<?
/****************************************************************************
 * Gestion des fichier :
 * - Dcoupage d'un nom de fichier en rpertoire, nom, extension
 * - 
 ****************************************************************************
 * Victor STINNER - 31 Juillet 2003 - victor.stinner@haypocalc.com
 ***************************************************************************/

// Dcoupe un nom de fichier
// Renvoie un tableau associatif :`
// "dir" => rpertoire
// "file" => fichier
// "ext" => extension du fichier (uniquement si le paramtre
// $extrait_extension=true)
function DecoupeNomFich ($nomfich, $extrait_extension=true)
{
  // Extrait le rpetoire
  $sep = "/\\\\";
  $regex  = "(file://)?";
  $regex .= "(([A-Za-z]:[$sep])?([^$sep]*[$sep])*)";
  $regex .= "(.*)";
  if (!ereg($regex, $nomfich,$regs)) Erreur ("Impossible de dcomposer le nom de fichier '$nomfich' !");
  $repertoire = $regs[1].$regs[2];
  $nomfich = $regs[5];

  if ($extrait_extension) {
    // Extrait l'extension
    $tab = explode('.', $nomfich);
    $extension = '.'.array_pop($tab);
    $nomfich = implode('.', $tab);
  } else {
    $extension = false;
  }

  // Renvoie le tout sous forme de tableau associatif
  $tab = Array(
  "dir" => $repertoire,
  "file" => $nomfich,
  "ext" => $extension
  );
  return $tab;
}

//---------------------------------------------------------------------------

// Nom d'un fichier avec son extension (supprime le rpertoire)
function MonBasename ($nomfich)
{
  $tab = DecoupeNomFich ($nomfich, false);
  return $tab["file"];
}

//---------------------------------------------------------------------------

// Extension d'un nom de fichier (avec son point en prfixe)
function ExtensionNomFich ($nomfich)
{
  $tab = DecoupeNomFich($nomfich);
  return $tab["ext"];
}

//---------------------------------------------------------------------------

// Nom de fichier sans extension, ni rpertoire
function RacineNomFich ($nomfich)
{
  $tab = DecoupeNomFich($nomfich);
  return $tab["file"];
}

//---------------------------------------------------------------------------

// Nom de fichier avec extension, mais sans rpertoire
function NomFichSansRep ($nomfich)
{
  $tab = DecoupeNomFich($nomfich, false);
  return $tab["file"];
}

//---------------------------------------------------------------------------

// Nom de fichier avec rpertoire, mais sans extension
function NomFichSansExt ($nomfich)
{
  $tab = DecoupeNomFich($nomfich, true);
  return $tab["dir"] . $tab["file"];
}

//---------------------------------------------------------------------------

// Taille d'un fichier en Ko (arrondi  l'entier le plus proche)
// Attention, 1 Ko = 1024 octets !
function TailleFichierKo ($nomfich)
{
  return round(filesize($nomfich) / 1024);
}

//---------------------------------------------------------------------------
?>