<?php 
//-----------------------------------------------------------------------------

set_time_limit(5);

$archive_castor = 'castor-data.tar.gz';
$htaccess = './.htaccess';
$htpasswd = './.htpasswd';
$rep_imagedb = './imagedb';
$rep_cms = './cms_data';
$config_php = 'inc/config.php';
$template_dir = './templates';
$dump_sql = 'setup.sql';
if (file_exists($config_php)) require_once ($config_php);

require_once('setup.inc');

$champs = Array
(
 // Format : <nom HTML/variable PHP> => Array(<description>, 
 //            <type input>, <valeur non nulle obligatoire>,<valeur>)
 'theme_css_defaut' => Array('Feuille de style CSS par dfaut','text',true),
 'page_defaut' => Array('Page par dfaut','text',true),
 'db_server' => Array('Serveur MySQL','text',true),
 'db_user' => Array('Utilisateur MySQL','text',true),
 'db_pass' => Array('Mot de passe MySQL','password',false),
 'db_database' => Array('Base MySQL','text',true),
 'url_prefix' => Array('Prfixe des url (adresse http de base)','text',true),
 'url_base' => Array('Url de base (par rapport  votre "DocumentRoot" sur le serveur)','text',true),
 'file_base' => Array('Chemin physique vers la racine du site','text',true),
 );

$valeurs = Array();

$valeurs_defaut = Array
(
 'theme_css_defaut' => 'bleu',
 'page_defaut' =>  'index',
 'db_server' =>  'localhost',
 'db_user' => 'root',
 'db_pass' => '',
 'url_prefix' => 'http://www.2le.fr/castor/');

$real = realpath ('./');
$txt = '^'.$_SERVER['DOCUMENT_ROOT'];
$txt = ereg_replace ($txt,'',$real);
$valeurs_defaut['url_base'] = 
  '/'.$txt.'/';
$valeurs_defaut['file_base'] = $real.'/';

$menu = Array
(
 // Format : Array(<libell>, <visible>)
 Array('Dcompression (et renomme index.php en setup.php)',true),
 Array('Tests des droits des rpertoires', true),
 Array('Configuration de base (css, sql, fichier, etc.)', true),
 Array('Enregistrement des paramtres MySQL', false),
 Array('Test de connexion MySQL', true),
 Array('Cration des tables MySQL', true),
 Array('Test ImageMagick', true),
 Array('Cration du fichier .htpasswd', true),
 Array('Cration du fichier .htaccess', true)
 );
$etape_sauve_param_mysql = 3;
$etape_decompression = 0;

//-----------------------------------------------------------------------------

foreach ($champs as $name => $val) {
    if (HtmlLitVar($name)) {
        $valeurs[$name] = HtmlLitVar($name);
    } else if (isset($$name))  {
        $valeurs[$name] = $$name;
    } else {
        $valeurs[$name] = $valeurs_defaut[$name];
    }
}

if (HtmlLitVar('etape')!==false)
$etape = HtmlLitVar('etape');
else
$etape = 'menu';

$titre_page = 'Installation de Castor';
if ($etape!='menu') $titre_page .= ' - Etape '.$etape;

echo '<?'.'xml version="1.0" encoding="ISO-8859-1"?>'."\n"; 

//-----------------------------------------------------------------------------
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title><?php echo $titre_page; ?></title>
<link rel="stylesheet" media="screen" href="setup.css" />
</head>
<body>
<?php
//-----------------------------------------------------------------------------

echo '<h1>'.$titre_page.'</h1>'."\n";
echo '<h2>'.$menu[$etape][0].'</h2>'."\n";

//-----------------------------------------------------------------------------

function formulaire_mysql($champs,$valeurs,$etape) {
    echo '<form action="setup.php" method="POST">'."\n";
    echo '  <input type="hidden" name="etape" value="'.$etape.'" />'."\n";
    foreach ($champs as $name => $val) {
        echo '  <p>'.$val[0].' : <input size="40" type="'
            .$val[1].'" name="'
            .$name.'" value="'
            .$valeurs[$name].'" /></p>'."\n";
    }
    echo '  <p class="centre"><input type="submit" value="Valider" /></p>'."\n";
    echo '</form>'."\n";
    return true;
}

//-----------------------------------------------------------------------------

function sauve_param_mysql($config_php, $champs) {
    $ok = true;
    foreach ($champs as $name => $val) {
        if ($val[2]) $ok &= EntreeValide($_POST[$name], $val[0]);
    }
    if ($ok) 
        $ok = SauveEntree($config_php, $champs, $_POST);
    if ($ok) {
        echo '<p>Paramtres enregistrs.</p>'."\n";
        $affiche_form = false;
    }
    return $ok;
}

//-----------------------------------------------------------------------------

function connexion_mysql($verbose=true) {
    global $db_server,$db_user,$db_pass,$db_database;

    if (($ok = @mysql_connect ($db_server, $db_user, $db_pass)) === false) {
        if ($verbose) erreur_setup(
            'Erreur lors de la connexion au serveur <em>'.$db_server.
            '</em> pour l\'utilisateur <em>'.$db_user.'</em> !');
        return false;
    }

    if (!@mysql_select_db ($db_database)) {
        if ($verbose) erreur_setup (
            'La base MySQL <em>'.$db_database.'</em> ne semble pas exister ! '.
            'Ou bien les autres paramtres sont incorrects ?');
        return false;
    }
    return true;
}

//-----------------------------------------------------------------------------

function test_connexion_sql($verbose=true) {
    if (!connexion_mysql($verbose)) return false;

    if ($verbose) echo '<p>Connexion MySQL russie !</p>';
    return true;
}

//-----------------------------------------------------------------------------

function appliqueDump($sql_file) {
    if (!file_exists($sql_file)) {
        erreur_setup ('Impossible de trouver le dump SQL <em>'.$sql_file.'</em> !');
        return false;
    }

    set_time_limit(30);

    $sql = implode(file($sql_file),'');
    $pieces       = array();
    if (!PMA_splitSqlFile($pieces, $sql, LitVersionMySQL())) {
        erreur_setup ('Erreur lors de la reconnaissance des requtes SQL');
        return false;
    }

    foreach ($pieces as $query) {
        $r=mysql_query ($query);
        if ($r === false) {
            erreur_setup
                ('La requte SQL suivante a chou :<br />'
                 .htmlspecialchars($query));
        }
    }

    echo '<p>Dump MySQL appliqu (<em>'
            .count($pieces).' requtes appliques</em>) !</p>';
    return true;
}

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

function installe_sql($dump_sql) {
    if (!connexion_mysql()) return false;
    $sql = 'SELECT COUNT(*) FROM fw_modules';
    $r = mysql_query($sql);
    if ($r !== false) {
        echo '<p>Les tables SQL semblent dj avoir t cres.</p>';
        return true;
    }
    if (!appliqueDump($dump_sql)) return false;
    return true;
}

//-----------------------------------------------------------------------------

// Crypte un mot de passe en utilisant le programme htpasswd 
function htpasswd($user='admin', $pass, $method='-m') {
    $cmd  = 'htpasswd -nb '.$method.' ';
    $cmd .= escapeshellarg($user).' ';
    $cmd .= escapeshellarg($pass);
    $r = execute($cmd,'la gnration d\'un mot de passe Apache !');
    if ($r['exit_code'] != 0) return false;
    return trim($r['content']);
}

//-----------------------------------------------------------------------------

function cree_htpasswd($etape, $htpasswd) {
    $user = 'admin';
    $password = HtmlLitVar('password');
    if ($password !== false) {
        $password = trim($password);
        if ($password=='') {
            erreur_setup ('Pas de mot de passe vide ... quand mme ...');
            $password = false;
        }
    }
    $recree = ($password !== false);
    $affiche = false;
    $ok = false;

    if ($recree) {
        $f = @fopen($htpasswd, 'w');
        if (!$f) {
            erreur_setup ('Impossible de crer le fichier <em>'.$htpasswd.'</em> !');
            return false;
        }

        $password = htpasswd($user, $password);
        fputs ($f, $password."\n");
        fclose ($f);

        echo '<p>Le fichier <em>'.$htpasswd.'</em> a t cre avec succs ! '
            .'Contenu du fichier :</p>'."\n";
        $affiche = true;
        $ok = true;
    } else if (file_exists($htpasswd)) {
        echo '<p>Le fichier <em>'.$htpasswd
            .'</em> existait dj, contenu :</p>'."\n";
        $affiche = true;
        $ok = true;
    }

    if ($affiche) echo '<pre>'.htmlspecialchars(implode(file($htpasswd),'')).'</pre>';
?>
        <div class="formulaire">
        <p>Vous pouvez craser le fichier <?php echo $htpasswd; ?> et cre un nouveau compte pour
        l'utilisateur <em><?php echo $user; ?></em> :</p>
        <form action="setup.php" method="POST">
        <input type="hidden" name="etape" value="<?php echo $etape; ?>" />
        
        <p>Mot de passe :
        <input name="password" type="password" value="" /></p>

        <input type="submit" value="Crer" />
        </form>

        </div>

        <p>Notez bien ce couple identifiant/mot de passe, il vous sera 
        demand  la fin de l'installation !</p>
<?php
    return $ok;
}

//-----------------------------------------------------------------------------

function cree_htaccess($etape, $htaccess) {
    $rewrite_base = trim(HtmlLitVar('rewrite_base'));
    $file_base = trim(HtmlLitVar('file_base'));
    $recree = $rewrite_base && $file_base;
    $ok = false;

    if ($rewrite_base == '') {
        // Tente de retrouver l'ancien RewriteBase dans .htaccess
        $f = @fopen($htaccess,'r');
        if ($f) {
            $recree = false;
            $rewrite_base = false;
            $x = '';
            while (!feof($f)) {
                $txt = fgets($f, 500);
                $x .= $txt;
                $txt = trim($txt);
                if (ereg('^RewriteBase (.*)$', $txt, $regs)) {
                    $rewrite_base = trim($regs[1]);
                } else if (ereg('^AuthUserFile (.*).htpasswd$', $txt, $regs)) {
                    $file_base = trim($regs[1]);
                }
            }
            if (!$rewrite_base) echo "<pre>$x</pre>";
            fclose ($f);
        }

        // Pas de .htaccess, ou impossible de l'isoler :
        // Lit le rpertoire racine du site
        if (!$rewrite_base) $rewrite_base = $GLOBALS['url_base'];
        if (!$file_base) $file_base = $GLOBALS['file_base'];
    }

    if ($recree) {
        $f = @fopen($htaccess, 'w');
        if (!$f) {
            erreur_setup ('Impossible de crer le fichier <em>'.$htaccess.'</em> !');
            return false;
        }

        fputs ($f, "RewriteEngine on\n");
        fputs ($f, 'RewriteBase '.$rewrite_base."\n");
        fputs ($f, 'RewriteRule ^([^/]+)\.html$ index.php?page=$1 [L,QSA]'."\n");
        fputs ($f, "\n");
        fputs ($f, "# URL /cms/manager.html\n");
        fputs ($f, "RewriteRule ^cms/(manager)\.html$ index.php?page=cms_manager&url_page=$1 [L,QSA]\n");
        fputs ($f, "\n");
        fputs ($f, "# URL /cms/<section>/manager.html\n");
        fputs ($f, "RewriteRule ^cms/([^/]+)/(manager)\.html$ index.php?page=cms_manager&section=$1&url_page=$2 [L,QSA]\n");
        fputs ($f, "\n");
        fputs ($f, "# URL /cms/<section>/<document>/\n");
        fputs ($f, "RewriteRule ^cms/([^/]+)/$ index.php?page=cms_display&section=$1 [L,QSA]\n");
        fputs ($f, "\n");
        fputs ($f, "# URL /cms/<section>/<document>/version<ver>.html\n");
        fputs ($f, "RewriteRule ^cms/([^/]+)/([^.]+)/(version([0-9]+))\.html$ index.php?page=cms_display_obj&section=$1&document_url=$2&version=$4&url_page=$3 [L,QSA]\n");
        fputs ($f, "\n");
        fputs ($f, "# URL /cms/<section>/<document>/historic.html\n");
        fputs ($f, "RewriteRule ^cms/([^/]+)/([^.]+)/(historic)\.html$ index.php?page=cms_manager&action=historic&section=$1&document_url=$2&url_page=$3 [L,QSA]\n");
        fputs ($f, "\n");
        fputs ($f, 'ErrorDocument 401 '.$rewrite_base.'index.php'."\n");
        fputs ($f, 'ErrorDocument 404 '.$rewrite_base.'index.php'."\n");
        fputs ($f, "\n");
        fputs ($f, 'AuthName "Administration de Castor"'."\n");
        fputs ($f, 'AuthUserFile '.$file_base.'.htpasswd'."\n");
        fputs ($f, 'AuthGroupFile /dev/null'."\n");
        fputs ($f, 'AuthType Basic'."\n");
        fputs ($f, "\n");
        fputs ($f, '<Files "setup.*">'."\n");
        fputs ($f, '  <Limit GET POST>'."\n");
        fputs ($f, '    require user admin'."\n");
        fputs ($f, '  </Limit>'."\n");
        fputs ($f, '</Files>'."\n");
        fclose ($f);

        echo '<p>Le fichier <em>'.$htaccess.'</em> a t cre avec succs ! '
            .'Contenu du fichier :</p>'."\n";
        $affiche = true;
        $ok = true;
    } else if (file_exists($htaccess)) {
        echo '<p>Le fichier <em>'.$htaccess
            .'</em> existait dj, contenu :</p>'."\n";
        $affiche = true;
        $ok = true;
    }

    if ($affiche)
        echo '<pre>'.htmlspecialchars(implode(file($htaccess),'')).'</pre>';
?>
        <div class="formulaire">
        <p>Si le rpertoire RewriteBase n'est pas bon, vous pouvez le corriger :</p>
        <form action="setup.php" method="POST">
        <input type="hidden" name="etape" value="<?php echo $etape; ?>" />
        
        <p>Rewrite base :
        <input name="rewrite_base" type="text" value="<?php echo $rewrite_base; ?>" />
        (pour RewriteBase ou ErrorDocument)</p>

        <p>Racine sur le disque dur :
        <input name="file_base" type="text" value="<?php echo $file_base; ?>" />
        (pour AuthUserFile)</p>
        
        <input type="submit" value="Enregister / corriger" />
        </form>

        </div>
<?php
    return $ok;
}

//-----------------------------------------------------------------------------

function affiche_menu($menu, $suivantphp) {
    echo '<p>Si Castor, n\'est pas encore install, dbutez par l\'tape 1 !</p>'."\n";

    echo '<ul>'."\n";
    $i = 0;
    foreach ($menu as $item) {
        echo '  <li>';
        $lien = $item[1];
        if ($lien) echo '<a href="'.$suivantphp.'?etape='.$i.'">';
        echo 'Etape '.$i;
        if ($lien) echo '</a>';
        echo ' - '.$item[0]."</li>\n";
        ++$i;
    }
    echo '</ul>'."\n";
?>
        <p>Consultez galement les fichiers suivants :</p>
        <ul>
        <li><a href="README">README</a> : Prsentation de Castor</li>
        <li><a href="INSTALL">INSTALL</a> : Guide d'installation</li>
        <li><a href="AUTHORS">AUTHORS</a> : Liste des auteurs de Castor</li>
        </ul>

        <p>Et n'oubliez de consulter rgulirement le 
        <a href="http://www.2le.net/castor/">site Internet de Castor</a>.</p>
<?php
        return true;
}

//-----------------------------------------------------------------------------

function chmod_recursif($dir, $dir_mode, $file_mode) {

    $dir = ereg_replace ('/$','',$dir);

    if (!@chmod($subdir, $dir_mode)) {
        erreur_setup('Erreur : impossible de changer les droits du rpertoire "<em>'
                .$dir.'</em>" (mode='.sprintf('0%o',$dir_mode).') !');
        return false;
    }

    $d = @opendir($dir);
    if (!$d) {
        erreur_setup('Erreurs lors de l\'ouverture du rpertoire "<em>'
                .$dir.'</em>" !');
        return false;
    }

    while (($f=readdir($d)) !== false) {
        echo $f.'<br>';
        if (ereg('\.\.?', $f)) continue;
        if (is_dir($f)) {
            $subdir = $dir.'/'.$f;
            echo 'Corrige '.$dir.'<br>';
            if (!@chmod($subdir, $dir_mode)) {
                erreur_setup('Erreur : impossible de changer les droits du rpertoire "<em>'
                        .$dir.'</em>" (mode='.sprintf('0%o',$dir_mode).') !');
                return false;
            }
            if (!chmod_recursif($subdir,$dir_mode,$file_mode)) { closedir($d); return false; }
        } else {
            echo 'Corrige '.$f.'<br>';
            if (!@chmod($f, $file_mode)) {
                erreur_setup('Erreur : impossible de changer les droits du fichier "<em>'
                        .$f.'</em>" (mode='.sprintf('0%o',$file_mode).') !');
            }     
        }
    }
    closedir($d);
    return true;
}

//-----------------------------------------------------------------------------

function cree_repertoire($repertoire)
{
    if (!file_exists($repertoire)) {
        if (!@mkdir($repertoire,0775)) {
            erreur_setup ('Erreur lors de la cration du rpetoire <em>'.
                    $repertoire.'</em> (utilis pour le module imagedb). '.
                    'Cette erreur peut tre ignore');
        } else {
            echo '<p>Cration du rpertoire <em>'.$repertoire.'</em>.';
        }
    } else {
        if (!check_dir_mode($repertoire, 'rw-')) {
            erreur_setup(
                    'Les droits du rpertoire <em>'.
                    $repertoire.'</em> sont incorrects '.
                    '(il faut criture plus lecture) !');
            echo '<p>Cette erreur peut-tre ignore si vous n\'utilisez pas ImageDB</p>'."\n";
        } else {
            echo '<p>Les droits du rpertoire <em>'.$repertoire.'</em> sont corrects.</p>'."\n";
        }
    }
}

//-----------------------------------------------------------------------------

function tests_generaux($template_dir,$rep_imagedb, $rep_cms) {
    if (!check_dir_mode($template_dir, 'rw-')) {
        erreur_setup(
                'Les droits du rpertoire <em>'.
                $template_dir.'</em> sont incorrects '.
                '(il faut criture plus lecture) !');
        return false;
    }

    echo '<p>Les droits du rpertoire <em>'.$template_dir.'</em> sont corrects.</p>'."\n";

    cree_repertoire($rep_imagedb);
    cree_repertoire($rep_cms);
    return true;
}

//-----------------------------------------------------------------------------

function test_imagemagick_identify() {
    $cmd = '/usr/bin/identify';
    $r = execute (
        $cmd,
        'la dtection de ImageMagick : il ne semble pas tre install !',
        $txt);
    if ($r['exit_code'] != 0) return false;

    $out = trim($out);
    echo '<p>ImageMagick est install. Version :</p>'."\n";
    echo '<pre>'.htmlspecialchars($r['content']).'</pre>'."\n";

    return true;
}

//-----------------------------------------------------------------------------

function test_imagemagick($etape) {
    if (test_imagemagick_identify()) return true;

    echo '<p>Vous pouvez ignorer cette tape, mais le module imagedb '
        .'ne fonctionnera pas correctement. Sinon, '
        .'<a href="?etape='.$etape.'">retentez cette tape</a>.</p>'
        ."\n";

    return true;
}

//-----------------------------------------------------------------------------
 
function untar($file) {
    $cmd = 'tar xvzf '.escapeshellarg($file);
    $txt  = "Assurez vous d'avoir autoris PHP  crire dans ";
    $txt .= "le rpertoire <em>".getcwd()."</em>";
    $r = execute (
        $cmd,
        'la dcompression !',
        $txt);
    return $r['exit_code'] == 0;
}

//-----------------------------------------------------------------------------

function decompression_ok() {
    $test = './modules';
    return file_exists($test);
}

//-----------------------------------------------------------------------------

function nom_script_php() {
    if (file_exists('setup.php')) return 'setup.php';
    return 'index.php';
}

//-----------------------------------------------------------------------------

function decompression($archive_castor) {
    if (decompression_ok()) {
        echo '<p>La dcompression a dj t effectue : rpertoire <em>'.
            './modules</em> dj existant</p>';
        return true;
    }

    if (!rename('index.php','setup.php')) {
        erreur_setup('ERREUR CRITIQUE : Impossible de renommer index.php en setup.php !');
        return false;
    }

    if (!untar($archive_castor)) return false;
    if (!@unlink($archive_castor)) {
        erreur_setup('Erreur lors de la suppression du fichier "'
            .$archive_castor.'" !');
    } else {
        message_setup ('Le fichier "'.$archive_castor.'" a t supprim');
    }

    echo "<p>Dcompression russie !</p>";
    return true;
}

//-----------------------------------------------------------------------------

function installation_terminee($config_php, $htaccess) {
    if (!decompression_ok()) return false;
    if (!test_connexion_sql(false)) return false;
    if (!file_exists($htaccess)) return false;
    if (!file_exists($config_php)) return false;
    return true;
}

//-----------------------------------------------------------------------------

$scriptphp = nom_script_php();

$ok = false;
switch ($etape) {
    case 'menu':
    default:
        $ok = affiche_menu($menu, $scriptphp);
        break;
    case 0:
        $ok = decompression($archive_castor);
        $scriptphp = nom_script_php();
        break;
    case 1:
        $ok = tests_generaux($template_dir, $rep_imagedb, $rep_cms);
        break;
    case 2:
    case 3:
        if (1<=count($_POST)) {
            $ok = sauve_param_mysql($config_php, $champs);
        } else {
            $ok = formulaire_mysql($champs,$valeurs,$etape+1);
        }
        break;
    case 4:
        $ok = test_connexion_sql(true);
        break;
    case 5:
        $ok = installe_sql($dump_sql);
        break;
    case 6:
        $ok = test_imagemagick($etape);
        break;
    case 7:
        $ok = cree_htpasswd($etape, $htpasswd);
        break;
    case 8:
        $ok = cree_htaccess($etape, $htaccess);
        break;
}

if ($ok) {
    $n = $etape+1;
    if ($menu[$n][1] || ($n == count($menu))) {
        echo '<p class="lien_defaut">';
        if ($n < count($menu)) {
            echo '<a href="'.$scriptphp.'?etape='.$n.'">Passer  l\'tape '.$n.' : ';
            echo $menu[$n][0].'</a>';
        } else { 
            echo '<a href="index.php">Vous pouvez maintenant ouvrir Castor</a> ;-)';
        }
        echo '</p>'."\n";
    }
} else {
    switch ($etape) {
        default:
            echo '<p class="lien_defaut"><a href="'.$scriptphp.'?etape='.$etape.'">'
                .'Voulez-vous retenter cette tape ?</a></p>'."\n";
            break;
        case $etape_sauve_param_mysql:
            formulaire_mysql($champs,$valeurs,$etape); 
            break;
    }
}

if ($etape != 'menu') {
    echo '<p class="centre"><a href="'.$scriptphp.'?etape=menu">Retour au menu</a>';
    if (installation_terminee($config_php, $htaccess)) echo '- <a href="./">Tester Castor</a>';
    echo '</p>'."\n";
}

?>

</body>
</html>
