<?php
class cms_article extends cms_object {
    var $title;
    var $subtitle;
    var $text;

    var $detail_xtpl;
    var $pdf_xtpl;    
    
    function cms_article($mode,$arg=false) {
        $this->sql_data_table = 'cms_article';
        $this->form_xtpl = 'form_article.xtpl';
        $this->detail_xtpl = 'detail_article.xtpl';
        $this->pdf_xtpl = 'pdf_article.xtpl';
        $this->fields = Array('title','subtitle','text');
        cms_object::cms_object($mode,$arg);
    }

    function download() {
        global $cms_common;
        $name = $this->document->url.'.pdf';
        $author = $this->document->author;
        
        $xtpl = new XTemplate('./templates/F/cms_manager/'.$this->pdf_xtpl);
        
        $xtpl->assign('modid', $cms_common->modid);
        $xtpl->assign('first_name', $author->first_name);        
        $xtpl->assign('name', $author->name);                
        $xtpl->assign('date', FormateTimestampDate( $this->date ) );                        
        $xtpl->assign($this->get_fields_values());
        
        $xtpl->parse('detail');
        
        GenerePDF( $xtpl->text('detail'), $name, $orientation = "portrait");
    }

    //********************** PRIVATE *******************************

    function read_data_from_form() {
        global $cms_common;
        foreach ($this->fields as $field) {
            $this->$field = $cms_common->read_html_form($field);
        }
    }

    function out_detail() {
        global $cms_common;

        $author = $this->document->author;
        
        $xtpl = new XTemplate('./templates/F/cms_manager/'.$this->detail_xtpl);
        
        $xtpl->assign('modid', $cms_common->modid);
        $xtpl->assign('first_name', $author->first_name);        
        $xtpl->assign('name', $author->name);                
        $xtpl->assign('date', FormateTimestampDate( $this->date ) );                        
        $xtpl->assign($this->get_fields_values('attribut'));
        
        $xtpl->parse('detail');
        
        return $xtpl->text('detail');
    }

    function out_list() {
        $lg_max = 80;
        $larg = 25;

        $txt = $this->subtitle;
        $txt = str_replace ("\r", " ", $txt);
        $txt = str_replace ("\n", " ", $txt);
        $txt = ereg_replace (' +', ' ', $txt);
        
        $lg = strlen($txt);
        if ($lg_max<$lg) {
            $txt = substr($txt,0,$lg_max);
            $sep = '?!);:,. -';
            $txt = ereg_replace ('^(.+)['.$sep.'][^'.$sep.']*$', '\1', $txt);
            $txt .= '(...)';
        }
        $txt = wordwrap($txt, $larg, "\n", 1);
        $txt = htmlspecialchars($txt);
        $out  = '<pre>';
        $out .= $txt;
        $out .= '</pre>';
        return $out;
    }

    function full_text() {
        return $this->title . ' ' . $this->subtitle . ' ' . $this->text;
   }
}
?>
