<?php

/*
 * File object for Castor CMS.
 */

//-----------------------------------------------------------------------------

function cms_evt_remove_file(&$object)
{
    // Si le fichier est encore utilis plus d'une fois
    // ne le supprime pas
    $n = q_read_field(
        'COUNT(no)',
        $object->sql_data_table,
        Array('realname' => $object->realname));
    if (1<$n) return;

    $name  = $object->document->document_type->directory;
    $name .= '/'.$object->realname;
    if ($GLOBALS['cms_common']->verbose) Message ("Supprime le fichier $name");
    unlink($name);
}

//-----------------------------------------------------------------------------

function cms_upload_file(&$object, $file)
{
    $info = cms_upload($object, $file, true);
    if (!$info) return false;
    if ($object -> title=='')
        $object -> title = $info['filename'];
    $object -> filename = $info['filename'];
    $object -> realname = $info['realname'];
    $object -> size = filesize($info['dest']);

    $mime = mime_get_file_mime($info['dest'], $info['filename']);
    $object -> mime = $mime['text'];
    
    $object -> type = mime_identify_file($info['dest'], $info['filename']);
    if ($object -> type === false) $object->type='file';
    return true;
}

//-----------------------------------------------------------------------------

function cms_evt_insert_file(&$object)
{
    $file = cms_upload_get_file('new_file');
    if (!$file) {
        if ($object->mode!='new_document') return true;
        Erreur('Erreur, aucun fichier n\'a t saisie !');
        return false;
    }
    return cms_upload_file(&$object, $file);
}

//-----------------------------------------------------------------------------

function cms_evt_update_file(&$object)
{
    $file = cms_upload_get_file('new_file');
    if (!$file) return true;
    cms_evt_remove_file($object);
    return cms_upload_file($object, $file);
}

//-----------------------------------------------------------------------------

class cms_file extends cms_object 
{
    var $type;
    var $title;
    var $text;
    var $size;
    var $filename;
    var $realname;
    var $mime;
    
    function cms_file($mode,$arg=false) {
        $this->sql_data_table='cms_file';
        $this->form_xtpl = 'form_file.xtpl';
        $this->fields = Array('type', 'title','text','size','filename','realname','mime');
        cms_object::cms_object($mode,$arg);
    }

    function download() {
        $file = $this->document->document_type->directory.'/'.$this->realname;
        cms_download($file, $this->filename);
    }

    function view() {
        $file = $this->document->document_type->directory.'/'.$this->realname;
        cms_view($file, $this->filename, $this->mime);
    }

    function get_icon() {
        $type = $this->document->document_type;
        return $GLOBALS['url_root'].'/images/mime/'.$this->type.'.png';
    }

    function get_icon_alt() {
        return 'Fichier de type '.$this->mime; 
    }

    //******************** PRIVATE ***************************

    function out_detail() {
        $url  = $GLOBALS['url_prefix'].'cms/';
        $url .= $this->document->section.'/';
        $url .= $this->document->url.'/version';
        $url .= $this->version.'.html?download=1';

        $status  = 'Tlcharger '.$this->filename;
        $status .= ' ('.$this->filesize().')';

        $on  = ' onmouseover="window.status=\'';
        $on .= htmlspecialchars($status,ENT_QUOTES);
        $on .= '\'; return true;" ';
        $on .= ' onmouseout="window.status=\'\';"';

        $img  = '<img src="'.$GLOBALS['url_root'].'/images/mime/';
        $img .= $this->type.'.png"';
        $img .= ' style="padding-right: 1ex; vertical-align: middle;"';
        $img .= ' alt="Tlcharger" />';

        $txt  = '<a title="'.htmlspecialchars($this->text,ENT_QUOTES).'"';
        $txt .= $on;
        $txt .= ' href="'.$url.'">';
        $txt .= $img;
        $txt .= htmlspecialchars($this->title).'</a>';
        $txt .= ' ('.$this->filesize().')';
        return $txt;
    }

    function out_list() {
        return htmlspecialchars($this->title);
    }

    function read_data_from_form() {
        global $cms_common;
        foreach ($this->fields as $field) {
            $this->$field = $cms_common->read_html_form($field);
        }
    }

    function filesize() {
        $ko=1024;
        $mo=$ko*1024;
        $go=$mo*1024;
        if ($this->size>$go) return sprintf("%.1f", $this->size/$go)." Go";
        if ($this->size>$mo) return sprintf("%.1f", $this->size/$mo)." Mo";
        if ($this->size>$ko) return sprintf("%.1f", $this->size/$ko)." Ko";
        return $this->size." octets";
    }
    
    function full_text() {
        if ($this->filename == $this->title)
            $txt = NomfichSansExt($this->filename);
        else
            $txt = $this->title;
        $txt .= ' ';
        $txt .= $this->text;
        return $txt;
    }
}

//-----------------------------------------------------------------------------
?>
