<?php
//----------------------------------------------------------------------------

// Create a cms_manager (global var) if no one does exist
function cms_create_manager() {
    global $cms_manager;
    if (gettype($cms_manager)=='object') return;
    $cms_manager = new cms_manager();
}

//----------------------------------------------------------------------------

class cms_manager
{
    var $section;

    function cms_manager()
    {
        $this->section = $_REQUEST['section'];
    }

    function save_document() {
        global $cms_common;

        if(!$cms_common->can_edit_document()) 
        {
            Erreur('Vous n\'avez pas le droit de modifier un document !');
            return;
        }
        
        $document_no = $this->read_html_form('document_no');
        $document =& $cms_common->get_document($document_no,'update');
        $document->save();
    }

    function remove_document($event) {
        global $cms_common;

        if(!$cms_common->can_remove_document()) 
        {
            Erreur('Vous n\'avez pas le droit de supprimer un document !');
            return;
        }
        
        $no = $this->read_html_form('document_no');
        $document =& $cms_common->get_document($no);

        // Call event ?
        if ($event) $event($document);

        // Remove the document
        $document->remove();
    }

    function confirm_remove_version() {
        global $cms_common;
        $version_no = $this->read_html_form('version_no');
        $obj = $cms_common->get_object($version_no,'load',false);
        
        $xtpl = new XTemplate('./templates/F/cms_manager/confirm_remove_version.xtpl');
        $xtpl -> assign('no', $obj->version_no);
        $xtpl -> assign('title', $obj->document->title);
        $xtpl -> assign('version', $obj->version);
        $xtpl -> assign('preview', $obj->out('list'));
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function confirm_remove_document() {
        global $cms_common;
        $no = $this->read_html_form('document_no');
        $doc =& $cms_common->get_document($no);
        $obj_no = $doc->find_last_version();
        $obj =& $cms_common->get_object($obj_no);
        
        $xtpl = new XTemplate('./templates/F/cms_manager/confirm_remove_document.xtpl');
        $xtpl -> assign('no', $doc->no);
        $xtpl -> assign('title', $doc->title);
        $xtpl -> assign('preview', $obj->out('list'));
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function edit_new_document() {
        global $cms_common;
        
        $doc =& $cms_common->get_new_document();
        $class = $doc->document_type->php_module;
        $module = new $class('new_document', &$doc);
        $form_content = $module->out('form');

        $f = $cms_common->sql_field['section'];
        $row = q_read_row(
            Array($f['min_rights'], $f['max_rights']),
            $cms_common->sql_table['section'],
            Array($f['id'] => $this->section));
    
        $xtpl = new XTemplate('./templates/F/cms_manager/new_document.xtpl');
        $xtpl -> assign('document_title', $doc->title);
        $xtpl -> assign('document_author', $doc->author->no);
        $xtpl -> assign('document_lang', $doc->lang);
        $xtpl -> assign('document_type', $doc->document_type->no);
        $xtpl -> assign('section', $this->section);
        $xtpl -> assign('form_content', $form_content);
        $xtpl -> assign('min_rights', $row[0]);
        $xtpl -> assign('max_rights', $row[1]);
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function historic() {
        global $cms_common;
  
        if(!$cms_common->can_access_archive()) 
        {
            Erreur('Vous n\'avez pas accs aux archives !');
            return;
        }
 
        $document_url = $this->read_html_form('document_url');

        $td = $cms_common->sql_table['document'];
        $tv = $cms_common->sql_table['version'];
        $join = Array(Array(
            'table'=>$td,
            $td.'.no'=>$tv.'.document'));
        $sql = $cms_common->search_object(
            false,
            Array($td.'.url'=>$document_url),
            $tv.'.version',
            $join);

        $pub_version = -1;
        $nb_obj = q_num_rows($sql); 
        if ($nb_obj != 0) {
            $document_no = q_read_field(
                'no',
                $cms_common->sql_table['document'],
                Array('url' => $document_url));
            $doc =& $cms_common->get_document($document_no);
            $pub = $cms_common->get_published_version($doc->no);
            if ($pub !== false) $pub_version = $pub['version'];
        }

        $xtpl = new XTemplate('./templates/F/cms_manager/historic.xtpl');
        $xtpl -> assign('document_no', $doc->no);
        $xtpl -> assign('document_title', $doc->title);
        $xtpl -> assign('document_author', $doc->author->no);
        $xtpl -> assign('document_lang', $doc->lang);
        $xtpl -> assign('document_type', $doc->document_type->no);
        $xtpl -> assign('section', $this->section);
        while ($row = q_fetch($sql)) {
            $version_no = $row[0];
            $obj =& $cms_common->get_object($version_no,'load',false);
            $xtpl -> assign('version_no', $obj->version_no);
            $xtpl -> assign('version', $obj->version);
            $xtpl -> assign('date', FormateTimestampDate($obj->date));
            $xtpl -> assign('html', $obj->out('list'));
            
            $xtpl->assign('state', $cms_common->get_object_state($obj, $pub_version));
           
            // Parse
            if (($pub_version != $obj->version) && $cms_common->can_publish())
                $xtpl->parse('main.version.publish');                
            if (($obj->version != $pub_version) && $cms_common->can_edit_version())
                $xtpl->parse('main.version.edit');                
            if (((1<$nb_obj) && ($obj->version != $pub_version))  && $cms_common->can_remove_version())
                $xtpl->parse('main.version.remove');
            $xtpl->parse('main.version');
        }
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function save_version($mode) {
        global $cms_common;

        if(!$cms_common->can_edit_version()) 
        {
            Erreur('Vous n\'avez pas le droit de modifier une version !');
            return;
        }

        $type = $this->read_html_form('document_type');
        $obj =& $cms_common->get_new_object($type, $mode);
        $obj->save();
        $cms_common->unregister_object($obj);
    }

    function save_new_document($event) {
        global $cms_common;
        
        if(!$cms_common->can_create_document()) 
        {
            Erreur('Vous n\'avez pas le droit de crer un nouveau document !');
            return;
        }

        $document =& $cms_common->get_new_document();
        $class = $document->document_type->php_module;
        $obj =& $cms_common->get_new_object(
            $document->document_type->no, 'new_document', &$document);
      
        // Save object and then document
        $ok = $obj -> save();
        if ($ok) $document -> save();

        // Call event ?
        if ($event) $event($document);

        // Remove document and object from the cache
        $cms_common->unregister_document($document);
        $cms_common->unregister_object($obj);
    }

    function unpublish() {
        global $cms_common;
        if(!$cms_common->can_publish()) 
        {
            Erreur('Vous n\'avez pas le droit de dpublier un document !');
            return;
        }
        $document_no = $this->read_html_form('document_no');
        q_delete(
            $cms_common->sql_table['publication'],
            Array('document_no' => $document_no));
    }
    
    function edit_document() {
        global $cms_common;
        $no = $this->read_html_form('document_no');
        $document =& $cms_common->get_document($no);
    
        $xtpl = new XTemplate('./templates/F/cms_manager/edit_document.xtpl');
        $xtpl->assign('no', $document -> no);
        $xtpl->assign('title', $document -> title);
        $xtpl->assign('lang', $document -> lang);
        $xtpl->assign('min_rights', $document -> min_rights);
        $xtpl->assign('max_rights', $document -> max_rights);

        $f = $cms_common->sql_field['section'];
        $r = q_select(
            Array($f['id'], $f['title']),
            $cms_common->sql_table['section'],
            false, // where
            false, // join
            false, // group
            $f['title'].' ASC');
         
        $sections = $cms_common->find_all_sections();
        foreach ($sections as $section) {
          $xtpl->assign('value', $section['id']);
          $xtpl->assign('text', $section['title']);
          if ($section['id'] == $document->section)
            $xtpl->assign('selected',' selected');
          else
            $xtpl->assign('selected','');
          $xtpl->parse('main.option_section');
        }

        $version_no = $document->find_last_version();
        $obj = $cms_common->get_object($version_no,'load',false);
        $xtpl->assign('last_version', $obj->out('list'));
        
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function publish() {
        global $cms_common;
        if(!$cms_common->can_publish()) 
        {
            Erreur('Vous n\'avez pas le droit de publier un document !');
            return;
        }
        
        $document_no = $this->read_html_form('document_no');
        $version_no = $this->read_html_form('version_no');
        
        $doc =& $cms_common->get_document($document_no);

        // Check if the document already have a published version
        $row = q_select(
            Array('no', 'version_no'),
            $cms_common->sql_table['publication'],
            Array('document_no' => $document_no));
        if (($row !== false) && (q_num_rows($row) != 0)) {
            $row = q_fetch_array($row);
            $pub_no = $row[0];
            $pub_version_no = $row[1];

            if ($pub_version_no == $version_no) {
                Erreur('Cette version du document est dj publie !');
                return;
            }
            q_update(
                $cms_common->sql_table['publication'],
                Array(
                    'version_no' => $version_no,
                    'section' => $doc->section),
                Array('no' => $pub_no));
        } else {
            q_insert(
                $cms_common->sql_table['publication'],
                Array(
                    'document_no' => $document_no,
                    'version_no' => $version_no,
                    'section' => $doc->section));
        }
    }

    function remove_version() {
        global $cms_common;

        if(!$cms_common->can_remove_version()) 
        {
            Erreur('Vous n\'avez pas le droit de supprimer une version d\'un document !');
            return;
        }
        
        $version_no = $this->read_html_form('version_no');
        $obj = $cms_common->get_object($version_no,'load',false);
        $obj->remove();
    }

    function edit_version($new) {
        global $cms_common;
        if ($new) {
            $document_no = $this->read_html_form('document_no');
            $document =& $cms_common->get_document($document_no);
            $version_no = $document->find_last_version();
            $action = 'save_new_version';
        } else {
            $version_no = $this->read_html_form('version_no');
            $action = 'save_version';
        }
        $version =& $cms_common->get_object($version_no,'load',false);
       
        $xtpl = new XTemplate('./templates/F/cms_manager/edit_version.xtpl');        
        $xtpl->assign('action', $action);
        $xtpl->assign('form_content', $version->out('form'));
        $xtpl->assign('doc_no', $version->document->no);
        $xtpl->assign('doc_nom', $version->document->nom);
        $xtpl->assign('type_no', $version->document->document_type->no);
        $xtpl->assign('doc_type', $version->document->document_type->title);
        if ($new)
            $xtpl->assign('version', 1+$version->version);
        else
            $xtpl->assign('version', $version->version);
        $xtpl->assign('version_no', $version->version_no);
        $xtpl->assign('data_no', $version->data_no);

        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function read_html_form($id) {
        $val = $_REQUEST[$id];
        $val = stripcslashes($val);
        return $val;
    }

    function display_all()
    {
        global $cms_common;
        $td = $cms_common->sql_table['document'];
        $ts = $cms_common->sql_table['section'];
        $fs = $cms_common->sql_field['section'];
                
        // Get section title
        $section_title = q_read_field(
            $fs['title'],
            $ts,
            Array($fs['id'] => $this->section));

        // Create XTemplate
        $xtpl = new XTemplate('./templates/F/cms_manager/rubrique.xtpl');

        // Section
        $xtpl->assign('section_title', $section_title);
        $xtpl->assign('section', $this->section);

        // Others
        $xtpl->assign('back_link', urlencode('../manager.html'));

        // Search all documents of the current section
        $join = Array();
        $join[] = Array(
                'table' => $ts,
                $ts.'.'.$fs['id'] => $td.'.section'
                );
        $r = q_select(
                $td.'.no',
                $td,
                Array($td.'.section'=>$this->section),
                $join);
        $empty = (q_num_rows($r)==0);
        while ($row=q_fetch($r)) {
            $parse = 'main.documents.document';
            $document_no = $row[0];

            // Load the document
            $doc =& $cms_common -> get_document($document_no);
            $nb_versions = $doc->count_version();

            // Find published version if existing
            $pub = $cms_common->get_published_version($doc->no);
            if ($pub !== false) {
                $pub_version = $pub['version'];
                $pub_version_no = $pub['version_no'];
            }

            // Find last version of the document
            $current_version_no = $doc->find_last_version();

            // Load object
            if ($pub && ($pub_version_no == $current_version_no)) {
                $pub =& $cms_common->get_object($pub_version_no,'load',false);
                $obj = false;
            } else {
                if ($pub) $pub =& $cms_common->get_object($pub_version_no);
                $obj =& $cms_common->get_object($current_version_no,'load',false);
            }

            // Assign document variables
            $xtpl->assign('document_no', $doc->no);
            $xtpl->assign('document_title', $doc->title);
            $xtpl->assign('document_url', $doc->url);
            $xtpl->assign('author', 
                    $doc->author->name.' '.
                    $doc->author->first_name
                    );
            $xtpl->assign('nb_versions', $nb_versions);
            if ($cms_common->can_edit_document())
                $xtpl->parse($parse.'.edit_document');
            if ($cms_common->can_access_archive())
                $xtpl->parse($parse.'.historic');
            if ($cms_common->can_remove_document())
                $xtpl->parse($parse.'.remove_document');

            $icon_obj = $obj?$obj:$pub;
            $image = $icon_obj->get_icon();
            $alt = $icon_obj->get_icon_alt(); 
            $xtpl->assign('document_type_image', $image);
            $xtpl->assign('document_type_image_alt', $alt);

            // Assign variables of the last version of the document
            if ($obj) {
                $xtpl->assign('no', $obj->version_no);
                $xtpl->assign('url', $obj->get_url());
                $xtpl->assign('version', $obj->version);
                $xtpl->assign('date', FormateTimestampDate($obj->date));
                $xtpl->assign('html_current', $obj->out('list'));
                $supprimer = $cms_common->can_remove_version() && (1 < $nb_versions);

                if ($supprimer) 
                    $xtpl->parse($parse.'.current_version.supprimer');
                if ($cms_common->can_publish()) 
                    $xtpl->parse($parse.'.current_version.publier');
                if ($cms_common->can_edit_version())
                    $xtpl->parse($parse.'.current_version.edit_version');
                $xtpl->parse($parse.'.current_version');
            } else {
                $xtpl->parse($parse.'.no_current');
            }

            if ($pub) {
                $xtpl->assign('pub_version', $pub->version);
                $xtpl->assign('pub_url', $pub->get_url());
                $xtpl->assign('pub_html', $pub->out('list'));
                if ($cms_common->can_publish()) 
                    $xtpl->parse($parse.'.depublier');
                $xtpl->parse($parse.'.pub_version');
            } else {
                $xtpl->assign('html_pub', '(aucune)');
                $xtpl->parse($parse.'.no_pub');
            }

            // Parse
            $xtpl->parse($parse);
        }
        if (!$empty) {
            $xtpl->parse('main.documents');
        } else {
            $xtpl->parse('main.empty_section');
        }

        if ($cms_common->can_create_document()) {
            $types = $cms_common->search_document_types();
            foreach ($types as $type) {
                $xtpl->assign('no', $type->no);
                $xtpl->assign('title', $type->title);
                $xtpl->assign('image', $type->image);
                $xtpl->parse('main.choose_document_type.type');
            }
            $xtpl->parse('main.choose_document_type');
        }

        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    function select_section() {
        global $cms_common;
        $xtpl = new XTemplate('./templates/F/cms_manager/select_section.xtpl');
        $sections = $cms_common->find_all_sections();
        foreach ($sections as $section) {
            $n = q_read_field(
                    'COUNT(no)',
                    $cms_common->sql_table['document'],
                    Array('section'=>$section['id']));
            
            $txt = (integer)$n.' document';
            if (1<$n) $txt .= 's';
            if ($n != 0) $txt = '<em>'.$txt.'</em>';

            $xtpl->assign('nb_documents', $txt);
            $xtpl->assign('id', $section['id']);
            $xtpl->assign('title', $section['title']);
            $xtpl->parse('main.section');
        }
        $xtpl->parse('main');
        return $xtpl->text('main');
    }
}

//----------------------------------------------------------------------------
?>
