<?php
/*
 * Outils pour le CMS.
 */

//-----------------------------------------------------------------------------

function cms_str2url($txt) {
    $txt = trim($txt);
    $txt = strtolower($txt);
    $txt = strtr($txt, 
        '"', 
        'aaaeeeiioouu');
    $txt = ereg_replace('[^a-z0-9]','_',$txt);
    return $txt;
}

//-----------------------------------------------------------------------------

function cms_str2keywords($txt) {
    // Tranforme les l'(...) et d'(...) en (...)
    $txt = ereg_replace ('(l|d)\'', '', $txt);

    // Transforme n'(...) en n(...)
    $txt = str_replace ('n\'', 'n', $txt);

    // Passe en minuscule
    $txt = strtolower($txt);

    // Transforme les accents et les ponctuations
    $txt = strtr($txt, 
        '.,;!?:-()[]/\\\'"', 
        'aaaeeeiioouu                 ');

    // Supprime les espaces en dbut et fin de chane
    $txt = trim($txt);
    
    // Ne conserve qu'un espace entre chaque mot
    $txt = ereg_replace (' +', ' ', $txt);
    return $txt;
}

//-----------------------------------------------------------------------------

function cms_download($file, $name) {
    if (!file_exists($file) || !is_file($file)) {
        ErreurFatale('Le fichier '.$file.' est introuvable !');
    }
    $size = filesize($file);
    $fd = fopen($file, "r");
    header("Content-Type: application/force-download");
    header('Content-Length: '.$size); 
    header('Content-Disposition: Attachment; filename="' . $name.'"');
    while (!feof($fd)) {
        $part = fread($fd, 8192);
        printf("%s",$part);
    }
    fclose($fd);
}

//-----------------------------------------------------------------------------

function cms_view($file, $name, $mime) {
    if (!file_exists($file) || !is_file($file)) {
        ErreurFatale('Le fichier '.$file.' est introuvable !');
    }
    $size = filesize($file);
    $fd = fopen($file, "r");
    header("Content-Type: ".$mime);
    header('Content-Length: '.$size); 
    header('Content-Disposition: inline; filename="'.$name.'"');
    while (!feof($fd)) {
        $part = fread($fd, 8192);
        printf("%s",$part);
    }
    fclose($fd);
}

//-----------------------------------------------------------------------------

// Get file to upload from HTML form where $html_id is the id in the form
function cms_upload_get_file($html_id)
{
    global $cms_common;
    if (!array_key_exists($html_id, $_FILES)) return false;
    $f = $_FILES[$html_id];
    if ($f['tmp_name']=='none') return false;
    return $f;
}

//-----------------------------------------------------------------------------

// Upload a file for CMS
// with $object           : the object (cms_file, cms_image, ...)
//      $file             : file info given from $_FILES[...]
//      $rewrite_filename : if true, use <doc>-<ver>.dat filename
function cms_upload($object, $file, $rewrite_filename) {
    global $cms_common;
    $id = $object->data_no;
    
    $dir = $object->document->document_type->directory;
    if( !is_dir($dir) ){ 
        if( mkdir( $dir ) ){
            chmod($dir, 0700);
        }
        else {
            Erreur("Impossible de crer le rpertoire " . $dir);
            return false;
        }
    }
    
    $filename = $file['name'];
    $src = $file['tmp_name'];
    if ($rewrite_filename)
        $realname = $object->document->no.'-'.$object->version_no.'.dat';
    else
        $realname = $filename;
    $dst = $dir.'/'.$realname;
    if ($GLOBALS['cms_common']->verbose) Message ('Upload '.$src.' to '.$dst);
    if (file_exists($dst)) {
        Erreur('Erreur, le fichier "'.$dst.'" existe dj !');
        return false;
    }
    move_uploaded_file($src,$dst);
    chmod($dst, 0400);
    return Array(
        'filename' => $filename, 
        'realname' => $realname, 
        'dest' => $dst);
}

//-----------------------------------------------------------------------------

function cms_user_have_role($role,$section)
{
    global $cms_common;
	$gid = $_SESSION["auth_gid"];
    $where  = "role='$role' ";
    $where .= "AND (section='$section' OR section =  '*' ) ";
    $where .= "AND gid='$gid'";
    $no = q_read_field(
        'no',
        $cms_common->sql_table['role'],
        $where);
    return ($no !== false);
}

//-----------------------------------------------------------------------------
?>
