<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * Gestion des diffrents types de champs pour la librairie 'rs'.
 *
 * Sbastien HEITZMANN
 * 2le@2le.net
 */

function toHumanSize($input) {

    $gigaSize = 1024 * 1024 * 1024;
    $megaSize = 1024 * 1024;
    $kiloSize = 1024;

    if ($input >= $gigaSize) return (round($input/$gigaSize,1)) . " Go";
    elseif ($input >= $megaSize) return (round($input/$megaSize,1)) . " Mo";
    elseif ($input >= $kiloSize) return (round($input/$kiloSize,0)) . " Ko";
    else return $input . " octet(s)";
}

function toHumanTime($input) {
    $dayTime = 60 * 60 * 24;
    $hourTime = 60 * 60;
    $minTime = 60;

    if ($input >= $dayTime) return (round($input/$dayTime,0)) . " j et " . round(($input%$dayTime)/$hourTime,0) . " h";
    elseif ($input >= $hourTime) return (round($input/$hourTime,0)) . " h et " . round(($input%$hourTime)/$minTime,0) . " mn";
    elseif ($input >= $minTime) return (round($input/$minTime,0)) . " mn";
    else return round($input,0) . " s";
}

function majuscule_handler($input) {

    return strtoupper($input);
}
 
function rs_field_text_handler($input)
{
  return (stripslashes($input));
}

function rs_field_memo_plus_handler($input)
{
  $input = eregi_replace("(^|[[:space:]])(http://[^[:space:]]{1,})([[:space:]]|$)", "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>\\3", $input);// convertit une adresse web situe entre 2 espaces en adresse web cliquable 

  $input = eregi_replace("(^|[ ,])([0-9a-zA-Z\._-]{1,}@[0-9a-zA-Z_-]{1,}\.[0-9a-zA-Z_-]{1,})([, ]|$)", "\\1<a href=\"mailto:\\2\">\\2</a>\\3", $input);// convertit une adresse email situe entre 2 espaces en adresse email cliquable 

  $input = eregi_replace("\[(.+);(.+)\]","<a href=\\2 target=_blank>\\1</a>",$input);// convertit un mot en mot cliquable. 
  
  $input = eregi_replace("\{\{([^\}]+)\}\}","<b>\\1</b>",$input);// convertit le texte contenu entre {{ et }} en GRAS

  $input = eregi_replace("\{([^\}]+)\}","<i>\\1</i>",$input);// convertit le texte contenu entre { et } en ITALIQUE

  $input = eregi_replace("\n---[-]+\n","<hr>",$input);// convertit ---- ou plus en une barre horizontale

  $input = eregi_replace("\n- ","<li>",$input);// convertit les lignes commenant par "- " en liste  puces

  //traitement des tableaux

  $input = eregi_replace("\n\n\|","<table><tr><td>",$input);
  $input = eregi_replace("\|\n\n","</td></tr></table>",$input);
  $input = eregi_replace("\|\n\|","</tr></td><tr><td>",$input);
  $input = eregi_replace(" \| ","</td><td>",$input);

  return (nl2br(stripslashes($input)));// remblace les sauts de ligne par des <br>
}

function rs_field_mysql_timestamp_handler($input){

    return ereg_replace("([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})", "\\3/\\2/\\1  \\4h\\5",$input);
}

function rs_field_mysql_timestamp_handler2($input){

    return ereg_replace("([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})", "le \\3/\\2/\\1  \\4:\\5",$input);
}

function rs_field_date_handler($input){
	return ereg_replace("([0-9]+)-([0-9]+)-([0-9]+) ([0-9]+):([0-9]+):([0-9]+)", "\\3/\\2/\\1  \\4h\\5",$input);
}

function rs_field_date_dmy_handler($input){	
  $regex_format1 = 
    '([0-9]+)-([0-9]+)-([0-9]+)'. // AA-JJ-MM
    '( ([0-9]+):([0-9]+):([0-9]+))?'; // HH:MM:SS (optionnel)
  $regex_format2 = 
    '([0-9]{4})([0-9]{2})([0-9]{2})'. // AAAAMMJJ
    '([0-9]{2})([0-9]{2})([0-9]{2})'; // HHMMSS

  if (ereg($regex_format1, $input,$regs)) {
    $input = $regs[3].'/'.$regs[2].'/'.$regs[1];
  } else if (ereg($regex_format2, $input,$regs)) {
    $input = $regs[3].'/'.$regs[2].'/'.$regs[1].'  '.$regs[4].'h'.$regs[5];
  } else if( $input == "00/00/0000" ) {
    $input="n/a";
  }    
  return $input;    
}

function rs_field_date_Y_handler($input){	
	$input = ereg_replace("([0-9]+)-([0-9]+)-([0-9]+)( ([0-9]+):([0-9]+):([0-9]+))?", "\\1",$input);
    if( $input == "0000" )
        $input="n/a";
    return $input;
}

function rs_field_date_M_Y_handler($input){
        return ereg_replace("([0-9]+)-([0-9]+)-([0-9]+)", "\\2/\\1",$input);
}

function rs_field_memo_handler($input){
  $input = ereg_replace("(^|[[:space:]])(http://[^[:space:]]{1,})([[:space:]]|$)", "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>\\3", $input); 

  $input = ereg_replace("(^|[[:space:]])([^[:space:]]{1,}@[^[:space:]]{1,}\.[^[:space:]]{1,})([[:space:]]|$)", "\\1<a href=\"mailto:\\2\">\\2</a>\\3", $input); 

  return (nl2br(stripslashes($input)));
}

function rs_field_money_handler_franc($input){
  return (sprintf ("%01.0f", $input));
}

function rs_field_money_handler_euro($input){
  return (sprintf ("%01.2f", $input));
}

function boolean_handler($input) {
	if ($input) return "OUI"; else return "NON";
}

function now_handler($input) {
	return date("Y-m-d");
}

function numeric_handler($input){
  $input = stripslashes($input);
  if( is_numeric($input) && $input==0 ) $input="n/a";
  return ($input);
}

function tel_number_handler($text){
	$res= ereg_replace("([0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9][0-9])", "\\1&nbsp;\\2&nbsp;\\3&nbsp;\\4&nbsp;\\5" ,$text);
	return $res;
}


/**
 * Short description.
 *
 * Detail description
 * @param     
 * @since     1.0
 * @access    private
 * @return    void
 * @throws    
 */
function rcs_handler($input)
{
    return substr($input,0,9);
} // end func

class rs_field
{
 var $name="";
 var $type="text";
 var $handler="rs_field_text_handler";
 var $editable=true;
 var $linkto="";
 var $lookupsql="";
 var $upload_dest="";
 var $as_bloc=false;

 function rs_field($name,$editable=true,$type="text",$handler="rs_field_text_handler"){
  $this->name=$name;
  $this->type=$type;
  $this->editable=$editable;
  $this->handler=$handler;
 }

 function rs_field_write_html_widget(&$fd,$rs)
 {
   if ($this->as_bloc) {
        fwrite($fd,"\n<!-- BEGIN: ".$this->name." -->\n");
   }
   switch($this->type) {
      case "upload_file":
         if ($this->linkto!="") fwrite($fd,"\t<a href=\"download.php3?rs=".$rs->table."&".$rs->keyfield."={".$rs->keyfield."}\">\n");
         fwrite($fd,"{".$this->name."}");
         if ($this->linkto!="") fwrite($fd,"\t</A>\n");
         break;
      default:

         if ($this->linkto!="") fwrite($fd,"\t<A href=\"".$this->linkto."?".$rs->keyfield."={".$rs->keyfield."}\">\n");
         fwrite($fd,"{".$this->name."}");
         if ($this->linkto!="") fwrite($fd,"\t</A>\n");
   }
   if ($this->as_bloc) {
        fwrite($fd,"\n<!-- END: ".$this->name." -->\n");
   }

 }
}

function rs_field_etat_handler($input){
    if( $input == "SAISI" ) return "En cours de rdaction";
    elseif( $input == "VALIDE" ) return "Publi";    
    elseif( $input == "ARCHIVE" ) return "Archiv";    
    else return "Etat inconnu";
}

function rs_field_signature( $input ){
    return wordwrap( $input, 64, "<br/>", 1);
}


?>
