<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * MySQL "high-level" functions.
 */

//---------------------------------------------------------------------------

function q_error() {
    return mysql_error();
}

//---------------------------------------------------------------------------

function q_query($sql){
    global $debug_sql;
    if ($debug_sql) echo 'q_query : '.nl2br(htmlspecialchars($sql))."<BR>\n";
    $res=mysql_query($sql);
    if ($res === false) {
        $txt  = 'Erreur SQL pour la requte "'.htmlspecialchars($sql).'" :<br>';
        $txt .= q_error(); 
        Erreur ($txt);
        return false;
    }
    return $res;
}

//---------------------------------------------------------------------------

function q_limit($start,$itemppage){
	return " LIMIT $start,$itemppage ";
}

//---------------------------------------------------------------------------

function q_num_rows($res){
    if ($res === false) return 0;
    return mysql_num_rows($res);
}

//---------------------------------------------------------------------------

function q_fetch($res){
    return mysql_fetch_row($res);
}

//---------------------------------------------------------------------------

function q_fetch_array($res,$option=MYSQL_BOTH){
    return mysql_fetch_array($res,$option);
}

//---------------------------------------------------------------------------

function q_fetch_assoc($res){
    return mysql_fetch_assoc($res);
}

//---------------------------------------------------------------------------

function q_fetch_assoc_table($fields, $res){
    $row = mysql_fetch_array($res);
    if ($row === false) return false;
    $assoc = Array();
    for($i=0; $i<count($fields); $i++)
        $assoc[$fields[$i]] = $row[$i];
    return $assoc;
}

//---------------------------------------------------------------------------

function q_fetch_both_table($fields, $res){
    $row = mysql_fetch_array($res);
    if ($row === false) return false;
    $assoc = Array();
    for($i=0; $i<count($fields); $i++)
        $assoc[$fields[$i]] = $row[$i];
    return array_merge($assoc,$row);
}

//---------------------------------------------------------------------------

function getSqlValue($sql){
    $r=mysql_query($sql);
    if (!$r) {
      $txt = 'Erreur SQL';
      if ($GLOBALS['debug']) {
	    $txt .= 'lors de la requte '.htmlspecialchars($sql).' !';
	    $txt .= 'Erreur MySQL : '. mysql_error();    
      }
      Erreur($txt);
      return;
    }
    if (mysql_num_rows($r)==0) return false;
    $arr=mysql_fetch_row($r);
    return $arr[0];
}

//---------------------------------------------------------------------------

function q_connect($db_server,$db_user,$db_pass,$db) {
	return mysql_connect($db_server,$db_user,$db_pass,$db);
}

//---------------------------------------------------------------------------

function q_fetch_row($res) {
	return mysql_fetch_row($res);
}

//---------------------------------------------------------------------------

function q_fetch_field($result,$key) {
	$temp=mysql_fetch_field($result,$key);
	$f["name"]=$temp->name;
	$f["type"]=$temp->type;
	return $f;
}

//---------------------------------------------------------------------------

function q_insert_id() {
	return mysql_insert_id();
}

//---------------------------------------------------------------------------

function q_num_fields($result) {
	return mysql_num_fields($result);
}

//---------------------------------------------------------------------------

// INSERT INTO $table (...) VALUES(...)
// with $fields=Array($key => $value, ...)
function q_insert($table, $fields) {
        $sql  = 'INSERT INTO '.$table;
        $sql .= ' '.'('.implode(array_keys($fields),',').')';
        $sql .= ' '.'VALUES(';
        $virgule = false;
        foreach ($fields as $key=>$val) {
            if ($virgule) $sql .= ', '; else $virgule = true;
            $sql .= q_prepare_string($val,"'");
        }
        $sql .= ')';
        $r=q_query($sql);
}

//---------------------------------------------------------------------------

// Convert select request into sql string
// See q_select function for parameters syntax
function q_select_sql($fields, $table=false, $where=false, $join=false, $group=false, $order=false)
{
    // SELECT statement
    $sql = 'SELECT '.q_prepare_fields($fields);
        
    // FROM statement
    if ($table !== false) $sql .= "\nFROM ".q_prepare_table($table);
    
    // JOIN statement
    if (gettype($join)=='array') {
        foreach ($join as $j) {
            $join_table = $j['table'];
            unset($j['table']);
            $sql .= "\nLEFT JOIN ".q_prepare_table($join_table).' ON ';
            $sql .= q_associative_array2string($j,'=',' AND ',"`","`",true,true);
        }
    } else if ($join !== false) {
        $sql .= ' '.$join.' ';
    }
    
    // WHERE statement
    $sql .= q_prepare_where($where);

    // GROUP BY statement
    if ($group !== false) $sql .= "\nGROUP BY ".$group;

    // ORDER BY statement
    $sql .= q_prepare_order($order);

    return $sql;
}

//---------------------------------------------------------------------------

// SELECT $fields FROM $table 
//   WHERE $where $join 
//   GROUP BY $group ORDER BY $order
// with $fields : array (key1, key2, ...) 
//                or assoc. array (key1 as name1, key2, key3 as name3, ...)
//                or string 
//      $table  : string or associative array (table AS name) (optionnal)
//      $where  : associative array (key1=value1, key2=value2, ...) 
//                or string (optionnal)
//      $join   : array where each value is an array : 
//                Array( $table, $cond1, $cond2, ...)
//                with $table : same syntax then main $table name
//                     $condi : associative array ($name => $value)
//      $group  : string (optionnal)
//      $order  : string (optionnal)
function q_select($fields, $table=false, $where=false, $join=false, $group=false, $order=false)
{
    $sql = q_select_sql($fields, $table, $where, $join, $group, $order);
    return q_query($sql);
}

//---------------------------------------------------------------------------

// Read one value in SQL : see q_select for parameters syntax
// Return false is the value can't be found
function q_read_field($field, $table=false, $where=false, $join=false) {
    // Query SQL
    $r = q_select($field, $table, $where, $join);

    // No row ?
    if (q_num_rows($r)==0) return false;

    // Fetch row
    $row = q_fetch($r);
    $value = $row[0];

    // Value does exist but is equal to NULL ?
    if ($value == NULL) return false;
    return $value;
}

//---------------------------------------------------------------------------

// Read one row in SQL : see q_select for parameters syntax
// Return false is no row can't be found
function q_read_row($fields, $table=false, $where=false, $join=false, $group=false, $order=false)
{
    if (gettype($fields)=='string') {
        $tab = explode(',',$fields);
        $fields = Array();
        foreach ($tab as $field) {
            $fields[] = trim($field);
        }
    }
    $sql = q_select_sql($fields, $table, $where, $join, $group, $order);
    $r = q_query($sql);
    if (($r === false) || (q_num_rows($r) != 1)) {
        ErreurFatale (
            'Erreur SQL lors de la lecture d\'une ligne.<br>'.
            'Requte =<br>'.nl2br(htmlspecialchars($sql)).';<br>'.
            'Message d\'erreur SQL : '.q_error());
    }
    return q_fetch_both_table($fields, $r);
}

//---------------------------------------------------------------------------

// UPDATE $table SET $key="$value", $key2=$value2, ... WHERE $where
// with $table: string, $fields : associative array, and $where : associative array 
// (k1=v1 and k2=v2 and ...) or string
function q_update($table, $fields, $where) {
    $sql  = 'UPDATE `'.$table.'` SET ';
    $sql .= q_associative_array2string($fields,'=',', ',"`","'");
    $sql .= q_prepare_where($where);
    return q_query($sql);
}

//---------------------------------------------------------------------------

// DELETE $table WHERE $where ORDER BY $order
function q_delete($table, $where=false, $order=false)
{
    $sql = 'DELETE FROM '.$table;
    $sql .= q_prepare_where($where);
    $sql .= q_prepare_order($order);
    q_query($sql);
}

//-----------------------------------------------------------------------------

// Get NOW() value in Unix time format
function q_now_time() {
  $now = q_read_field('NOW()');
  $txt  = "^([0-9]{4})"; // Anne
  $txt .="-([0-9]{2})"; // Mois
  $txt .= "-([0-9]{2})"; // Jour
  $txt .= " ([0-9]{2})"; // Heure 
  $txt .= ":([0-9]{2})"; // Minute 
  $txt .= ":([0-9]{2})$"; // Seconde
  if (ereg($txt, $now, $regs)) {
    $annee = $regs[1];
    $mois = $regs[2];
    $jour = $regs[3];
    $heure = $regs[4];
    $minute = $regs[5];
    $seconde = $regs[6];
  } else {
    $annee = 1900;
    $mois = 1;
    $jour = 1;
    $heure = 12;
    $minute = 0;
    $seconde = 0;
  }
  return mktime($heure,$minute,$seconde,$mois,$jour,$annee);
}

//-----------------------------------------------------------------------------

// Convert Unix time format into MySQL timestamp
function q_time2timestamp($time) {
  return strftime('%Y%m%d%H%M%S' ,$time);
}

//---------------------------------------------------------------------------
?>
