<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

// $Id: rs.php,v 1.4 2004/11/18 10:59:18 ymaillard Exp $
if (isset($debug)) echo ("rs.php3 start2<BR>\n");
/**
 * Recordset
 *
 * Cette classe permet de grer des recordsets (ensemble de donnes issues 
 * d'un base de donnes SQL).
 *
 * Elle permet 
 * -  d'afficher  l'aide de templates l'ensemble des donnes du recordset.
 * -  de saisir un enregistrement et de le poster dans la base.
 * -  de saisir des modifications et de les poster dans la base.
 * -  d'effacer un enregistrement.
 *
 * @access public 
 * @author	 HEITZMANN Sbastien <2le@2le.net>
 * @author	 HEITZMANN Sbastien <2le@2le.net>
 */
class rs_class
{

  /**
   * Requete sql du recordset
   * @access public 
   */
  var $sql="";

  /**
   * Affiche des messages de debug si diffrent de 0. Pas sur que ca marche
   * @access public 
   */
  var $debug=0;

  /**
   * Nom de la table sur laquelle s'appuie le recordset. Sert pour les ajout,modif et suppression
   * @access public 
   */
  var $table;

  /**
   * Champ clef de la table sur laquelle s'appuie le recordset. Sert pour les ajout,modif et suppression
   * @access public 
   */
  var $keyfield;
  var $keyfield2;

  /**
   * Chemin du template d'affichage du recordset
   * @access public 
   */
  var $template_list;
  /**
   * Chemin du template d'affichage de la fiche detaille
   * @access public
   */
  var $template_detail;
  /**
   * Chemin du template de saisie du recordset. Sert  la fois pour la saisie et la modification
   * @access public 
   */
  var $template_form;
  /**
   * Nombre d'enregistrement par page. Ne fonctionne pas encore tout a fait.
   */
  var $itemppage=0; // no nav

  var $navvar='start'; 
  var $nbmodulo=3; 
  var $keyistext=1;
  /**
   * Tableau contenant les champs du recordset. Variable prive, ne pas utiliser directement.
   * Les valeurs de ce tableau sont des objets de type rs_field
   * @see rs_field
   */
  var $field_list;
	
  /**
   * Description
   * @var       
   * @since     1.0
   * @access    private
   */
  var $caller;

  var $nbruptfield=0;

  /**
   * Crer et affiche un formulaire de saisie des donnes du recordset.
   * Le template de cration doit contenir l'ensemble des champs editable du recordset.
   * @access public 
   */
  Function rs_new($postvar="post_new",$isFile = true, $text = false,$defval=array())
  {
    $xtpl=new XTemplate($this->template_form,"main",$isFile);
    $this->rs_new_tpl(&$xtpl,"main",$postvar,$defval);
    if ($text) return $xtpl->text("main");
    else $xtpl->out("main");
  }

  /**
   * Remplis le template de saisie des donnes du recordset.
   * Le template de cration doit contenir l'ensemble des champs editable du recordset.
   * @access public 
   * @param XTemplate  $xtpl	Objet template  remplir avec les donnes du formulaire
   * @param string		$key	Clef  parse dans le template
   */
  Function rs_new_tpl(&$xtpl,$keybloc='main',$postvar="post_new",$defval=array()){
    $xtpl->assign("Type_form","<input type=\"hidden\" name=\"$postvar\" value=\"1\">");

    $this->rs_traitement_fields ($xtpl, $keybloc, $defval);
    $xtpl->parse($keybloc);
  }

  /**
   * @access public 
   */
  Function rs_delete($delete,$beforedeletecallback='',$afterdeletecallback='')
  {
    if ( $debug ) echo ("delete ".$this->keyfield."=$delete\n");
    $ok = TRUE;
    if ($beforedeletecallback) {
      $ok= $beforedeletecallback($delete);
    }
    if ($ok) {
      if ($this->keyistext) {
	$sql="delete from ".$this->table." where ".$this->keyfield."='$delete'";
	q_query($sql);
      } else {
	q_query("delete from ".$this->table." where ".$this->keyfield."=$delete");
      }
      reset($this->field_list);
      while (list($k, $v) = each($this->field_list)) {
	if (($v->type=='upload_file')&&(file_exists($v->upload_dest."/".$delete.".dat"))) {
	  if (!unlink ($v->upload_dest."/".$delete.".dat")) echo "erreur suppression fichier";
	}
      }
    }
    if ($afterdeletecallback) {
      $afterdeletecallback($delete);
    }
  }

  /**
   * @access public 
   */
  Function rs_post_new($beforepostcallback='',$afterpostcallback=''){
    $n=0;
    reset ($this->field_list);
    while (list($k, $v) = each($this->field_list)) {
      if( !$v->editable && $v->type=="now"){
	$GLOBALS[$k] = date("Y-m-d H:i:s");
	$values[$n]="'".addslashes(stripslashes($GLOBALS[$k]))."'";
	$champs[$n++]=$k;                
      }

      if (($v->editable) || ( ($v->type=='hiddenvar') && ($v->type!='upload_file') ) ) {
	if ($v->type=='date') {
	  echo $GLOBALS[$k];
	  $values[$n]="'".ereg_replace("([0-9]+)[/-]([0-9]+)[/-]([0-9]+)", "\\3-\\2-\\1",$GLOBALS[$k])."'";
	} else {
	  $values[$n]="'".addslashes(stripslashes($GLOBALS[$k]))."'";
	}

	$champs[$n++]=$k;
      }
    }
    $ok=1;
    $tabparams = arraysInOne( $champs, $values );
    if ($beforepostcallback) {
      $ok= $beforepostcallback(&$tabparams, "new");
    }
    if ($ok) {
      $sql="Insert into ".$this->table."(".join(",",$champs).") values(".join(",",$tabparams).")";
      //echo "SQL=".$sql;
      q_query($sql);
      $noFiche=q_insert_id();

      // GESTION DES UPLOADS
      reset($this->field_list);
      while (list($k, $v) = each($this->field_list)) {
	if ($v->type=='upload_file') {
	  if (isset($_FILES[$v->name]['tmp_name']) 
	      && ($_FILES[$v->name]['tmp_name']!='') 
	      && ($_FILES[$v->name]['tmp_name']!='none')) {
	    if ($win32==1) {
	      $file = basename($GLOBALS[$v->name]);
	      $des = $v->upload_dest."/".$noFiche.".dat";
	      if (!copy("c:\\$file",$dest)) echo "erreur 	copie fichier";
	    }
	    else {
	      $dest = $v->upload_dest.'/'.$noFiche.".dat";
	      if(!move_uploaded_file($_FILES[$v->name]['tmp_name'],
				     $dest)) echo "erreur copie fichier";
	    }
	    $sql= "update ".$this->table
	      ." set ".$v->name."='".$_FILES[$v->name]['name']
	      ."' where ".$this->table.'.'.$this->keyfield."=$noFiche";
	    q_query($sql);
	  }

	}
      }
      if ($afterpostcallback) {
	      $afterpostcallback(&$noFiche,$tabparams, "new");
      }

      return $noFiche;
    } else {
      return 0;
    }
  }

  /**
   * @access public 
   */
  Function rs_post_modify($post_modify, $beforepostcallback='', $afterpostcallback=''){
    $n=0;

    reset ($this->field_list);
    while (list($k, $v) = each($this->field_list)) {
      if (($v->editable) && ( $v->type!='upload_file')) {
	if ($v->type=='date') {
	  $values[$n]="'".ereg_replace("([0-9]+)[/-]([0-9]+)[/-]([0-9]+)", "\\3-\\2-\\1",$GLOBALS[$k])."'";
	} else {
	  $values[$n]="'".addslashes(stripslashes($GLOBALS[$k]))."'";
	}
                    
	$champs[$n++]=$k;
      }

    }
            
    $ok=1;
    $tabparams = arraysInOne( $champs, $values );
    if ($beforepostcallback) {
      $ok= $beforepostcallback(&$tabparams, "modify");
    }

    $sql="Update ".$this->table." set ";

    list($key,$val)=each($tabparams);
    $sql=$sql."$key=$val";
    while (list($key, $val) = each($tabparams)) {
      $sql=$sql.",$key=$val";
    }            
            
    if ($this->keyistext) {
      $sql=$sql." WHERE ".$this->keyfield."='$post_modify'";
      if ($this->keyfield2 != '') $sql .= " AND ".$this->keyfield2."='$post_modify2'";
    } else {
      $sql=$sql." WHERE ".$this->keyfield."=$post_modify";
      if ($this->keyfield2 != '') $sql .= " AND ".$this->keyfield2."='$post_modify2'";
    }
    q_query($sql);

    // GESTION DES UPLOADS
    reset($this->field_list);
    while (list($k, $v) = each($this->field_list)) {
      if ($v->type=='upload_file') {
	//echo "handle upload : file :".$GLOBALS[$v->name]."<BR>";
	if (isset($_FILES[$v->name]['tmp_name']) && ($_FILES[$v->name]['tmp_name']!='')&& ($_FILES[$v->name]['tmp_name']!='none')){
	  //print "DANS IF";
	  if ($win32==1) {
	    $file = basename($GLOBALS[$v->name]);
	    if (!copy("c:\\$file",$v->upload_dest."/".$post_modify.".dat")) echo "erreur copie fichier";
	  }
	  else {
	    if(!move_uploaded_file($_FILES[$v->name]['tmp_name'],$v->upload_dest."/".$post_modify.".dat")) echo "erreur copie fichier";
	  }
	  $sql= "update ".$this->table.
	    " set ".$v->name."='".$GLOBALS[$v->name."_name"].
	    "' where ".$this->keyfield."='$post_modify'";
	  //print "<BR>SQL" . $sql . "<BR>";                    
	  q_query($sql);
	}

      }
    }

    if ($afterpostcallback) {
      $afterpostcallback(&$post_modify,$tabparams, "modify");
    }            

  }

  /**
   * @access public 
   */
  Function rs_modify($modify,$postmodifyvar="post_modify",$isFile = true, $text = false,$defval=Array())
  {

    $xtpl=new XTemplate($this->template_form,"main",$isFile);
    $this->rs_modify_tpl($modify,$xtpl,"main",$postmodifyvar,$defval);
    if ($text) return $xtpl->text("main");
    else $xtpl->out("main");
  }

  /*
   * $defval = valeur par dfaut
   */
  function rs_traitement_fields(&$xtpl, $keybloc, $defval) 
  {
    reset($this->field_list);
    while (list($k, $v) = each($this->field_list)) {

      // Traite les variables caches
      if ($v->type=="hiddenvar") {
	$xtpl->assign($k,$GLOBALS[$k]);
      }

      // Traite les lookups SQL
      if ($v->lookupsql!='') {
	if (array_key_exists($v->name,$defval))
	  $xtpl->assign($v->name."_id", $defval[$v->name]);

	$r=q_query($v->lookupsql);
	if (!$r) die ($v->lookupsql.'  :  '.q_error());

	while ($val=q_fetch_row($r)) {
	  $xtpl->assign(array("key"=>$val[0],"val"=>$val[1]));
	  $xtpl->parse($keybloc.'.'.$k.'options');
	}
      }

      // Traite les lookups de module
      if ($v->lookupmods!='') {
	$modules = Castor_ListeModules($v->lookupmods);
	sort ($modules);
	foreach ($modules as $item) {
	  $xtpl->assign(array("key"=>$item,"val"=>$item));
	  $xtpl->parse($keybloc.'.'.$k.'options');
	}
      }

      $xtpl->assign($defval);
    }
}

  /**
   * @access public 
   */
  Function rs_modify_tpl($modify,&$xtpl,$keybloc='main',$postmodifyvar="post_modify",$defval=Array())
  {
    if( strpos($this->sql,"where") === FALSE && strpos($this->sql,"WHERE") === FALSE ) {
      if ($this->keyistext) $sql=$this->sql." where ".$this->keyfield."='$modify'";
      else $sql=$this->sql." where ".$this->keyfield."=$modify";
    }
    else {
      if ($this->keyistext) $sql=$this->sql." and ".$this->keyfield."='$modify'";
      else $sql=$this->sql." and ".$this->keyfield."=".$modify;
    }

    // Lit les valeurs actuelles des diffrents champs
    $result = q_query($sql);

    if (!$result) echo q_error();
    $a = q_fetch_array($result);
    $this->rs_list_parse_fields($a, $xtpl,$result,$keybloc);

    reset ($a);
    while (list ($key, $val) = each ($a)) {
      $f=q_fetch_field($result,$key);
      if (!$f) echo "erreur champ $key,$val";
      $xtpl->assign($f->name,$val);
    }

    $xtpl->assign("Type_form","<input type=\"hidden\" name=\"$postmodifyvar\" value=\"$modify\">");
    $this->rs_traitement_fields ($xtpl, $keybloc, $defval);
    $xtpl->parse($keybloc);
  }



  /**
   * Assigne <nom> => <valeur_handler> et __<nom>__ => <valeur>
   * o <valeur_handler> est la <valeur> passe dans un handler si ncessaire
   * @access private 
   */
  Function rs_list_parse_field($fname,$val,&$xtpl,$k)
  {
    $f=$this->field_list[$fname];
    $hdl=$f->handler;
    $lkp=$f->lookupsql;
    if ($lkp) {
      $match = eregi('select(.*)from(.*)',$lkp, $result);
      if ($match) {
	$fields = split(',',$result[1],2);
	$key = trim($fields[0]);
	$lib = trim($fields[1]);
	$table = trim($result[2]);
	$match = eregi('(.*)order by(.*)', $table, $result2);
	if ($match) $table = trim($result2[1]);
	$match = eregi('(.*)where(.*)', $table, $result2);
	if ($match) $table = trim($result2[1]);
	$match = eregi("(.*)group by(.*)", $table, $result2);
	if ($match) $table = trim($result2[1]);          

	$vallib = getSqlValue("SELECT $lib FROM $table WHERE $key = '$val';");
	$xtpl->assign($fname."_id",stripslashes($val));
	$val=$vallib;
      }
    }
    if ($f->type=='date') {
      $val=rs_field_date_dmy_handler($val);
    }
    if (($f->type!='hiddenvar') && $hdl) {
      $xtpl->assign($fname,stripslashes($hdl($val)));
    }
    else{
      $xtpl->assign($fname,stripslashes($val));            
    }

    $xtpl->assign("__".$fname."__",stripslashes($val));            

    if ($f->as_bloc==true) { 
      if (($val) && !(/*$f->type=="upload_file" &&*/ $val=='none')) {
	$xtpl->parse($k.'.'.$fname);
      }
    }
  }

  /**
   * @access private 
   */
  Function rs_list_parse_fields($a,&$xtpl,$result,$tpl_key)
  {
    reset($a);
    while (list ($key, $val) = each ($a)) {
      //$f=q_fetch_field($result,$key);
      $this->rs_list_parse_field($key,$val,$xtpl,$tpl_key);
    }
  }

  /**
   * @access public 
   */
  Function rs_list_tpl(&$xtpl,$key="main",$parsenorow=true, $insere_ajout = FALSE, $insere_modif = FALSE, $insere_suppr = FALSE, $insere_detail = FALSE, $insere_export = FALSE,$on_row=''){
    //echo("rs_list_tpl start key=$key:<br>\n");
    if ($this->itemppage!=0){
      $result = q_query($this->sql);
      $nbmax=q_num_rows($result);
      if (!isset($GLOBALS[$this->navvar])) $GLOBALS[$this->navvar]='0';
      $this->sql.=q_limit($GLOBALS[$this->navvar],$this->itemppage);
    }

    $ruptstr="";
    $result = q_query($this->sql);

    // Gnre le bloc lien ajout
    if( $insere_ajout ){
      $xtpl->parse($key.".lien_ajout");            
    }

    // Gnre le bloc lien export
    if( $insere_export ){
      $xtpl->parse($key.".lien_export");            
    }        

    if (q_num_rows($result)>0) {
      $keytable = $key.'.table';
      while($a = q_fetch_array($result,MYSQL_BOTH)){

	if ($on_row) {
	  if ($this->caller) {
	    $this->caller->$on_row(&$a);
	  } else {
	    $on_row(&$a);
	  }
	}
	// gestion des ruptures
	$str='';
	for ($j=0;$j<$this->nbruptfield;$j++){
	  $str.=$a[$j];
	}

	if ($str!=$ruptstr) $rupt=1; else $rupt=0;
	$this->rs_list_parse_fields($a,$xtpl,$result,$keytable.".row",$rupt);

	if ($str!=$ruptstr){
	  if ($ruptstr){
	    $xtpl->parse($keytable.".row.finRupt");
	  }
	  $xtpl->parse($keytable.".row.entete");
	  $ruptstr=$str;
	}

	// Gnre le bloc lien modifier
	if( $insere_modif ){
	  $xtpl->parse($keytable.".row.lien_modif");            
	}

	// Gnre le bloc lien supprimer
	if( $insere_suppr ){
	  $xtpl->parse($keytable.".row.lien_suppr");
	}

	// Gnre le bloc lien detail
	if( $insere_detail ){
	  $xtpl->parse($keytable.".row.lien_detail");
	}                

	// Gnre le bloc lien modifier
	if( $insere_modif ){
	  $xtpl->parse($keytable.".row.row".$i % $this->nbmodulo."lien_modif");            
	}

	// Gnre le bloc lien supprimer
	if( $insere_suppr ){
	  $xtpl->parse($keytable.".row.row".$i % $this->nbmodulo."lien_suppr");
	}                

	// Gnre le bloc lien detail
	if( $insere_detail ){
	  $xtpl->parse($keytable.".row.row".$i % $this->nbmodulo."lien_detail");
	}                                

	// gestion des pyjamas
	$xtpl->parse($keytable.".row.row".$i % $this->nbmodulo);
	$xtpl->parse($keytable.".row");
	$i++;
      }
      $xtpl->parse($keytable);

      if ($this->itemppage<$nbmax){// gnre le bloc nav
	//echo "--".$GLOBALS[$this->navvar]."--";
	if ($GLOBALS[$this->navvar]>0) {
	  $xtpl->assign("prec",$GLOBALS[$this->navvar]-$this->itemppage);	
	  $xtpl->parse($key.".nav.flecheprec");	
	  //echo "parse prec.";
	}

	if (($GLOBALS[$this->navvar]+($this->itemppage))<$nbmax) {
	  $xtpl->assign("suiv",$GLOBALS[$this->navvar]+$this->itemppage);	
	  $xtpl->parse($key.".nav.flechesuiv");	
	  //echo "parse suiv.";
	}

	$xtpl->parse($key.".nav");	
      }

      $xtpl->parse($key);      
    }else{
      if ($parsenorow==true) {
	$xtpl->parse($key.".norow");
	$xtpl->parse($key);
      }
    }
  }

  /**
   * @access public 
   */
  Function rs_list($isFile = true, $text = false, $parsenorow = true, $insere_ajout = FALSE, $insere_modif = FALSE, $insere_suppr = FALSE, $insere_detail = FALSE, $insere_export = FALSE,$on_row=''){
    $xtpl=new XTemplate($this->template_list,"main",$isFile);
    $this->rs_list_tpl($xtpl, "main", $parsenorow, $insere_ajout, $insere_modif, $insere_suppr, $insere_detail, $insere_export,$on_row);
    if ($text) return $xtpl->text("main");
    else $xtpl->out("main");
    //print "LISTING DE : ".$this->sql."<br>";
  }

  /**
   * @access public 
   */
  Function rs_export( $mime_export='text/csv', $file_export='document.csv', $on_row = '', $isFile = true){
    $xtpl=new XTemplate($this->template_export,"main",$isFile);
    $this->rs_list_tpl($xtpl,"main",true,FALSE, FALSE, FALSE, FALSE, FALSE,$on_row);
    header("Content-Type: " . $mime_export);
    if( trim( $file_export ) != '' ) header("Content-Disposition: filename=" . trim( $file_export ) );
    $xtpl->out(main);
    die();
  }     

  /**
   * @access public
   */
  Function rs_detail($detail,$isFile = true, $text = false, $insere_modif = FALSE, $insere_suppr = FALSE)
  {
    //echo("rs_detail start<br>\n");
    $xtpl=new XTemplate($this->template_detail,"main",$isFile);

    //if (file_exists($this->template_detail)) echo $this->template_detail." EXISTE<br>";
    //else echo $this->template_detail." N'EXISTE PAS<br>";

    $match = eregi('(.*)where(.*)',$this->sql, $result);
    //echo "SQL : ".$this->sql."<br>";
    if ($match) {
      // On a une clause WHERE...
      $clauseWhere = $result[2];
      $match = eregi('(.*)order by(.*)', $clauseWhere, $result2);
      if ($match) $clauseWhere = $result2[1];
      $match = eregi('(.*)group by(.*)',$clauseWhere, $result3);
      if ($match) $clauseWhere = $result3[1];
      $this->sql = $result[1].'WHERE '.$clauseWhere.' AND '.$this->table.'.'.$this->keyfield." = '".$detail."'";
    }
    else $this->sql .= ' WHERE '.$this->table.'.'.$this->keyfield." = '".$detail."'";

    $this->rs_list_tpl($xtpl,"main", true, false, $insere_modif, $insere_suppr);
    if ($text) return $xtpl->text("main");
    else $xtpl->out("main");
  }

  /**
   * @access private 
   */
  Function rs_list_select_options($key_field,$val_field,$checked_key='')
  {
    //   echo("rs_list_tpl start key=$key:<br>\n");
    $opt_str='';
    $result = q_query($this->sql);
    if (q_num_rows($result)>0) {
      while($a = q_fetch($result)) {
	if ($a[0]==$checked_key) $checked='checked'; else $checked='';
	$opt_str.='<OPTION value="'.$a[0].'" '.$checked.'>'.$a[1]."</option>\n";
      }
    }
    return $opt_str;
  }



  /**
   * Ajoute un champs au recordset.
   * 
   * @param string $name		Nom du champs. Ce nom doit correspondre avec le nom du champs dans le select
   * @param boolean $editable	Indique si le champs peut tre edit dans le formulaire de saisie
   * @param string $type		Type du champs. 
   *						text : champs simple ,  
   *						upload_file : nom de fichier et enregistrement de celui-ci sur le serveur
   *						hiddenvar : 
   * @param string $handler	Fonction qui traitera la donne brute de la base avant de l'afficher
   * @access public 
   */
  Function rs_addfield($name,$editable=true,$type="text",$argument="rs_field_text_handler")
  {
    $this->field_list[$name]=new rs_field($name,$editable,$type,$argument);
  }

  /**
   * @access public 
   */
  Function rs_addblocfield($name,$editable=true,$type="text",$handler="rs_field_text_handler")
  {
    $f=new rs_field($name,$editable,$type,$handler);
    $f->as_bloc=true;
    $this->field_list[$name]=$f;
  }

  /**
   * @access public 
   */
  Function rs_addfieldobj(&$obj)
  {
    $this->field_list[$obj->name]=$obj;
  }

  /**
   * @access public 
   */
  Function rs_addfields($name_array)
  {
    while (list ($key, $val) = each ($name_array)) {
      $this->rs_addfield($val);
    }
  }

} //class


function optionList($sql)
{
  $r=q_query($sql);
  $res="";
  while ($row=q_fetch_row($r)) {
    $res=$res.'<Option value="'.$row[0].'">'.$row[1]."</option>\n";
  }
  return $res;
} // end func

function getSQL($sql)
{
  $r=q_query($sql);
  $row=q_fetch_array($r);
  return $row;
} // end func

/**
 *
 * fusion de deux tableaux
 *
 * Fusion de deux tableaux en un seul
 *  partir d'un tableau de cls et un tableau de valeurs
 *
 * @return	    array   tableau fusionn
 * @parameter	array   tableau des noms des champs du formulaire
 * @parameter	array   tableau des valeurs des champs du formulaire
 */
function arraysInOne( $tabkeys, $tabvalues ){
  $tabkeys = array_flip( $tabkeys );
  foreach( $tabkeys as $key => $value ){
    $tabparams[$key] = $tabvalues[$value];   
  }
  return $tabparams;
}
?>
