<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/**
 * Gestion des modules Castor.
 */

class webmodule {

  // Identifiant du module (utilis pour stocker les paramtres du module,
  // entre autres)
  var $id = "webmodule";
  
  // Configuration parameters of the module
  var $params = array(); // Parameters name
  var $paramsType = array(); // Parameters type
  var $paramsLevel = array(); // Parameters level (see $levelib), first is 0
  var $paramsComment = array(); // Comments about a parameter
  var $levellib = array("parameters"); // Name of parameters level
  var $levelComment = array(); // Comments about a parameters level

  // ($key=>$value) For templates : is the template loaded from
  // theme directory ?
  var $templateFromThemes=Array(); 
   
  // Liste des variables externes utilise par le module.
  var $inVars = array();
  
  // Description
  var $docstring = "";

  // Zone Castor dans laquelle est crite la sortie
  var $zone = "content";


  // Constructor
  function webmodule($id='webmodule'){
    $this->id=$id;
    $this->loadParamFromDb();
  } // end func


  // Set the (output) zone of the module
  function setZone($zone){
    $this->zone=$zone;
  } // end func


  // Load a template :
  // 1- Try to load template from current theme directory
  // 2- Try to load template from template directory
  // If no template is found, return false
  function loadTemplate($name,$from_themes=false) {
    global $lg, $templatePath,$theme_css;

    if (!$from_themes) {
      $content = $this->loadTemplate($name, true);
      if ($content) return $content;
    }
    
    if ($from_themes)
      $filename = $rootpath.'themes/'.$theme_css.'/templates/'.$lg.'/'.$this->id.'/'.$name.'.xtpl';
    else
      $filename = $templatePath."$lg/".$this->id.'/'.$name.'.xtpl';
    if (!file_exists($filename)) return false;
    $fd = @fopen($filename, "r");
    if (!$fd) {
      Erreur ('Impossible d\'ouvrir le fichier "<em>'.
  	      $filename.
	      '</em>" en lecture ! Veuillez corriger '.
	      'les droits d\'accs  ce fichier.');
      return false;
    } 
    $contents = fread($fd, filesize ($filename));
    fclose($fd);
    $this->templateFromThemes[$name]=$from_themes;
    return trim($contents);
  }

  function loadParamFromDb(){
    global $table_modules_params;

    // Charge les paramtres depuis la base SQL
    $sql = "SELECT id, text FROM ".$table_modules_params." WHERE id_module = '".$this->id."'";
    $r=mysql_query($sql);
    if (!$r) die(mysql_error()."<br>SQL = ".$sql);

    // Traite un paramtre aprs l'autre
    while ($row=mysql_fetch_array($r)) {
	if ($this->paramsType[$row["id"]]=='templates') {
	    $contents = $this->loadTemplate ($row['id']);
	    if ($contents===false) $contents=$row["text"];
	} else {
	    $contents = $row['text'];
	}
        $this->params[$row["id"]] = $contents;
    }
  }


  function saveTemplate($name, $contents) {
    global $templatePath,$lg;
    
    if (!file_exists($templatePath.$lg.'/'.$this->id."/")) {
	umask("000");
	mkdir($templatePath.$lg.'/'.$this->id."/",0770);
    }
    $filename=$templatePath.$lg.'/'.$this->id."/".$name.".xtpl";
    @chmod( $filename, 0664 );
    $fd = @fopen($filename, "w");
    if ($fd) {
      fwrite($fd, stripslashes($contents));
      fclose($fd);
    } else {
      Erreur ('Impossible d\'ouvrir le fichier "<em>'.
	      $filename.
	      '</em>" en criture ! Veuillez corriger '.
	      'les droits d\'accs  ce fichier.');
    }
  }

	
  function saveParamToDb(){
    global $table_modules,$table_modules_params;

    // If the module didn't exist in modules table : create it
    $sql = "SELECT id FROM ".$table_modules." WHERE id = '".$this->id."'";
    $r=mysql_query($sql);
    if (!$r) die(mysql_error()."<br>SQL = ".$sql);
    if (mysql_num_rows($r)==0) {
	mysql_query("insert into $table_modules"."(id) values('".$this->id."')");
    }
    
    // Save each params in module parameters table
    while (list($k,$v)=each($this->params)) {

        // If the parameter is a template and was loaded from the
	// theme directory : don't save it !
        if (($this->paramsType[$k] == 'templates')
            && $this->templateFromThemes[$k]) continue;
    
        // Convert string into SQL format
	$v=addslashes($v);
	
        // Try to read to parameter to know if the parameter exists or
	// not in the data base
	$sql = "select id from $table_modules_params where id='".$k."' and id_module='".$this->id."'";
	$r=mysql_query($sql);
	if (!$r) { Erreur ('Erreur SQL : $sql,<br>'.mysql_error()); continue; }

        // If the key 
	if (mysql_num_rows($r)==0) {
	    $sql="insert into $table_modules_params"."(id,id_module,text) values('$k','".$this->id."','".$v."')";
	    $res = mysql_query($sql);
	    if (!$res) echo $sql."<br>".mysql_error();
	} else {
	    $sql="update $table_modules_params set text='$v' where id_module='".$this->id."' and id='".$k."'";
	    mysql_query($sql);
	    echo mysql_error();
	}
	if ($this->paramsType[$k] == 'templates') {
            $this->saveTemplate ($k,$v);
	}
    }
  } // end func


  function getParam($id)
  {
    return $this->params[$id];
  } // end func

  function setParam($id,$val)
  {
    $this->params[$id]=$val;
  } // end func
	

	
  function initModule()
  {
    global $table_modules_params;
    $var=$this->id;
    foreach (array_keys($this->params) as $p) {
	$r=mysql_query("SELECT id, id_module,text FROM $table_modules_params WHERE id_module='".$this->id."' and id='$p'");
	echo mysql_error();
	if (mysql_num_rows($r)<1) {
	    mysql_query("insert into $table_modules_params"."(id,id_module,text) values('$p','$var','".addslashes($this->getParam($p))."')");
	    echo mysql_error();
	}
    }
  } // end func


  function process(){
  } // end func


  /* Renvoie la sortie du module */
  function out(){
  } // end func

	
  function show(){
    print $this->out();
  } // end func

	
  function substParam($str,$vararray){
    while (list($k,$v)=each($vararray)) {
	$str=str_replace("[[".$k."]]",$v,$str);
    }
    return $str;
	    
  } // end func

    /*
     * Fonction de remplacement de paramtres
     *
     * Cette fonction remplace dans une chaine les variables 
     * des tableaux GET, POST, SESSION, GLOBALS par leurs valeurs
     *
     * @return	string	 Chaine avec les valeurs remplaces
     */
  function replace_params($chaine,$default_value=FALSE){
    $match=1;
    while ($match) {
	$match=0;
	$regex = 
	  '(.*)'. // sauve ce qu'il y avant
	  '(GET|POST|SESSION|REQUEST|GLOBALS)'. // tableau utilis
	  '\['. // [
	  '([^]]+)'. // l'index
	  '\]'. // ]
	  '(.*)';  // sauve ce qu'il y a aprs
	$match_get  = eregi($regex, $chaine, $result_get);
	if ($match_get){
	    $match=1;
	    $v=$result_get[2];

	    switch($v) {
	    case 'GET': $val=$_GET[$result_get[3]]; break;
	    case 'POST': $val=$_POST[$result_get[3]]; break;
	    case 'SESSION': $val=$_SESSION[$result_get[3]]; break;
	    case 'REQUEST': $val=$_REQUEST[$result_get[3]]; break;
	    case 'GLOBALS': $val=$GLOBALS[$result_get[3]]; break;
	    }

	    $chaine = str_replace( $result_get[2].'['.$result_get[3].']', (string) $val, $chaine );
	}
    }
    return $chaine;
  }    

}
?>
