<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * Display documents of the CMS for a section. 
 */

$dir = './lib/cms/';
require_once ($dir.'cms.php');

class wm_cms_display_obj extends webmodule 
{
    var $section;
    var $document_url;
    var $version;
    var $object;
    var $mode;

    function wm_cms_display_obj($id='wm_cms_display_obj')
    {
        $this->params=array(
                );
        cms_create_common();
        parent::webmodule($id);
    }

    function process() 
    {
        global $cms_common;
        $this->back_link = $_GET['back_link'];
        $this->section = $_GET['section'];
        $this->document_url = $_GET['document_url'];
        $this->version = $_GET['version'];
        
        if ($_GET['download'] == '1')
            $this->mode='download';
        else if ($_GET['view'] == '1')
            $this->mode='view';
        else if ($_GET['thumbnail'] == '1')
            $this->mode='thumbnail';
        else
            $this->mode='display_all';

        $tbl_ver = $cms_common->sql_table['version'];
        $tbl_doc = $cms_common->sql_table['document'];

        $join = Array();
        $join[] = Array(
                'table' => $tbl_doc,
                $tbl_doc.'.no' => $tbl_ver.'.document'
                );
        $object_no = q_read_field(
                $tbl_ver.'.no',
                $tbl_ver,
                Array(
                    $tbl_doc.'.section' => $this->section,
                    $tbl_doc.'.url' => $this->document_url,
                    $tbl_ver.'.version' => $this->version),
                $join);
        $this->object =& $cms_common->get_object($object_no);
    }

    function out() {

        if( ($this->mode) == 'display_all' ){
            $this->display();
        }
        
        elseif ( !method_exists ( $this->object, $this->mode) ){
            Erreur('Fonction ' . $this->mode . ' non disponible.');
            $this->display();
        }
        
        else{
            $function = $this->mode;
            $this->object->$function();                       
            die();
        }

    }

    function display() {    
        global $_OUT, $cms_common;

        // Get published version
        $pub = $cms_common->get_published_version($this->object->document->no);
        if ($pub !== false) $pub_version = $pub['version']; else $pub_version = -1;

        $xtpl = new XTemplate('./templates/F/cms_manager/show_version.xtpl');
        $xtpl -> assign('back_link', $this->back_link);
        $xtpl -> assign('modid', $this->id);
        $xtpl -> assign('document_no', $this->object->document->no);
        $xtpl -> assign('document_name', $this->object->document->title);
        $xtpl -> assign('author', 
                $this->object->document->author->name.' '.
                $this->object->document->author->first_name);
        $xtpl -> assign('creation_date', FormateTimestamp($this->object->document->creation_date));
        $xtpl -> assign('date', FormateTimestamp($this->object->date));
        $xtpl -> assign('lang', $this->object->document->lang);
        $xtpl -> assign('auteur_prenom', $this->object->document->auteur->prenom);
        $xtpl -> assign('no', $this->object->version_no);
        $xtpl -> assign('version', $this->object->version);
        $xtpl -> assign('html', $this->object->out('detail'));
        $xtpl -> assign('url', $this->object->get_url());
        $xtpl -> assign('icon', $this->object->get_icon());
        $xtpl -> assign('icon_alt', $this->object->get_icon_alt());

        $state = $cms_common->get_object_state($this->object, $pub_version);
        $xtpl -> assign('state', $state);          
        
        if ($pub_version == $this->object->version) {
            $xtpl -> assign('publication_date', FormateTimestamp($pub['date']));
            $xtpl->parse('main.publication');        
        }
        
        $xtpl->parse('main');
        
        $_OUT[$this->zone].= $xtpl->text('main');
    }
}
?>
