<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * Display documents of the CMS for a section. 
 */

$dir = './lib/cms/';
require_once ($dir.'cms.php');

class wm_cms_manager extends webmodule 
{
    var $section;
    var $mode;
    var $manager;

    function wm_cms_manager($id='wm_cms_manager')
    {
        global $cms_common;
        $this->params=array(
            'event_new_doc' => '',
            'event_remove_doc' => ''
                );
        $this->paramsComment['event_new_doc'] =
            '<p>Fonction PHP appele lorsqu\'un nouveau document est cre '.
            '(reoit le document en argument)</p>';
        $this->paramsComment['event_remove_doc'] =
            '<p>Fonction PHP appele lorsqu\'un document est supprim '.
            '(reoit le document en argument)</p>';
        
        $this->section = $_REQUEST['section'];

        cms_create_common();
        cms_create_manager();
        
        parent::webmodule($id);
    }

    function process() 
    {
        global $cms_manager;

        if (!$this->section) {
            $this->mode = 'select_section';
            return;
        }

        $action = $_REQUEST['action'];
        switch ($action)
        {
            case 'historic':
            case 'edit_version':
            case 'edit_new_version':
            case 'new_document':
            case 'edit_document':
            case 'remove_version': 
            case 'remove_document': 
                $this->mode = $action;
                break;
            case 'publish': $cms_manager->publish(); break;
            case 'unpublish': $cms_manager->unpublish(); break;
            case 'save_version': $cms_manager->save_version('update'); break;
            case 'save_new_version': $cms_manager->save_version('new_version'); break;
            case 'save_document': $cms_manager->save_document(); break;
            case 'save_new_document':
                $event = $this->getParam('event_new_doc');
                $cms_manager->save_new_document($event);
                break;
            case 'do_remove_version': $cms_manager->remove_version(); break;
            case 'do_remove_document':
                $event = $this->getParam('event_remove_doc');
                $cms_manager->remove_document($event); break;
                break;
            default: $this->mode = 'display_all';
        }
    }

    function out()
    {
        global $_OUT, $cms_manager;

        $txt = false;
        switch ($this->mode)
        {
            case 'remove_version':
                $txt = $cms_manager->confirm_remove_version(); 
                break;
            case 'remove_document':
                $txt = $cms_manager->confirm_remove_document(); 
                break;
            case 'edit_version':
            case 'edit_new_version':
                $txt = $cms_manager->edit_version($this->mode=='edit_new_version');
                break;
            case 'edit_document':
                $txt = $cms_manager->edit_document();
                break;
            case 'historic':
                $txt = $cms_manager->historic();
                break;
            case 'new_document':
                $txt = $cms_manager->edit_new_document();
                break;
            case 'select_section':
                $txt = $cms_manager->select_section();
                break;
            case 'display_all':
            default:
                $txt = $cms_manager->display_all();
        }
        if ($txt) $_OUT[$this->zone] .= $txt;
    }
}
?>
