<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * CMS.
 */

$dir = './lib/cms/';
require_once ($dir.'cms.php');

class wm_cms_search extends webmodule {
    var $keywords;
    var $and;
    var $published;
    var $sql_result;
    var $mode;

    function wm_cms_search($id='wm_cms_search'){
        $this->params=array(
            'full_search_rights' => '100');
        $this->paramsComment['full_search_rights'] =
            '<p>Droits minimum pour avoir accs  la recherche complte '.
            '(document non publis)</p>';
        cms_create_common();
        webmodule::webmodule($id);
    }

    function process() {
        $this->mode='all';
        if (HtmlLitVar('keywords')) {
            $this->keywords = HtmlLitVar('keywords');
            $this->and = (HtmlLitVar('and')==1);
            $this->published = HtmlLitVar('published')=='on';
            
            $this->keywords = cms_str2keywords($this->keywords);
            if ($this->keywords != '')
                $this->mode='search';
            else
                Message('Vous n\'avez saisi aucun mot-cl !');
        }
    }
    
    // Search by keywords
    // Return false if keywords string was empty
    function search() {
        global $cms_common;

        $sql_field = 'full_text';
        
        // Where statement
        if ($this->and)
            $where_op = ' AND ';
        else
            $where_op = ' OR ';
        $kw = explode (' ',$this->keywords);
        $where = '';
        foreach ($kw as $word) {
            if ($where != '') $where .= $where_op;
            $where .= $sql_field.' LIKE "%'.$word.'%"';
        }
        
        $this->sql_result=$cms_common->search_object($this->published,$where,'date DESC');
    }

    function out(){
        global $_OUT;
        $no_result = false;
        if ($this->mode=='search') {
            $txt = $this->display_search();
            if ($txt === false) $no_result = true;
        }
        if ($this->mode=='all' || $no_result) {
            $txt = $this->display_all($no_result);
        }
        $_OUT[$this->zone] .= $txt; 
    }

    function display_search() {
        global $cms_common;
        $this->search();
        if (q_num_rows($this->sql_result)==0) return false;

        $xtpl = new XTemplate('./templates/F/cms_search/search_result.xtpl');
        $xtpl -> assign('modid', $this->id);
        $xtpl->assign('keywords', $this->keywords);
        $xtpl->assign('and', $this->and);
        while ($row = q_fetch($this->sql_result)) {
            $version_no = $row[0];
            $obj =& $cms_common->get_object($version_no);
            $xtpl->assign('no', $obj->version_no);
            
            $xtpl->assign('date', FormateTimestampDate($obj->date));
            $xtpl->assign('nom', $obj->document->title);
            $xtpl->assign('html', $obj->out('list'));
            
            $back = '../../../'.$GLOBALS['page'].'.html';
            $url = 'cms/'.$obj->document->section.'/'.$obj->document->url;
            $url .= '/version'.$obj->version.'.html';
            $url .= '?back_link='.urlencode($back);

            $xtpl->assign('url', $url);
            
            $xtpl->assign('icon', $obj->get_icon());
            $xtpl->assign('icon_alt', $obj->document->document_type->title);

            if (!$this->published) {
                $xtpl->assign('version', $obj->version);
                $xtpl->parse('main.object.version');
            }
            
            $xtpl->parse('main.object');
            $cms_common->unregister_object($obj);
        }
        $xtpl->parse('main');
        return $xtpl->text('main');
    }
 
    
    function display_all($no_result) {
        $xtpl = new XTemplate('./templates/F/cms_search/search.xtpl');
        $xtpl->parse('main.form_search');
        if ($no_result) {
            $xtpl->assign('keywords',$this->keywords);
            $xtpl->parse('main.noresult');
        }
        $xtpl->parse('main');
        return $xtpl->text('main');
    }
}
?>
