<?php

    /*********************************************************************************
     *   Copyright (c) 2004 The 2le development team                                 *
     *********************************************************************************/
     
    /*********************************************************************************
     *                                                                               *
     *   This file is part of CASTOR.                                                *
     *                                                                               *
     *   CASTOR is free software; you can redistribute it and/or modify              *
     *   it under the terms of the GNU General Public License as published by        *
     *   the Free Software Foundation; either version 2 of the License, or           *
     *   (at your option) any later version.                                         *
     *                                                                               *
     *   CASTOR is distributed in the hope that it will be useful,                   *
     *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
     *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
     *   GNU General Public License for more details.                                *
     *                                                                               *
     *   You should have received a copy of the GNU General Public License           *
     *   along with CASTOR; if not, write to the Free Software                       *
     *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
     *                                                                               *
     *********************************************************************************/


/**
 * webmodule.
 *
 * module web, gestion des entres, sorties.
 * @author
 * @version      1.0
 * @copyright
 * @since
 * @access       public
 */

class wm_emailing extends webmodule {

   var $docstring = "Module d'emailing.<br>Les champs utiliss pour la personnalisation d'un mail doivent tre compris dans la requte <email_sql> et le premier doit correspondre  l'adresse email.";
/**
 * Constructeur.
 *
 * Detail description
 * @param
 * @since     1.0
 * @access    private
 * @return    void
 * @throws
**/

	function wm_emailing($id='wm_emailing') {
		$this->params=array(
		    "from_mail" => "",
		    "expediteur" => "",
		    "emailing_dir" => "",
			"email_sql" => "",
			"select_sql" => "",
			"template_saisie_email" => "",
			"template_stats" => "",
			"persistVars" =>""
		);
		$this->paramsType=array(
			"email_sql" => "textarea",
			"select_sql" => "textarea",
			"template_saisie_email" => "templates",
			"template_stats" => "templates"
		);
		webmodule::webmodule($id);
	}

	/**
	 * Short description.
	 *
	 * Detail description
	 * @param
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws
	 */

	function initModule(){
		
		$this->saveParamToDb();
		parent::initModule();
	}

	/**
	 * Short description.
	 *
	 * Detail description
	 * @param
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws
	 */
	function process() {

		// Pour les logs
        global $BODY, $subject, $from, $expediteur, $cpt, $nbre_ok;    

        $var_name = $this->id.'_mail_body';

        if (isset($_POST[$var_name]) && $_POST[$var_name] != '') {
            // On envoit le mail
            $var_name2 = $this->id.'_mail_subject';
            $desti = array();
            $sql = $this->getParam("email_sql");
            //echo  $sql;
            $match = eregi('SELECT(.*)FROM.*',$sql, $result);
            if ($match) {
                $listeChamps = split(',',$result[1]);
                for ($i=0;$i<count($listeChamps);$i++) {
                     $listeChamps[$i] = trim($listeChamps[$i]);
                     $match = eregi('.* as (.*)',$listeChamps[$i], $result);
                     if ($match) $listeChamps[$i] = $result[1];
                     $match = eregi('.*\.(.*)',$listeChamps[$i], $result);
                     if ($match) $listeChamps[$i] = $result[1];
                }
            }
            
			$res = mysql_query($this->replace_params($sql));
			
			while ($row = mysql_fetch_row($res)) array_push($desti,$row);
			
			$BODY = $_POST[$var_name];
			$subject = $_POST[$var_name2];
			$from = $this->getParam("from_mail");
			$expediteur = $this->getParam("expediteur");

            // Entete content-type
            if ($_POST["html"] == 1){
                $BODY = "<HTML>\n\r<BODY>\n\r" . $BODY . "</BODY>\n\r</HTML>\n\r";
                $content_type='text/html';
            }
            else{
                $content_type='text/plain';
            }

            $subject = stripslashes($subject);
            $BODY = stripslashes($BODY);

            // Envoi par script externe
            if($_POST["mode_smtp"] == 'cgi'){

                // Traitement du body
                $BODY = str_replace("\n", "", $BODY);
                $BODY = str_replace("\r", "", $BODY);
                
                // Les destinataires
                for ($cpt=0;$cpt<count($desti);$cpt++) {
                    $bloc_data .= "DATA:".join(";",$desti[$cpt]).";\n";
                }

                // Creation du fichier .mail
                $fichier = fopen($this->getParam("emailing_dir").date("YmdHis").".mail", "a-");
                fwrite($fichier,"CONTENT:$content_type\n");
                fwrite($fichier,"FROM:$expediteur <$from>\n");
                fwrite($fichier,"SUJET:$subject\n");
                fwrite($fichier,"TEXTE:" . $BODY . "\n");
                fwrite($fichier,"EMAIL:".$listeChamps[0]."\n");
                fwrite($fichier,"DATAVAR:".join(";",$listeChamps).";\n");
                fwrite($fichier, $bloc_data);
                fclose($fichier);
            }
            // Envoi par php
            else{
                // en-ttes de mail
                $handle = fopen("emailing.log", "wb");
                fwrite($handle, "Emailing du ".date("d/m/Y")."\n\n");
                $headers .= "From: $expediteur <$from>\n";
                $headers .= "Sender: <$from>\n";
                $headers .= "X-Sender: <$from>\n";
                $headers .= "X-Mailer: PHP\n"; // maileur
                $headers .= "Reply-To: <$from>\n";
                $headers .= "Return-Path: <$from>\n";  // Re-chemin de retour pour les erreurs
                $headers .= "Content-Type: $content_type; charset=iso-8859-1\n"; // Type MIME
                set_time_limit(3600);

                for ($cpt=0;$cpt<count($desti);$cpt++) {
                    $message = "<!-- BEGIN:main -->$BODY<!-- END:main -->";
                    $xtpl =  new XTemplate("");
                    for ($i=0;$i<count($desti[0]);$i++) $xtpl->assign($listeChamps[$i],$desti[$cpt][$i]);
                    $xtpl->XTemplateStr($message);
                    $xtpl->parse("main");
                    $message = $xtpl->text("main");
                    unset($xtpl);
                    //echo $desti[$cpt][0]."<br>";
                    $retour = mail($desti[$cpt][0], $subject, $message, $headers, "-f" . $from);
                    if ($retour) fwrite($handle, "OK : ".$desti[$cpt][0]."\n");
                    else fwrite($handle, "___ECHEC___ : ".$desti[$cpt][0]."\n");
                }
                fclose($handle);
            }

            // Log dans db
            $this->log( "emailing", $sql );
        }
        else {
             // On rcupre la liste des slections
             $var_name2 = $this->id.'_select_dest';
             global $$var_name2;
             $$var_name2 = '<SELECT name="'.$this->id.'_destinataires">';
             $res = mysql_query($this->getParam("select_sql"));
             while ($row = mysql_fetch_row($res)) $$var_name2 .= '<OPTION value="'.$row[0].'">'.$row[1].'</OPTION>';
             $$var_name2 .= '</SELECT>';
             // Que l'on insrera dans le template  l'aide de par exemple {PHP.post_mail_select_dest}
        }
	}
	
	/**
	 * renvoie la sortie du module.
	 *
	 * Detail description
	 * @param
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws
	 */
	function out() {
	
	    global $_OUT, $listeChamps;
	    $var_name = $this->id.'_mail_body';
        if (isset($_POST[$var_name]) && $_POST[$var_name] != '') {
             // On affiche le template de stats
             $xtpl = new XTemplate ($this->getParam("template_stats"),"main",false);
             $xtpl -> parse("main");
             $_OUT[$this->zone] .= $xtpl -> text("main");
        }
        else {

            // On dtermine les champs de personnification disponibles.
            $sql = $this->getParam("email_sql");
            $match = eregi('SELECT(.*)FROM.*',$sql, $result);
            if ($match) {
                $listeChamps = split(',',$result[1]);
                for ($i=0;$i<count($listeChamps);$i++) {

                     $listeChamps[$i] = trim($listeChamps[$i]);
                     $match = eregi('.* as (.*)',$listeChamps[$i], $result);
                     if ($match) $listeChamps[$i] = $result[1];
                     $match = eregi('.*\.(.*)',$listeChamps[$i], $result);
                     if ($match) $listeChamps[$i] = $result[1];
                     $listeChamps[$i] = '{'.$listeChamps[$i].'}';
                }
            }
            $listeChamps = join(', ',$listeChamps);

             // On affiche le formulaire d'emailing
             $xtpl = new XTemplate ($this->getParam("template_saisie_email"),"main",false);
             $xtpl -> parse("main");
             $_OUT[$this->zone] .= $xtpl -> text("main");
        }
	} // end func
}
?>
