#!/usr/bin/perl

# 17/05/02 --- 2le/cj --- emailing_quizz.pl --- lecture de fichier(s) de format "YmdHis".mail et envoi mail 
# tat de fonctionnement : ok le 23/05/02 cj
#
# 05/05/03 --- 2le/ym --- emailing.pl --- Adaptation pour Direct News
# 

# Module
use Getopt::Long;
use SendMail;

# Mode debug  1 ou 0
$DEBUG=0;

# Adresse du serveur SMTP par defaut
$SMTP="localhost";

# Chemin du repertoire contenant les fichiers de mailing par defaut
$PATH_MAILING="/data/httpd/2le.net/www/nef/emailings";

# Parametrage de l'applicatif via la ligne de commande
&GetOptions("smtp:s" => \$SMTP, "path:s" => \$PATH_MAILING, "help" => \$opt_help, "format" => \$opt_format);

# Aide  la ligne de commande
if($opt_help){
    print "\n--smtp: nom du serveur smtp\n";
    print "        ( defaut: $SMTP )\n";
    print "--path: chemin vers le repertoire contenant les fichiers .mail  envoyer\n";
    print "        ( defaut: $PATH_MAILING )\n";
    print "--format: Descriptif du format du fichier .mail\n";    
    print "--help: aide\n\n";
    exit;
}

# Aide au formatage du fichier .mail
if($opt_format){
    print "\nDescriptif du format du fichier .mail:\n";
    print "--------------------------------------\n\n";
    print "Content: Content-type du mail.\n";
    print "     exemple=>CONTENT:text/plain\n\n";    
    print "FROM: Expediteur du mail.\n";
    print "     exemple=>FROM: Prenom Nom <adresse\@email.domaine>\n\n";
    print "SUJET: Sujet du mail\n";
    print "     exemple=>SUJET:Mail de test\n\n";    
    print "TEXTE: Texte du mail avec les champs  remplacer.\n";
    print "     exemple=>TEXTE:Monsieur {nom} {prenom} de la societe {societe}, votre email est {email}\n\n";
    print "EMAIL: Nom du champ contenant l'adresse email du destinataire dans la section DATAVAR.\n";
    print "     exemple=>EMAIL:email\n\n";
    print "DATAVAR: Nom des champs  remplacer dans le texte\n";    
    print "     exemple=>DATAVAR:nom;prenom;societe;email;\n\n";
    print "DATA: Les donnes  remplacer dans le texte et l'adresse email du destinataire\n";
    print "     exemple=>DATA:Dupont;Bernard;Soc & comp;dupont.bernard\@email.net;\n\n";    
    exit;
}

# Traitement pour chaque fichier .mail prsent dans le rpertoire 
foreach $nomfichier (glob("$PATH_MAILING/*.mail")) {
    # Marquer le fichier comme trait
    rename $nomfichier, $nomfichier . ".send";
    
    # Rangement des donnes dans une table de Hash
    %variable=();

    # Ouverture du fichier
    open (FICHIER, $nomfichier . ".send");

    # Parcours du fichier ligne par ligne    
    while ( $ligne=<FICHIER> ){
        $ligne =~ /^([A-Z]+):(.*)$/;
        $val = $2;
        $variable{$1}.=$val;
    }

    # Fermeture du fichier
    close(FICHIER);    
        
    # Structure et donnes en tableaux
    @dataVar = split (/;/, $variable{"DATAVAR"});
    @data = split (/;/, $variable{"DATA"});

    # Nombre d'lments dans les tableaux
    $nbDataVar = scalar(@dataVar);
    $nbData    = scalar(@data);

    # Infos de debug
    if($DEBUG){
       print "nbDataVar:$nbDataVar\n";            
       print "nbData:$nbData\n\n";                        
    }

    # Ouverture du fichier en ecriture
    open (FICHIER, ">>" . $nomfichier . ".send");
    
    $cptData=0;
    while($cptData < $nbData){
        $texte_mail = $variable{"TEXTE"};
        for($i=0;$i<$nbDataVar;$i++){
            if($dataVar[$i] eq $variable{"EMAIL"}){
                $destinataire=$data[$cptData];
            }
            
            $texte_mail=~ s/{$dataVar[$i]}/$data[$cptData]/;
            $cptData++;            
            
            # Infos de debug
            if($DEBUG){            
                print "********************\n";            
                print "DataVar:$dataVar[$i]\n";
                print "Data:", $data[$cptData-1], "\n";            
                print "i:$i\n";            
                print "cptData:", $cptData-1, "\n";                        
            }
        }

        $mail = new SendMail($SMTP);

        if($DEBUG){        
            print "********************\n";
            print "INFO DEBUG SENDMAIL:\n\n";            
            $mail->setDebug($mail->ON);
        }

        # Paramtrage du mail
        # et envoi
        $mail->Content($variable{"CONTENT"});
        $mail->To($destinataire);        
        $mail->From($variable{"FROM"});
        $mail->Subject($variable{"SUJET"});
        $mail->setMailBody($texte_mail);
    	if ($mail->sendMail() != 0) {
            chomp($mail->{'error'});
            chop($mail->{'error'});
            print FICHIER "\n\n***Erreur(SMTP): " . $mail->{'error'} . " ***\n";
            print FICHIER "CONTENT:", $variable{"CONTENT"}, "\n";                                    
            print FICHIER "TO:", $destinataire, "\n";                        
            print FICHIER "FROM:", $variable{"FROM"}, "\n";            
            print FICHIER "SUJET:", $variable{"SUJET"}, "\n";
            print FICHIER "MAIL:\n", $texte_mail, "\n";            
        }          
        else{
            print FICHIER "\n*** Ok pour $destinataire ***";            
        }

        # Infos de debug
        if($DEBUG){                    
            print "\n********************\n";                        
            print "CONTENT:", $variable{"CONTENT"}, "\n";                                                
            print "TO:", $destinataire, "\n";                        
            print "FROM:", $variable{"FROM"}, "\n";            
            print "SUJET:", $variable{"SUJET"}, "\n";
            print "MAIL:\n", $texte_mail, "\n";
            print "--------------------\n\n";
            
        }
    }
    
    # Fermeture du fichier
    close(FICHIER);
}
