<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/**
 * Module permettant de lire le contenu d'un fichier.
 *
 * module web, gestion du menu.
 * @author       
 * @version      1.0
 * @copyright    
 * @since        
 * @access       public
 */

class wm_error_document extends webmodule {
    var $status;

    function wm_error_document($id='wm_error_document')
    {
        $this->params=array(
                'timeout' => 30,
                'template_401' => './templates/F/error_document/401.xtpl',
                'template_404' => './templates/F/error_document/404.xtpl'
                );
        $this->paramsComment['timeout'] = 
            '<p>Nombre de secondes avant la redirection vers la page d\'accueil de Castor. '.
            'Si ngatif, il n\'y a pas de redirectment automatique.</p>';
        parent::webmodule($id);
    }

    function process() {
        $this->status = $_SERVER['REDIRECT_STATUS'];
    }


    function template($file, $def) {
        $xtpl = new XTemplate($file);
        $xtpl->assign($def);
        $xtpl->parse('main');
        return $xtpl->text('main');
    }

    /**
     * renvoie la sortie du module.
     */
    function out()
    {
        global $_OUT, $url_base;
        
        $timeout = $this->getParam('timeout');
        $url = $GLOBALS['url_base'];
        $request = ereg_replace('^'.$url_base, '/', $_SERVER['REQUEST_URI']);
        
        switch ($this->status) {
        case 401:
            $GLOBALS['page'] = '';
            $def = Array('request' => $request);
            $txt = $this->template($this->getParam('template_401'),$def);
            if (0<=$timeout)
                $_OUT['head'] .= '<meta http-equiv="refresh" content="'.$timeout.'; url='.$url.'" />';
            break;
        case 404:
            $GLOBALS['page'] = '';
            $def = Array('request' => $request);
            $txt = $this->template($this->getParam('template_404'),$def);
            if (0<=$timeout)
                $_OUT['head'] .= '<meta http-equiv="refresh" content="'.$timeout.'; url='.$url.'" />';
            break;
        }
        $_OUT[$this->zone] .= $txt; 
    }
}
?>
