<?php

    /*********************************************************************************
     *   Copyright (c) 2004 The 2le development team                                 *
     *********************************************************************************/
     
    /*********************************************************************************
     *                                                                               *
     *   This file is part of CASTOR.                                                *
     *                                                                               *
     *   CASTOR is free software; you can redistribute it and/or modify              *
     *   it under the terms of the GNU General Public License as published by        *
     *   the Free Software Foundation; either version 2 of the License, or           *
     *   (at your option) any later version.                                         *
     *                                                                               *
     *   CASTOR is distributed in the hope that it will be useful,                   *
     *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
     *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
     *   GNU General Public License for more details.                                *
     *                                                                               *
     *   You should have received a copy of the GNU General Public License           *
     *   along with CASTOR; if not, write to the Free Software                       *
     *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
     *                                                                               *
     *********************************************************************************/

/**
 * wm_form
 *
 * module web, gestion du menu.
 * @author       
 * @version      1.0
 * @copyright    
 * @since        
 * @access       public
 */
 
class wm_formmail extends webmodule {
	
	/**
	 * Description
	 * @var       
	 * @since     1.0
	 * @access    private
	 */
	var $docstring = "
                      Module de gestion de formulaire.<br>
                      => Pour un champ texte,    nom du champ:text:obligatoire(0 ou 1):intitule<br>
                      => Pour un champ cach,    nom du champ:hidden:obligatoire(0 ou 1):valeur du champ<br>
                      => Pour un champ select,   nom du champ:select:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','<br>
                      => Pour un champ checkbox, nom du champ:checkbox:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','<br>                      
                      => Pour un champ radio,    nom du champ:radio:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','<br> 
                     ";

	function wm_formmail($id='wm_formmail'){
		$this->params=array(
			"champ"  => "",
			"email_dest"  => "",
			"subject"  => "",            
			"redirect"  => "",            
			"template_form" => "",
			"template_redirect" => ""
		);

		$this->paramsType=array(
			"champ" => "textarea",
            "template_form" => "templates",
            "template_redirect" => "templates"            
		);

		webmodule::webmodule($id);
	}

    /**
    *
    * Initialise le formulaire en fonction des champs dfinis
    *
    * Cette methode initialise le formulaire en fonction des champs dfinis.
    * La nomenclature de ces champs est:
    *     => Pour un champ texte,    nom du champ:text:obligatoire(0 ou 1):intitule
    *     => Pour un champ cach,    nom du champ:hidden:obligatoire(0 ou 1):valeur du champ    
    *     => Pour un champ select,   nom du champ:select:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','
    *     => Pour un champ checkbox, nom du champ:checkbox:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','
    *     => Pour un champ radio,    nom du champ:radio:obligatoire(0 ou 1):intitule:liste des options (libell=>valeur) spar par des ','    
    *    
    */
    function initModule(){
        if( $this->getParam( "champ" ) != '' && $this->getParam( "template_form" ) == '' ){
            // Entete du formulaire
            $formulaire  = "<!-- BEGIN: main -->\n";
            $formulaire .= "<DIV ID=\"" . $this->id . "_form\">\n";        
            $formulaire .= "    <FORM METHOD=\"post\" NAME=\"" . $this->id . "_formmail\" ENCTYPE=\"multipart/form-data\" ACTION=\"lib/formmail.php\">\n";        
            $formulaire .= "        <INPUT TYPE=\"hidden\" NAME=\"recipient\" VALUE=\"{email_dest}\">\n";
            $formulaire .= "        <INPUT TYPE=\"hidden\" NAME=\"redirect\" VALUE=\"{redirect}\">\n";
            $formulaire .= "        <INPUT TYPE=\"hidden\" NAME=\"subject\" VALUE=\"{subject}\">\n";            
            $formulaire .= "        <TABLE>\n";

            // Liste des champs obligatoires
            $require = '';
            
            // Une dfinition de champ par ligne
            $champs = explode( "\n", $this->getParam( "champ" ) );
            foreach( $champs as $champ ){
                $champ = explode( ':', $champ );
                $nom_fonction = trim( "input_" . $champ[1] );
                $this->$nom_fonction( $champ, $formulaire );
                if( $champ[2] ) $require .= $champ[0] . ',';
            }

            // Pied de formulaire
            $formulaire .= "        </TABLE>\n";            
            $formulaire .= "        <INPUT TYPE=\"hidden\" NAME=\"require\" VALUE=\"" . substr( $require, 0, -1 ) . "\">\n";
            $formulaire .= "        <INPUT TYPE=\"submit\" VALUE=\"Valider\">\n";
            $formulaire .= "        <INPUT TYPE=\"reset\" VALUE=\"Annuler\">\n";            
            $formulaire .= "    </FORM>\n";            
            $formulaire .= "</DIV>\n";
            $formulaire .= "<!-- END: main -->\n";

            // Paramtrage du module
            $this->setParam( "template_form", $formulaire );
        }
        
		$this->saveParamToDb();
		parent::initModule();        
    }

    /**
    *
    * Fabrique un champ texte de formulaire
    *
    */
    function input_text( $champ, &$formulaire ){
        $formulaire .= "     <TR>\n";
        $formulaire .= "        <TD>\n";
        $formulaire .= "            <LABEL FOR=\"" . $champ[0] . "_id\">" . trim( $champ[3] ) . "</LABEL>\n";        
        $formulaire .= "        </TD>\n";        
        $formulaire .= "        <TD>\n";        
        $formulaire .= "            <INPUT TYPE=\"text\" id=\"" . $champ[0] . "_id\" NAME=\"" . $champ[0] . "\">\n";
        $formulaire .= "        </TD>\n";                
        $formulaire .= "     </TR>\n";
    }

    /**
    *
    * Fabrique un champ select de formulaire
    *
    */
    function input_select( $champ, &$formulaire ){
        $formulaire .= "     <TR>\n";
        $formulaire .= "        <TD>\n";
        $formulaire .= "            <LABEL FOR=\"" . $champ[0] . "_id\">" . $champ[3] . "</LABEL>\n";        
        $formulaire .= "        </TD>\n";        
        $formulaire .= "        <TD>\n";        
        $formulaire .= "            <SELECT ID=\"" . $champ[0] . "_id\" NAME=\"" . $champ[0] . "[]\">\n";

        // Gnre les champs d'options
        $options = explode( ',', $champ[4] );
        foreach( $options as $option ){
            $option = explode( "=>", $option );
            $formulaire .= "                <OPTION VALUE=\"" . trim( $option[1] ) . "\">" . $option[0] . "</OPTION>\n";
        }
        
        $formulaire .= "            </SELECT>\n";
        $formulaire .= "        </TD>\n";                
        $formulaire .= "     </TR>\n";    
    }

    /**
    *
    * This is the short Description for the Function
    *
    * This is the long description for the Class
    *
    * @return	integer	 Description
    * @access	public
    * @see		??
    */
    function input_checkbox( $champ, &$formulaire ){
        $formulaire .= "     <TR>\n";
        $formulaire .= "        <TD COLSPAN=\"2\">\n";        
        $formulaire .= "            <LABEL FOR=\"" . $champ[0] . "_id\">" . $champ[3] . "</LABEL>\n";
        $formulaire .= "        </TD>\n";                
        $formulaire .= "     </TR>\n";
    
        // Gnre les champs d'options
        $options = explode( ',', $champ[4] );
        foreach( $options as $option ){
            $option = explode( "=>", $option );    
            $formulaire .= "     <TR>\n";
            $formulaire .= "        <TD>\n";        
            $formulaire .= "            <INPUT TYPE=\"checkbox\" ID=\"" . $champ[0] . "_id\" NAME=\"" . $champ[0] . "[]\" VALUE=\"" . trim( $option[1] ) . "\">\n";
            $formulaire .= "        </TD>\n";                        
            $formulaire .= "        <TD>" . $option[0] . "</TD>\n";                
            $formulaire .= "     </TR>\n";
        }        
    }

    /**
    *
    * This is the short Description for the Function
    *
    * This is the long description for the Class
    *
    * @return	integer	 Description
    * @access	public
    * @see		??
    */
    function input_radio( $champ, &$formulaire ){
        $formulaire .= "     <TR>\n";
        $formulaire .= "        <TD COLSPAN=\"2\">\n";        
        $formulaire .= "            <LABEL FOR=\"" . $champ[0] . "_id\">" . $champ[3] . "</LABEL>\n";
        $formulaire .= "        </TD>\n";                
        $formulaire .= "     </TR>\n";
    
        // Gnre les champs d'options
        $options = explode( ',', $champ[4] );
        foreach( $options as $option ){
            $option = explode( "=>", $option );    
            $formulaire .= "     <TR>\n";
            $formulaire .= "        <TD>\n";        
            $formulaire .= "            <INPUT TYPE=\"radio\" ID=\"" . $champ[0] . "_id\" NAME=\"" . $champ[0] . "[]\" VALUE=\"" . trim( $option[1] ) . "\">\n";
            $formulaire .= "        </TD>\n";                        
            $formulaire .= "        <TD>" . $option[0] . "</TD>\n";                
            $formulaire .= "     </TR>\n";
        }        
    }    

    /**
    *
    * This is the short Description for the Function
    *
    * This is the long description for the Class
    *
    * @return	integer	 Description
    * @access	public
    * @see		??
    */
    function input_hidden( $champ, &$formulaire ){
        $formulaire .= "    <INPUT TYPE=\"hidden\" id=\"" . $champ[0] . "_id\" NAME=\"" . $champ[0] . "\" VALUE=\"" . trim( $champ[3] ) . "\">\n";
    }    

	/**
	 * Short description.
	 *
	 * Detail description
	 * @param     
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws    
	 */
	function process(){
    }
    
	/**
	 * renvoie la sortie du module.
	 *
	 * Detail description
	 * @param     
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws    
	 */
	function out(){
        global $_OUT;
		$modid=$this->id;
        if( $_GET["redirect"] == 'y' ){
            $xtpl=new XTemplate($this->getParam( "template_redirect"), "main", FALSE );
        }
        else{
		    $xtpl=new XTemplate($this->getParam( "template_form"), "main", FALSE );
            $xtpl->assign( "email_dest",$this->getParam( "email_dest" ) );
            $xtpl->assign( "redirect",$this->getParam( "redirect" ) );
            $xtpl->assign( "subject",$this->getParam( "subject" ) );
        }
		$xtpl->parse("main");
		$_OUT[$this->zone] .= $xtpl->text("main");        
	}
}


?>
