<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/**
 * webmodule.
 *
 * Gestionnaire d'image.
 * @author       
 * @version      1.0
 * @copyright    
 * @since        
 * @access       public
 */

class wm_imagedb extends webmodule{

    var $maBiblio;
    var $monImage;
    var $mode; // Affiche une image ou la biblio ?
    var $largeurVignette;
    var $hauteurVignette;
    var $arg_optimisation;

    function wm_imagedb($id='imagedb'){
        $this->params=array(
                'chemin_images' => 'imagedb/',
                'css' => 'inc/imagedb.css'
                );
        $this->paramsType=array(
                );

        $this->affiche_image=false;
        $this->largeurVignette=100;
        $this->hauteurVignette=100;

        require_once('inc/outils.php');
        require_once('modules/wm_imagedb/constantes.inc.php');
        require_once('modules/wm_imagedb/class.image.php');
        require_once('modules/wm_imagedb/class.imagemagick.php');
        require_once('modules/wm_imagedb/class.bibliotheque.php');

        parent::webmodule($id);
    }

    function process(){
        global $page;

        // Creation de la bibliotheque
        $racine = './';
        $chemin = $this->getParam('chemin_images');
        if (HtmlLitVar('chemin')) $chemin = HtmlLitVar('chemin');

        // Mode de ImageDB ?
        $this->mode = HtmlLitVar('imagedb');
        if (($page=='imagedb') && ($this->mode=='')) $this->mode='biblio';

        if (HtmlLitVar('image')) $this->operationsSurImage(HtmlLitVar('image'));
        if (HtmlLitVar('supprime')) $this->faireSupprime(HtmlLitVar('supprime'));
        if ($this->mode=='optimisation') $this->configureAutomatique($chemin);
        if (HtmlLitVar('submitOptimisation')) $this->sauveOptimisation($chemin);
        if (HtmlLitVar('renommer_biblio')) {
            $chemin = $this->faireRenommerBiblio ($chemin, HtmlLitVar('renommer_biblio'));
        }

        /*
           if (isset($delBiblio)) $this->faireSupprimeBiblio ($delBiblio);
           $chemin_pere = basename($chemin);
           if ($chemin_pere == 'imagedb') {
           $editable = FALSE;
           $this -> maBiblio = new Bibliotheque($racine, $chemin);
           } else {
           $this->maBiblio = new Bibliotheque($racine, $chemin, $chemin_pere);
           }
         */
        $this->maBiblio = new Bibliotheque($racine, $chemin);

        if (HtmlLitVar('ajout')) 
            $this->faireAjoutImage (HtmlLitVar('ajout'));
        if (HtmlLitVar('ajout_zip')) 
            $this->faireAjoutZip ($chemin, $_FILES['fichier_zip']);
        if (HtmlLitVar('new_repertoire')) 
            $this->faireAjoutRepertoire (HtmlLitVar('new_repertoire'));

        // Gnrer les vignettes
        /*
           if (isset($vignette)) {
           $this->maBiblio->genere_vignettes($this->hauteurVignette, $this->largeurVignette, 'keep_aspect');
           }
         */
    }

    /**
     * renvoie la sortie du module.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function out(){
        global $_OUT;

        $css = $this->getParam('css');
        if ($css!='') $_OUT['head'] .= '<link rel="stylesheet" media="screen" href="'.$css.'" />'."\n";

        switch($this->mode) {
            case 'choix':
                $this->maBiblio->str_template = 'templates/F/imagedb/choix.xtpl';
                $str = '';
                $str  = '<tr><td class="tableheader">ImageDB :</td><td>';
                $str .= $this->maBiblio->affiche();
                $str .= '</td></tr>'."\n";
                $_OUT['head'] .= '<style>'.$this->maBiblio->out_css.'</style>';
                $GLOBALS['imagedb_out'] = $str;
                $str = '';
                break;
            case 'optimisation':
                $xtpl = new XTemplate("templates/F/imagedb/optimisation.xtpl");
                $xtpl->assign($this->arg_optimisation);
                $xtpl->parse("main");
                $str = $xtpl->text('main');
                break;
            case 'image':
                $str = $this->monImage->affiche();
                break;
            case 'biblio':
                $str = $this->maBiblio->affiche();
                break;
            case 'off': 
                break;
        }

        $_OUT[$this->zone] .= $str;
    }

    //-----------------------------------------------------------------------------


    function upFile($filename) {
        // remonte un fichier d'un niveau dans l'arborescence
        $fichier = basename($filename);
        $parent = dirname($filename);
        $newdir = dirname($parent);
        rename($filename,$newdir.'/'.$fichier);
        return $newdir.'/'.$fichier;
    }

    //-----------------------------------------------------------------------------

    function faireOptimiseZip ($chemin, $options) {
        global $config;

        if ($r = $options['resize']) {
            $resize = 1;
            $resize_x = $r[0];
            $resize_y = $r[1];
            $resize_method = $r[2];
        }
        if ($r = $options['crop']) {
            $crop = 1;
            $crop_x = $r[0];
            $crop_y = $r[1];
            $crop_method = $r[2];
        }

        $dir = $chemin.$options['dir'].'/';
        $dh = @opendir($dir);
        if (!$dh) {
            Erreur('Impossible d\'ouvrir le rpertoire '.$dir.' !');
            return;
        }
        while (($file = readdir($dh)) !== false) {
            if ($debug) echo "Fichier : $file\n";
            if ($file == '.' || $file == '..') continue;
            if (!is_file($dir.$file)) continue;
            if (!getimagesize($dir.$file)) continue;

            if ($debug) echo "C'est une image !\n";
            $monImage = new Image($dir.'/'.$file);
            if ($resize == 1) $monImage -> resize($resize_x, $resize_y, $resize_method);
            if ($crop == 1) $monImage -> crop($crop_x, $crop_y, $crop_method);
            $newFile = $this->upFile($dir.$file);
            $monImage = new Image($newFile);
            $monImage->genere_vignette($this->hauteurVignette, $this->largeurVignette, 'keep_aspect');
        }
        closedir($dh);
        rmdirs($dir);
    }

    // Oprations sur une image
    function operationsSurImage ($image) {
        global $config;

        $this->monImage = new Image($image);

        if (HtmlLitVar('resize') == 1) {
            $this->monImage -> resize(HtmlLitVar('resize_x'), 
                    HtmlLitVar('resize_y'), 
                    HtmlLitVar('resize_method'));
        }

        if (HtmlLitVar('crop') == 1) {
            $this->monImage -> crop(HtmlLitVar('crop_x'), HtmlLitVar('crop_y'), 
                    HtmlLitVar('crop_method'));
        }

        if (HtmlLitVar('square') == 1) {
            $this->monImage -> square(HtmlLitVar('square_method'));
        }

        if (HtmlLitVar('monochrome') == 1) {
            $this->monImage -> monochrome();
        }

        if (HtmlLitVar('negative') == 1) {
            $this->monImage -> negative();
        }

        if (HtmlLitVar('flip') == 1) {
            $this->monImage -> flip(HtmlLitVar('flip_method'));
        }

        if (HtmlLitVar('dither') == 1) {
            $this->monImage -> dither();
        }

        if (HtmlLitVar('frame') == 1) {
            $this->monImage -> frame(HtmlLitVar('frame_width'), HtmlLitVar('frame_color'));
        }

        if (HtmlLitVar('rotate') == 1) {
            $this->monImage -> rotate(HtmlLitVar('rotate_angle'), HtmlLitVar('rotate_bgcolor'));
        }

        if (HtmlLitVar('blur') == 1) {
            $this->monImage -> blur(HtmlLitVar('blur_radius'), HtmlLitVar('blur_sigma'));
        }

        if (HtmlLitVar('convert') == 1) {
            $this->monImage -> convert(HtmlLitVar('convert_method'));
        }

        if (!empty($_POST) || HtmlLitVar('reloadBiblio') == 'yes') {
            $this->monImage->genere_vignette($this->hauteurVignette, $this->largeurVignette, 
                    'keep_aspect');
        }

        $this->monImage->load();
    }

    // Optimisation automatique d'un rpertoire
    // Affichage du formulaire
    function configureAutomatique ($chemin) {
        $arg = Array
            ('nom' => HtmlLitVar('nom')
            );

        if (is_file($chemin.".rules")) {
            $arg['auto'] = 'non';
            $arg['redim'] = 'non';
            $arg['coup'] = 'non';
            $fd = fopen ($chemin.".rules", "r");
            while (!feof ($fd)) {
                $buffer = fgets($fd, 4096);
                $ligne = explode(':',$buffer);
                if (count($ligne)==2) {
                    $arg['auto'] = 'oui';
                    $infos = explode(';',$ligne[1]);
                    $dimensions = explode('x',$infos[0]);
                    $m = explode('=',$infos[1]);
                    if (trim($ligne[0])=='redimensionner') {
                        $arg['redim'] = 'oui';
                        $arg['resize_x'] = trim($dimensions[0]);
                        $arg['resize_y'] = trim($dimensions[1]);
                        $methodeRedim = trim($m[1]);
                    }
                    else {
                        $arg['coup'] = 'oui';
                        $arg['crop_x'] = trim($dimensions[0]);
                        $arg['crop_y'] = trim($dimensions[1]);
                        $methodeTaille = trim($m[1]);
                    }
                }
            }
            fclose ($fd);
        } else {
            $arg['auto'] = 'non';
        }

        $this->arg_optimisation=$arg;
    }

    function sauveOptimisation($chemin) {
        if (HtmlLitVar('autoOptimisation') == 1) {
            // On crit de nouvelles rgles
            $handle = fopen($chemin.".rules", "w");
            fwrite($handle, "optimisations automatiques\n");
            if (HtmlLitVar('redimensionne')) {
                fwrite($handle, "redimensionner:".HtmlLitVar('resize_x')."x".HtmlLitVar('resize_y').";mthode=".HtmlLitVar('methodeRedimensionner')."\n");
            }
            if (HtmlLitVar('taille')) {
                fwrite($handle, "tailler:".HtmlLitVar('crop_x')."x".HtmlLitVar('crop_y').";mthode=".HtmlLitVar('methodeTaille')."\n");
            }
            fclose($handle);
        }
        else {
            // On efface toute rgle existante
            if (is_file($chemin.".rules")) unlink($chemin.".rules");
        }
    }

    // Suppression d'une image
    function faireSupprime($supprime) {
        $this->monImage = new Image($supprime);
        $this->monImage->supprime();
        unset($this->monImage);
    }

    // Renommer une bibliothque (un rpertoire)
    // Renvoie le nouveau chemin
    function faireRenommerBiblio($chemin, $newNom) {
        if (($newNom=='') or ($chemin=='')) return;
        $newChemin = dirname($chemin).'/'.$newNom.'/';
        rename($chemin, $newChemin);
        print "$chemin renomm en $newChemin<br>";
        return $newChemin;
    }

    // Suppression d'une bibliotheque (= d'un repertoire)
    function faireSupprimeBiblio ($delBiblio) {
        if ($delBiblio == '') return;
        rmdirs($delBiblio);
        unset($chemin);
    }

    // Ajout d'une image
    function faireAjoutImage ($ajout) {
        global $config;

        $new_image = $this->maBiblio->ajoute_image($_FILES['fichier']);
        if (!$new_image) return;
        $new_image->genere_vignette($this->hauteurVignette, $this->largeurVignette, 'keep_aspect');
        $this->maBiblio->load();
    }

    // Ajout d'images d'un zip
    function faireAjoutZip ($chemin, $fichiers) {
        $r = $this->maBiblio->ajoute_zip($fichiers);
        if ($r == false) return;
        if ($r['action'] == 'optimise') {
            $this->faireOptimiseZip($chemin, $r);
        }
        //$this->maBiblio->genere_vignettes($this->hauteurVignette, $this->largeurVignette, 'keep_aspect', 'missing');
    }	

    // Creation d'un repertoire
    function faireAjoutRepertoire ($new_repertoire)
    {
        $this->maBiblio->ajoute_repertoire($new_repertoire);
    }


}
?>
