<?php
/*
 *
 */
class Image
{
  var $str_fichier;
  var $int_taillefichier;
  var $str_repertoire;
  var $str_extension;

  var $str_nomimage;
  var $str_typeimage;
  var $int_largeur;
  var $int_hauteur;
  var $str_taillehtml;

  var $object_vignette;

  var $str_template;

  /*
   *
   */
  function Image ($str_fichier)
  {
      global $rootpath;
      $str_template = $rootpath.'/templates/F/imagedb/image.xtpl';

      $this->set_fichier($str_fichier);
      $this->set_template($str_template);
      $this->load();
  }

  /*
   *
   */
  function affiche ()
  {
      $object_template = new XTemplate($this->get_template());

      $object_template->assign('image', $this->get_fichier());
      $object_template->assign('repertoire', $this->get_repertoire());
      $object_template->assign('nomimage', $this->get_nomimage());
      $object_template->assign('typeimage', $this->get_typeimage());
      $object_template->assign('largeur', $this->get_largeur());
      $object_template->assign('hauteur', $this->get_hauteur());
      $object_template->assign('taillehtml', $this->get_taillehtml());
      $object_template->assign('taillefichier', $this->get_taillefichier());
      $object_template->assign('taillehtml', $this->get_taillehtml());
      $object_template->assign('urlimage', $this->get_urlimage());

      if( $object_vignette = $this->get_vignette() ){
	$object_template->assign('vignette', $object_vignette->get_fichier());
	$object_template->assign('vignette_repertoire', $object_vignette->get_repertoire());
	$object_template->assign('vignette_nomimage', $object_vignette->get_nomimage());
	$object_template->assign('vignette_typeimage', $object_vignette->get_typeimage());
	$object_template->assign('vignette_largeur', $object_vignette->get_largeur());
	$object_template->assign('vignette_hauteur', $object_vignette->get_hauteur());
	$object_template->assign('vignette_taillefichier', $object_vignette->get_taillefichier());
	$object_template->assign('vignette_taillehtml', $object_vignette->get_taillehtml());
	$object_template->assign('vignette_urlimage', $object_vignette->get_urlimage());

	$object_template->parse('main.vignette');
      }

      $object_template->parse('main');
      return $object_template->text('main');
  }

  /*
   *
   */
  function genere_vignette ($int_hauteur, $int_largeur, $str_method)
  {
      $str_targetvignette = $this->get_repertoire().'/vignette/';
      if (!is_dir($str_targetvignette)) {
	mkdir($str_targetvignette,0777);
      }
      copy($this->get_fichier(), $str_targetvignette . $this->get_nomimage());

      $object_vignette = new Image($str_targetvignette . $this->get_nomimage());
      $object_vignette->resize($int_hauteur, $int_largeur, $str_method);
      $object_vignette->convert(EXTENSION_VIGNETTE);
  }

  /*
   *
   */
  function supprime ()
  {
      if ($object_vignette = $this->get_vignette()) {
	$object_vignette->supprime_object();
      }
      $this->supprime_object();
  }

  /*
   *
   */
  function load ()
  {
      $array_image_infos = getimagesize($this->get_fichier());
      $array_fichier_infos = stat($this->get_fichier());
      $array_fichiername = pathinfo($this->get_fichier());

      $this->set_extension($array_fichiername['extension']);
      $this->set_repertoire($array_fichiername['dirname']);
      $this->set_nomimage($array_fichiername['basename']);
      $this->set_typeimage($array_image_infos[TYPE_IMAGE]);
      $this->set_largeur($array_image_infos[LARGEUR]);
      $this->set_hauteur($array_image_infos[HAUTEUR]);
      $this->set_taillehtml($array_image_infos[TAILLE_HTML]);
      $this->set_taillefichier($array_fichier_infos[TAILLE_FICHIER]);
      $this->set_vignette();
  }

  /*
   *
   */
  function reload ($str_fichier)
  {
      $this->set_fichier($str_fichier);
      $this->load();
  }

  /*
   *
   */
  function resize ($x, $y, $method)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Resize($x, $y, $method);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function crop ($x, $y, $method)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Crop($x, $y, $method);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function square ($square_method)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Square($square_method);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function monochrome ()
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Monochrome();
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function negative ()
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Negative();
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function flip ($flip_method)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Flip($flip_method);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function dither ()
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Dither();
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function frame ($frame_width, $frame_color)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Frame($frame_width, $frame_color);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function rotate ($rotate_angle, $rotate_bgcolor)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Rotate($rotate_angle, $rotate_bgcolor);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function blur ($blur_radius, $blur_sigma)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Blur($blur_radius, $blur_sigma);
      $object_imagemagick->Save();
      $object_imagemagick->CleanUp();
      $this->load();
  }

  /*
   *
   */
  function convert ($method)
  {
      $object_imagemagick = $this->creer_imagemagick();
      $object_imagemagick->Convert($method);
      $str_fichier = $object_imagemagick -> Save();
      $object_imagemagick->CleanUp();
      $this->reload($str_fichier);
  }

  /*
   *
   */
  function get_fichier ()
  {
      return $this->str_fichier;
  }

  /*
   *
   */
  function get_repertoire ()
  {
      return $this->str_repertoire;
  }

  /*
   *
   */
  function get_taillefichier ()
  {
      return $this->int_taillefichier;
  }

  /*
   *
   */
  function get_extension ()
  {
      return $this->str_extension;
  }

  /*
   *
   */
  function get_nomimage ()
  {
      return $this->str_nomimage;
  }

  /*
   *
   */
  function get_typeimage ()
  {
      return $this->str_typeimage;
  }

  /*
   *
   */
  function get_largeur ()
  {
      return (0+$this->int_largeur);
  }

  /*
   *
   */
  function get_hauteur ()
  {
      return (0+$this->int_hauteur);
  }

  /*
   *
   */
  function get_taillehtml ()
  {
      return $this->str_taillehtml;
  }

  /*
   *
   */
  function get_vignette ()
  {
      return $this->object_vignette;
  }

  /*
   *
   */
  function get_template ()
  {
      return $this->str_template;
  }

  /*
   *
   */
  function get_urlimage ()
  {
      $str_url = './';
      //dirname($_SERVER['PHP_SELF']);
      //'/' . 
      $str_fichier = $this->get_fichier();
      $str_urlImage = $str_url . $str_fichier;
      return $str_urlImage;
  }

  /*
   *
   */
  function set_fichier ($str_fichier)
  {
      $this->str_fichier = $str_fichier;
  }

  /*
   *
   */
  function set_repertoire ($str_repertoire)
  {
      $this->str_repertoire = $str_repertoire;
  }

  /*
   *
   */
  function set_taillefichier ($int_taillefichier)
  {
      $this->int_taillefichier = $int_taillefichier;
  }

  /*
   *
   */
  function set_extension ($str_extension)
  {
      $this->str_extension = $str_extension;
  }

  /*
   *
   */
  function set_nomimage ($str_nomimage)
  {
      $this->str_nomimage = $str_nomimage;
  }

  /*
   *
   */
  function set_typeimage ($int_typeimage)
  {
      if ($int_typeimage == GIF) {
	$this->str_typeimage = 'GIF';
      }
      if ($int_typeimage == JPG) {
	$this->str_typeimage = 'JPG';
      }
      if ($int_typeimage == PNG) {
	$this->str_typeimage = 'PNG';
      }
      if ($int_typeimage == PSD) {
	$this->str_typeimage = 'PSD';
      }
      if ($int_typeimage == BMP) {
	$this->str_typeimage = 'BMP';
      }
  }

  /*
   *
   */
  function set_largeur ($int_largeur)
  {
      $this->int_largeur = 0+$int_largeur;
  }

  /*
   *
   */
  function set_hauteur ($int_hauteur)
  {
      $this->int_hauteur = 0+$int_hauteur;
  }

  /*
   *
   */
  function set_taillehtml ($str_taillehtml)
  {
      $this->str_taillehtml = $str_taillehtml;
  }

  /*
   *
   */
  function set_vignette ()
  {
      $str_nomvignette = str_replace('.' . $this->get_extension(),
				     '.'.EXTENSION_VIGNETTE, 
				     $this->get_nomimage());
      $str_fichiervignette = $this->get_repertoire() . '/vignette/' . $str_nomvignette;

      if (file_exists($str_fichiervignette)) {
	$this->object_vignette = new Image($str_fichiervignette);
      } else {
	$this->object_vignette = FALSE;
      }
  }

  /*
   *
   */
  function set_template ($str_template)
  {
      $this->str_template = $str_template;
  }

  /*
   *
   */
  function toString ($str_format = 'html')
  {
      $str_message = '
Objet Image : 
Fichier : ' . $this->get_fichier() . '
Repertoire : ' . $this->get_repertoire() . '
Taille fichier (octets) : ' . $this->get_taillefichier() . '
Extension : ' . $this->get_extension() . '
Template : ' . $this->get_template() . '
Nom image : ' . $this->get_nomimage() . '
Type image : ' . $this->get_typeimage() . '
Largeur image (pixels) : ' . $this->get_largeur() . '
Hauteur image(pixels) : ' . $this->get_hauteur() . '
Taille en html : ' . $this->get_taillehtml();

      if ($str_format == 'html') {
	$str_message = nl2br($str_message);
      }
      if ($object_vignette = $this->get_vignette()) {
	$str_message .= $object_vignette->toString();
      }

      return $str_message;
  }

  /*
   *
   */
  function creer_imagemagick ()
  {
      $array_infoimage['name'] = $this->get_nomimage();
      $array_infoimage['type'] = 'image/' . $this->get_typeimage();
      $array_infoimage['tmp_name'] = $this->get_fichier();
      $array_infoimage['size'] = $this->get_taillefichier();

      $str_tmp = $this->get_repertoire() . '/tmp/';
      if (!is_dir($str_tmp)) {
	mkdir($str_tmp,0777);
      }
      $verbose = false;

      $object_imagemagick = new ImageMagick($array_infoimage, $str_tmp,$verbose);
      $object_imagemagick->setTargetdir($this->get_repertoire());

      return $object_imagemagick;
  }

  /*
   *
   */
  function supprime_object ()
  {
      unlink($this->get_fichier());
      unset($this);
  }
}

?>
