<?php


/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * Module de gestion des connexions par login:password.
 *
 * Fonction par session PHP :
 * - Variables de sessions : auth_uid, auth_right, auth_last_name,
 *   auth_first_name, auth_email
 * - Variables de sessions si l'utilisateur appartient  un groupe :
 *   auth_gid, auth_group_right
 */

class wm_login extends webmodule{

  var $passLoseSend = 0;

  function wm_login($id='login'){
      $this->params=array(
			  "table_auth" => "fw_users",
			  "table_auth_group" => NULL,
			  "uid_field" => "uid",
			  "gid_field" => NULL,
			  "user_right_field" => "user_right",
			  "group_right_field" => NULL,
			  "last_name_field" => "last_name",
			  "first_name_field" => "first_name",
			  "email_field" => "email",
			  "login_field" => "login",
			  "password_field" => "passwd",
			  "template_login" => "",
			  "template_logged" => "Bonjour {PHP.first_name} {PHP.last_name}",
			  "template_passLose" => "",
			  "template_passLose_OK" => "Votre mot de passe vient de vous tre envoy  l'adresse mail que vous nous avez communique.",
			  "template_passLose_failed" => "L'envoi de votre mot de passe a chou.",
			  "template_mail" => "<!-- BEGIN: main -->Votre accs : {login} / {pass}<!-- END: main -->",
			  "sujet_mail" => "Mot de passe perdu",
			  "zone_passLose" => "content",
			  "sqlGetPass" => "SELECT pass FROM table WHERE clause",
			  "afterCheckCallBack" => ""
			  );
      $this->paramsType=array(
			      "template_logged" => "templates",
			      "template_login" => "templates",
			      "template_passLose" => "templates",
			      "template_passLose_OK" => "templates",
			      "template_passLose_failed" => "templates",
			      "template_mail" => "templates"
			      );
      parent::webmodule($id);
  }

  function check($l, $p) {
      $authentifie = FALSE;
      $authentifie = $this->check_auth($l,$p);
      $afterCheckCallBack = $this->params["afterCheckCallBack"];
      if ($afterCheckCallBack) {
	  $afterCheckCallBack($l, $p, $authentifie);
      }
      return $authentifie;
  }
  
  
  function check_auth($l, $p) {
      $groupe_utilisateur = FALSE;
      if( !empty($this->params["gid_field"]) && !empty( $this->params["group_right_field"] ) && !empty( $this->params["table_auth_group"] ) ){
	  $groupe_utilisateur = TRUE;
      }

      $select = "SELECT ".$this->params["uid_field"].", ".$this->params["user_right_field"].", ".$this->params["last_name_field"].", ".$this->params["first_name_field"].", ".$this->params["email_field"];
      $from = " FROM ".$this->params["table_auth"];
      $where = " WHERE ".$this->params["login_field"]." = '".$l."' AND ".$this->params["password_field"]." ='".$p."'";

      if( $groupe_utilisateur ){
	  $select .= ", " . $this->params["table_auth_group"] . "." .$this->params["gid_field"]. ", " . $this->params["table_auth_group"] . "." . $this->params["group_right_field"];
	  $from   .= " LEFT JOIN " . $this->params["table_auth_group"] . " ON " . $this->params["table_auth"] . "." . $this->params["gid_field"] . "=" . $this->params["table_auth_group"] . "." . $this->params["gid_field"];
      }

      $sql = $select . " " . $from . " " . $where;
      $res = mysql_query($sql);

      if (mysql_num_rows($res)>0){
	  $row = mysql_fetch_row($res);
	  $_SESSION["auth_uid"] = $row[0];
	  $_SESSION["auth_right"] = $row[1];
	  $_SESSION["auth_last_name"] = $row[2];
	  $_SESSION["auth_first_name"] = $row[3];
	  $_SESSION["auth_email"] = $row[4];

	  if( $groupe_utilisateur ){
	      $_SESSION["auth_gid"] = $row[5];
	      $_SESSION["auth_group_right"] = $row[6];
	  }
	  return TRUE;
      }
      else {
	  return FALSE;
      }
  }
  
  function process(){
      global $page;
      if ($_GET["logout"] == 'yes'){
	  // Want to logout
	  session_destroy();
	  $authentifie = FALSE;
	  header("Location: ./".$page.".html");
	  die();
      } else{
	  // Try to login
	  $l = $_POST[$this->id."_login"];
	  $p = $_POST[$this->id."_passwd"];
	  if ($l != '') {
	      if ($this->check($l, $p)) {
		  header("Location: ./".$page.".html");
		  die();
	      } else {
		  Erreur("Le login et/ou le mot de passe fourni est incorrect !");
	      }
	  } 
      }
      if (isset($_REQUEST[$this->id."_sendMe"])) {
	  $req = $this->replace_params($this->getParam("sqlGetPass"));
	  $res = q_query($req);
	  echo $res."<br>";
	  $nb = q_num_rows($res);
	  if ($nb<1) {
	      $this->passLoseSend = 0;
	  }
	  else {
	      $envoi = false;
	      while ($tmp = q_fetch_array($res)) {
		print_r ($tmp);echo '<hr>';
		  $xtpl = new XTemplate($this->getParam("template_mail"),
					"main",false);
		  $xtpl->assign($tmp);
		  $xtpl->parse("main");
		  $envoi |= mail($_REQUEST[$this->id."_sendMe"],
				 $this->getParam("sujet_mail"),
				 $xtpl->text("main"));
	      }
	      $this->passLoseSend = 1;
	      if (!$envoi) $this->passLoseSend = 0;
	  }
	  die();
      }
  }
	
  /**
   * renvoie la sortie du module.
   *
   * Detail description
   * @param     
   * @since     1.0
   * @access    private
   * @return    void
   * @throws    
   */
  function out(){
      global $_OUT;
      global $login_id;
      if (isset($_GET[$this->id."_passLose"])) {
	  $_OUT[$this->getParam("zone_passLose")] .= $this->getParam("template_passLose");
      }
      elseif (isset($_REQUEST[$this->id."_sendMe"])) {
	  if ($this->passLoseSend == 0) $_OUT[$this->getParam("zone_passLose")] .= $this->getParam("template_passLose_failed");
	  else $_OUT[$this->getParam("zone_passLose")] .= $this->getParam("template_passLose_OK");
      }
      if (!isset($_SESSION['auth_right']) || (!isset($_SESSION['auth_group_right']) && $_SESSION['auth_right']==0) ){
	  $login_id = $this->id;
	  $xtpl = new XTemplate($this->getParam("template_login"),true,0);
	  $xtpl->parse("main");
	  $_OUT[$this->zone] .= $xtpl->text("main");
      } else {
	  $xtpl = new XTemplate($this->getParam("template_logged"),true,0);
	  $xtpl->parse("main");
	  $_OUT[$this->zone] .= $xtpl->text("main");
      }
  } // end func
}
?>
