<?php

class Bibliotheque
{
    var $str_nom;
    var $str_racine;
    var $str_chemin;
    var $array_images;
    var $str_template;
    var $array_erreurs;
    var $out_css_test;

    function Bibliotheque ($str_racine = './images/', 
            $str_chemin = './images/', 
            $str_nom = 'Bibliothque d\'images')
    {
        global $rootpath;

        $array_images = array();
        $array_erreurs = array();
        $str_template = $rootpath.'/templates/F/imagedb/bibliotheque.xtpl';

        $this->str_nom = $str_nom;
        $this->str_racine = $str_racine;
        $this->str_chemin = $str_chemin;
        $this->array_images = $array_images;
        $this->array_erreurs = $array_erreurs;
        $this->str_template = $str_template;

        $this->load();
    }

    function affiche($type_sortie='biblio')
    {
        $int_modulo = 4;
        $object_template = new XTemplate($this->str_template);
        $object_template->assign('chemin', $this->str_chemin);

        $array_erreurs = $this->array_erreurs;

        reset($array_erreurs);
        while (list($str_cle, $str_erreur) = each($array_erreurs)) {
            $object_template->assign('erreur', $str_erreur);
            $object_template->parse('main.erreur');
        }

        $array_images = $this->array_images;
        reset ($array_images);
        $i = 0;
        while (list($str_cle, $object_image) = each($array_images)) {
            $image = $object_image->get_fichier();
            $object_template->assign('image', $image);
            $id = strtr($image, '/-.','___');
            $object_template->assign('id', $id);
            $object_template->assign('repertoire', $object_image->get_repertoire());
            $object_template->assign('nomimage', $object_image->get_nomimage());
            $object_template->assign('typeimage', $object_image->get_typeimage());
            $object_template->assign('largeur', $object_image->get_largeur());
            $object_template->assign('hauteur', $object_image->get_hauteur());
            $object_template->assign('taillefichier', $object_image->get_taillefichier());
            $object_template->assign('taillehtml', $object_image->get_taillehtml());
            $object_template->assign('urlimage', $object_image->get_urlimage());

            if ($object_vignette = $object_image->get_vignette()) {
                $object_template->assign('vignette', $object_vignette->get_fichier());
                $object_template->assign('vignette_repertoire', $object_vignette->get_repertoire());
                $object_template->assign('vignette_nomimage', $object_vignette->get_nomimage());
                $object_template->assign('vignette_typeimage', $object_vignette->get_typeimage());
                $object_template->assign('vignette_largeur', $object_vignette->get_largeur());
                $object_template->assign('vignette_hauteur', $object_vignette->get_hauteur());
                $object_template->assign('vignette_taillefichier', $object_vignette->get_taillefichier());
                $object_template->assign('vignette_taillehtml', $object_vignette->get_taillehtml());
                $object_template->assign('vignette_urlimage', $object_vignette->get_urlimage());

                $object_template->parse('main.liste.image.vignette');
                if ($type_sortie=='biblio') {
                    $vignette = $object_vignette->get_fichier();
                    $txt =  "'$id' : Array('$image', '$vignette')";

                    $this->out_css_test .= 'div.liste.imagedb_choix img#'.$id." {\n";
                    $this->out_css_test .= 'width:'.$object_vignette->get_largeur().'px; ';
                    $this->out_css_test .= 'height:'.$object_vignette->get_hauteur().'px; ';
                    $this->out_css_test .= "}\n";

                    if ($i<count($array_images)-1) $txt .= ',';
                    $object_template->assign('javascript', $txt);
                    $object_template->parse('main.javascript');
                }
            }

            if ($type_sortie=='biblio') {
                $object_template->parse('main.liste.image.image' . ($i % $int_modulo));
                $object_template->parse('main.liste.image');
            }
            $i++;
        }
        if (count($array_images)!=0) 
            $object_template->parse('main.liste');
        else
            $object_template->parse('main.liste_vide');

        $array_nom = explode('/', $this->str_racine);
        array_pop($array_nom);
        //    $this->ls($object_template, $this->str_racine, array_pop($array_nom), $int_cpt);

        $object_template->assign('nbreRepertoire', $int_cpt);
        $object_template->assign('nom', $this->str_nom);

        $object_template->parse('main');

        return $object_template->text('main');
    }

    function genere_vignettes ($int_hauteur, $int_largeur, $str_method, $str_option = 'all')
    {
        $array_images = $this->array_images;
        reset ($array_images);
        while (list($str_cle, $object_image) = each($array_images)) {
            if ($str_option == 'all' || !$object_image->get_vignette()) {
                $object_image->genere_vignette($int_hauteur, $int_largeur, $str_method);
            }
        }
        $this->load();
    }

    function checkAutoOpti($chemin, &$image) {
        $debug = false;
        if (!is_file($chemin.".rules")) return;

        $fd = fopen ($chemin.".rules", "r");
        $towork = FALSE;
        while (!feof ($fd)) {
            $buffer = fgets($fd, 4096);
            $ligne = explode(':',$buffer);
            if (count($ligne)==2) {
                $infos = explode(';',$ligne[1]);
                $dimensions = explode('x',$infos[0]);
                $larg = (int)trim($dimensions[0]);
                $haut = (int)trim($dimensions[1]);
                $methode = explode('=',$infos[1]);
                $methode = trim($methode[1]);
                if ($ligne[0] == 'redimensionner') {
                    if ($debug) echo "<p>Resize into ${larg}x${haut} with $methode method.</p>\n";
                    $image->resize($larg,$haut,$methode);
                }
                if ($ligne[0] == 'tailler') {
                    if ($debug) echo "<p>Crop by ${larg}x${haut} with $methode method.</p>\n";
                    $image->crop($larg,$haut,$methode);
                }
            }
        }
        fclose ($fd);
    }


    function ajoute_image ($destination)
    {
        if (!$this->isImage($destionation)) {
            $this->erreur('Le format de l\'image "'
                    .$destination.'" n\'est pas support !');
            return FALSE;

        }
        $object_image = new Image($destination);
        $this->load();
        $this->checkAutoOpti($this->str_chemin, $object_image);
        return $object_image;
    }


    /*
     * Ajoute un zip. Valeurs de retour : false ou un tableau.
     * Dans le cas du table, on peut avoir :
     * - $tab['action'] = 'vignettes' => il faut gnrer des vignettes
     * - $tab['action'] = 'optimise' => Idem, sauf qu'il faut en plus
     *   appliquer $tab['resize'] et $tab['crop'] (si existant)
     */
    function ajoute_zip ($fichier)
    {
        if (!file_exists($fichier['tmp_name'])) {
            $this->erreur('Erreur lors de l\'upload du fichier ZIP '.$fichier['name'].' !');
            return false;      
        }
        if (($fichier['type'] != 'application/x-zip-compressed')
                && ($fichier['type'] != 'application/x-compressed') 
                && ($fichier['type'] != 'application/zip'))
        {
            $this->erreur(
                    'Le fichier '.$fichier['name'].
                    ' ne semble pas tre au format ZIP (format "'.
                        $fichier['type'].'") !');
            return false;
        }

        $nom = $this->str_chemin . $fichier['name'];
        if (file_exists($nom)) {
            $this->erreur($nom. ' dj existant.');
            return false;
        }

        if (!@move_uploaded_file($fichier['tmp_name'], $nom)) {
            $this->erreur('Impossible de renommer ' . $fichier['tmp_name'].' dans '.$nom.' !');
            return false;
        }

        if (!is_file($this->str_chemin.".rules")) {
            // dzippage normal
            exec('/usr/bin/unzip -j -qq '.$this->str_chemin.$fichier['name'].' -d '.$this->str_chemin);
            unlink($this->str_chemin . $fichier['name']);
            return Array('action' => 'vignettes');
        }

        //auto-optimisation
        $result = Array
            (
             'action' => 'optimise',      
            );

        $fd = fopen ($this->str_chemin.".rules", "r");
        $resize_string = "";
        $crop_string = "";
        while (!feof ($fd)) {
            $buffer = fgets($fd, 4096);
            $ligne = explode(':',$buffer);
            if (count($ligne)==2) {
                $infos = explode(';',$ligne[1]);
                $dim = explode('x',$infos[0]);
                $m = explode('=',$infos[1]);

                $action = $ligne[0];
                $larg = trim($dim[0]);
                $haut = trim($dim[1]);
                $methode = trim($m[1]);

                if ($action == 'redimensionner') {
                    $result['resize'] = Array($larg, $haut, $methode);
                }
                if ($action == 'tailler') {
                    $result['crop'] = Array($larg, $haut, $methode);
                }
            }
        }

        // Dcompresse le zip dans le rpertoire <chemin>/unzip_<now>
        // o now est la date courante
        $newDir = "unzip_".strtotime("now");
        $result['dir'] = $newDir;
        mkdir($this->str_chemin.$newDir,0777);
        exec('/usr/bin/unzip -j -qq '.$this->str_chemin.$fichier['name'].' -d '.$this->str_chemin.$newDir);

        // Supprime le zip
        unlink($this->str_chemin . $fichier['name']);
        return $result;
    }	

    function ajoute_repertoire ($str_repertoire)
    {
        $str_new = $this->str_chemin . $str_repertoire . '/';
        if (!is_dir($str_new)) {
            if (!mkdir($str_new, 0777))
                $this->erreur('Impossible de crer le rpertoire '.$str_new);
        } else {
            $this->erreur('Repertoire dj existant');
        }
    }

    function load ()
    {
        $str_chemin = $this->str_chemin;
        $array_images = $this->array_images;

        $pt_repertoire = @opendir($str_chemin);
        if ($pt_repertoire) {
            while ($str_fichier = readdir($pt_repertoire)) {
                if( is_file($str_chemin.$str_fichier) && $this->isImage($str_chemin.$str_fichier) ){
                    $array_images[$str_fichier]= new Image($str_chemin.$str_fichier);
                }
            }
            closedir($pt_repertoire);
            $this->array_images = $array_images;
            return TRUE;

        } else {
            $this->erreur('Erreur d\'ouverture du repertoire <b>' . $str_chemin.'</b>');
            return FALSE;
        }
    }

    function toString ($str_format = 'html')
    {
        $str_message =  '
            Objet Bibliotheque :
            Nom : ' . $this->str_nom . '
            Erreurs : ' . implode( ',', $this->array_erreurs) . '
            Chemin : ' . $this->str_chemin . '
            Template de liste : ' . $this->str_template . '
            Images : ';

        if ($str_format == 'html') {
            $str_message = nl2br($str_message);
        }

        $array_images = $this->array_images;
        reset ($array_images);
        while (list($str_cle, $object_image) = each($array_images)) {
            $str_message .= $object_image->toString($str_format);
        }

        return $str_message;
    }

    function isImage ($str_fichier)
    {
        // Return false si ce n'est une image supporte par la librairie gd
        return getimagesize($str_fichier);
    }

    function erreur ($str_msg)
    {
        Erreur($str_msg);
    }

    function ls (&$xtpl, $str_chemin, $str_repertoire = '', &$int_cpt, $textedecalage = '')
    {
        $xtpl->assign(array('val' => $str_repertoire, 'key' => $str_chemin, 'textedecalage' => $textedecalage));
        $int_cpt++;

        if ($str_chemin) {
            $xtpl->parse('main.arbre.libelle');
        }
        $xtpl->parse('main.arbre');

        $pt_repertoire = @opendir($str_chemin);
        if($pt_repertoire){
            $xtpl->parse('main.arbre.decalage');
            if ($str_chemin) {
                $textedecalage .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
            }
            $xtpl->parse('main.arbre');

            while ($str_repertoire = readdir($pt_repertoire)) {
                if (is_dir($str_chemin . $str_repertoire) && ($str_repertoire != '.') && ($str_repertoire != '..') && ($str_repertoire != 'tmp') && ($str_repertoire != 'vignette') && ($str_repertoire != 'CVS')) {
                    $this->ls($xtpl, $str_chemin . $str_repertoire . '/', $str_repertoire, $int_cpt, $textedecalage);
                }
            }
            closedir($pt_repertoire);
        }	
    }
}
?>
