<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

/*
 * Menu crit  la base pour le site tourisme-lucelle.com : menu
 * vertical permettant de dplier et replier une sous-arborescence. Met
 * la page active en rouge.
 */

class wm_menu_lucelle extends webmodule {


  function wm_menu_lucelle($id='wm_qualif'){
    $this->params=array(
			"tablehierarchie" => "modalite",
			"keyfield" => "no",
			"libfield" => "libelle",
			"parentkeyfield" => "noPere",
			"sql_hierarchie" => "select no,libelle,noPere from modalite where droitMini <= GLOBALS[droit_user] AND droitMaxi >= GLOBALS[droit_user]",
			"linetemplate" => "{lib}",
			"leaftemplate" => "",
			"imagepath" => "images/treemenu",
			'template' => "<div>[tree]</div>",
			'keyistext' => "0",
			'orderby' => 'tri',
			'css' => ""
			);
    $this->paramsType=array(
			    "linetemplate" => "templates",
			    "leaftemplate" => "templates",
			    "template" => "templates",            
			    );
		
    webmodule::webmodule($id);
  }

	
  /**
   * Short description.
   *
   * Detail description
   * @param     
   * @since     1.0
   * @access    private
   * @return    void
   * @throws    
   */
  function process(){
    global $_URLVARS,$HTTP_POST_VARS;

    $tablehierarchie=$this->getParam('tablehierarchie');

    $id=$this->id;
  } // end func


  function out(){
    global $id, $_OUT;

    if ($this->getParam("css")) {
      $css = $this->replace_params( $this->getParam("css") );
      $_OUT["head"].="<link rel=\"stylesheet\" media=\"screen\" href=\"".$css."\">\n";
    }

    $tablehierarchie=$this->getParam('tablehierarchie');
    $keyfield=$this->getParam('keyfield');
    $libfield=$this->getParam('libfield');
    $parentkeyfield=$this->getParam('parentkeyfield');
    $keyistext=$this->getParam('keyistext');
    $sql_hierarchie=$this->replace_params( $this->getParam('sql_hierarchie'));
    $id=$this->id;
    $tab = $this->arbreModalite($tablehierarchie,$keyfield,$libfield,$parentkeyfield,$sql_hierarchie,$keyistext);
    $output_string = $tab[0];
    $tpl=$this->getParam('template');
		
    foreach ($_GET as $gkey => $gvar) {
      $tpl= str_replace("{PHP.".$gkey."}",$gvar, $tpl);
    }        
        
    $o=str_replace('[tree]', $output_string, $tpl);
    if( empty( $this->zone ) ){
      $GLOBALS["OUT_" . $id] = $o;
    }
    else{
      $_OUT[$this->zone].=$o;
    }
  }

  /**
   * Short description.
   *
   * Detail description
   * @param     
   * @since     1.0
   * @access    private
   * @return    void
   * @throws    
   */
  function arbreModalite($table,$keyfield,$libfield,
			 $parentkeyfield,$sqlh,$keyistext,$noPere=0) {
    global $page;

    // Construit la requte SQL
    if ($keyistext) {
      if (!$noPere) {
	$sql=$sqlh." and ( ($parentkeyfield='') or ($parentkeyfield is null) )";
      } else {
	$sql=$sqlh." and $parentkeyfield='$noPere'";
      }
    } else {
      $sql=$sqlh." and $parentkeyfield=$noPere";
    }
    if ($this -> getParam('orderby')!='')
      $sql .= ' order by '.$this -> getParam('orderby');

    // Lance la requte SQL
    $r=mysql_query($sql);
    if (!$r) {
      print $sql.":".mysql_error();
    }

    // Cherche  savoir s'il faut dplier l'arborescence ou non
    $numrow=mysql_num_rows($r);
    $deplie = ($noPere == $page);
    if ($numrow!=0) {
      $i=0;
      while ($row=mysql_fetch_array($r)) {
	if ($row[$keyfield] == $page) { $deplie = true; break; }
      }
      mysql_data_seek ($r, 0);
    }

    // S'il n'y a rien  afficher : exit !
    if ($numrow==0) return "";

    if ($noPere) {
      $str ='<div id="menu_'.$noPere.'" ';
      if (!$deplie) $str .= 'style="display:none"';
      $str .= '>'."\n";
    } else {
      $str="<div id=\"menu_".$noPere."\">\n";
    }


    $imagepath =$this->getParam('imagepath');
    while ($row=mysql_fetch_array($r)) {
      $subtree=$this->arbreModalite($table,$keyfield,$libfield,$parentkeyfield,$sqlh,$keyistext,$row[$keyfield]);
      if ($subtree[0]=='') $substree = false;

      $tpl = '';

      $str.="<li>";
      if ($subtree) {
	$tpl = "<a href=\"#\" onclick=\"switchTreeDiv('menu_{key}','$imagepath');return false;\" class=\"tree\"><IMG SRC=\"$imagepath/";

	if ($deplie && ($row[$keyfield] != $page) && (!$subtree[1]))
	  $tpl .= "tree_expand.gif";
	else
	  $tpl .= "tree_collapse.gif";
	$tpl .= "\" id=\"imgmenu_{key}\" alt=\"+\"></a>";
      }

      if ($subtree) {
	$tpl .= $this->getParam('linetemplate');
      } else {
	if ($this->getParam('leaftemplate')) {
	  $tpl .= $this->getParam('leaftemplate');
	} else {
	  $tpl .= $this->getParam('linetemplate');
	}
      }


      $avant = array(
		     "{key}",
		     "{lib}",
		     "{parentkey}"
		     );
      $apres = array(
		     $row[$keyfield],
		     $row[$libfield],
		     $row[$parentkeyfield]
		     );

      if ($row[$keyfield] == $page)
	$str.= '<span class="item_menu_actif">'.str_replace($avant, $apres, $tpl).'</span>';
      else
	$str.= str_replace($avant, $apres, $tpl);
      $str.="</li>\n";

      foreach ($_GET as $gkey => $gvar) {
	$str= str_replace("{PHP.".$gkey."}",$gvar, $str);
      }
      foreach ($row as $rkey => $rvar) {
	$str= str_replace("{".$rkey."}",$rvar, $str);
      }

      if ($subtree) {
	$str.="<ul>\n".$subtree[0]."</ul>\n";
      }
    }
    $str.="</div>";

    return Array($str,$deplie);

  } // end func
}


?>
