<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

// Bibliotheque pur la gnration de PDF
require_once( $GLOBALS["rootpath"] . "/modules/wm_rs/html2fpdf/html2fpdf.php" );

/**
 * Record set
 */

class wm_rs extends webmodule {

    var $docstring = "Module recordset. Encapsule l'ancien recordset";
    /**
     * Constructeur.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     **/

    var $wysiwygfield;
    var $use_wysiwyg;
    var $field_desc; // parsed field description
    var $request_val;
    var $format_regex;
    var $template_title; // Templates titles
    var $template_options; // Templates options
    var $is_workflow; // Is a workflow ? (false fo wm_rs, true for wm_rswf)

    function wm_rs($id='wm_rs',$is_workflow=false){
        $this->is_workflow = $is_workflow;
        $this->wysiwygfield=array();
        $this->params=array(
                "sql" => "",
                "orderBy" => "",
                "table" => "",
                "keyfield" => "",
                "keyistext" => "",
                "template_list" => "",
                "template_export" => "",
                "template_detail" => "",
                "template_form" => "",
                "template_list_pdf" => "",            
                "template_detail_pdf" => "",                        
                "itemppage" => "0",
                "nbruptfield" => "0",
                "parsenorow" => "1",            
                "field_list" =>"",
                "field_desc" =>"",
                'template_title' => 
                'list="Ajout/Modification d\'un enregistrement"'."\n".
                'form="Edition d\'un enregistrement"'."\n".
                'detail="Dtails d\'un enregistrement"'."\n",
                'template_options' => '',
                "admin" => 0,
                "mime_export" => 'text/csv',
                "file_export" => 'document.csv',                
                "persistVars" =>'',
                "droitModif" =>"0",
                "droitAjout" =>"0",
                "droitSuppr" =>"0",
                "droitDetail" =>"0",
                "droitExport" =>"0",
                "cond_expr" => "0",
                "cond_droit" => "0",
                "cond_affichage" => "0",
                "evt_on_new" =>"",
                "evt_after_delete" =>"",
                "evt_before_delete" =>"",
                "evt_before_post" =>"",
                "evt_after_post" =>"",
                "evt_on_row" =>"",
                "evt_on_edit" =>"",
                "css" =>""
                    );
        $this->paramsType=array(
                "sql" => "textarea",
                "field_list" => "textarea",
                "field_desc" => "textarea",
                "template_title" => "textarea",
                "template_options" => "textarea",
                "template_list" => "templates",
                "template_export" => "templates",
                "template_detail" => "templates",
                "template_form" => "templates",
                "template_list_pdf" => "templates",                
                "template_detail_pdf" => "templates"                
                );
        $this->paramsLevel=array(
                "evt_on_new" => 3,
                "evt_after_delete" => 3,
                "evt_before_delete" => 3,
                "evt_before_post" => 3,
                "evt_after_post" => 3,
                "evt_on_row" => 3,
                "evt_on_edit" => 3,
                'template_title' => 1,
                'template_options' => 1,
                "template_list" => 1,
                "template_detail" => 1,
                "template_form" => 1,
                "droitModif" =>2,
                "droitAjout" =>2,
                "droitSuppr" =>2,
                "droitDetail" =>2,
                "droitExport" =>2,
                "cond_expr" => 2,
                "cond_droit" => 2,
                "cond_affichage" => 2,
                "css" => 4,
                "persistVars" =>4,
                "template_list_pdf" => 5,                                  
                "template_detail_pdf" => 5,
                "mime_export" => 6,
                "file_export" => 6,
                "template_export" => 6
                    );
        $this->levellib=array("Sql","Templates","Droits","Evenements","Autres","Templates PDF","Export");
        $this->use_wysiwyg=false;
        $this->request_val = Array();
 
        // Format regular expression without '^' and '$' (added automaticly)
        $this->format_regex=Array
            ('email' => '[a-z0-9_\.-]+@([a-z0-9]+([\-]+[a-z0-9]+)*\.)+[a-z]{2,7}',
             'number' => '-?[0-9]+(,[0-9]+)?',
             'integer' => '-?[0-9]+',
             'file' => '(special type, see check_format function !)',
             'siren' => '[0-9]{9}',
             'date' => '[0-9]{1,2}/[0-9]{1,2}/[0-9]{4}',
             'time' => '[0-9]{1,2}:[0-9]{2}',
             'unsigned_integer' => '[0-9]+',
             'text' => '.+');
        
        $this->levelComment[0] =
          '<p>Configuration SQL.</p>';
        
        $this->levelComment[1] =
          '<p>Configuration des modles de page. "--" est synosyme de template vide. Celui-ci ne sera pas regnr.</p>';
        
        $this->levelComment[2] =
          '<p>Configuration des droits minimums pour diffrentes actions.</p>';
        
        $this->levelComment[3] =
          '<p>Configuration des vnements (fonctions PHP appeles '.
          'lorsqu\'une action est effectue).</p>';
        
        $this->levelComment[5] =
          '<p>Modle de document pour l\'exportation au format PDF</p>';

        $this->levelComment[6] =
          '<p>Paramtre pour l\'exportation dans un format texte ( XML, CSV, etc ... )</p>';          
        
        $this->paramsComment['keyfield'] = 
          '<p>Nom de la cl primaire dans la table</p>';

        $this->paramsComment['keyistext'] = 
          '<p>Indique si la cl (keyfield) est un champ au format texte (1) ou non (0)</p>';
 
        $this->paramsComment['template_options'] = 
          '<p>Options pour le gnrateur de templates :</p>'.
          '<ul>'.
          '  <li>opt_url="..." : chane ajoute aux liens '.
          '(utilis pour passer paramtres supplmentaires). Vous n\'avez pas  spcifier ? ou &,'.
          'ceci est gr automatiquement.</li>'.
          '</ul>';
        
        $this->paramsComment['field_list'] = 
          '<p>Liste des champs de la table (voyez galement le paramtre sql). Syntaxe :</p>'.
          '<pre>nom:editable:type:handler</pre>'.
          '<p>Avec :</p>'.
          '<ul>'.
          '  <li>nom : nom du champ</li>'.
          '  <li>editable : indique si le champ est ditable (1) ou non (0)</li>'.
          '  <li>type : type de champ (text, wysiwyg, textarea, lookupmods, lookupsql, bloc, upload_file)</li>'.
          '  <li>handler : fonction php utilise pour traiter les donnes '.
          'avant des les afficher (rs_text_handler par dfaut)</li>'.
          '</ul>';
        
        $this->paramsComment['field_desc'] = 
          '<p>Description et options des champs. '.
          'Diffrentes options sont disponnibles '.
          '(id tant l\'identifiant du champ) :</p>'.
          '<ul>'.
          '<li>label[id]="abc" : Dfinit le libell</li>'.
          '<li>format[id]=FORMAT : Dfinit le format. '.
          'Types disponnibles : '.implode(array_keys($this->format_regex),', ').'. Si le champ est '.
          'optionnel, ajoutez simplement un point d\'interrogation (ex: text?).</li>'.
          '<li>link[id] : Indique que le champ sera utilis comme lien vers les dtails</li>'.
          '<li>hide[id] : Cache le champ</li>'.
          '<li>hide_in_list[id] : Cache le champ en mode liste</li>'.
          '<li>hide_in_form[id] : Cache le champ en mode saisie</li>'.
          '</ul>';
        
        $this->paramsComment['template_title'] = 
          '<p>Titre des templates (utilis par le gnrateur de templates)</p>';
        
        $this->paramsComment['sql'] = 
          '<p>Requte SQL utilise pour lire les diffrents champs</p>';
        
        $this->paramsComment['template_export'] = 
          '<p>Modle pour l\'exportation dans un format texte.</p>';
        
        $this->paramsComment['mime_export'] = 
          '<p>Type MIME pour l\'exportation dans un format texte.</p>';          

        $this->paramsComment['file_export'] = 
          '<p>Nom du fichier  tlcharger pour l\'exportation dans un format texte.</p>';                    

        webmodule::webmodule($id);
        $this->init_rs();

        $this->field_desc = $this->fields_description();
        $this->template_title = $this->parse_template_title();
        $this->template_options = $this->parse_template_options();
    }

    /**
     * Short description.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function init_rs(){

        $this->rs=new rs_class();
        $sql = $this->getParam("sql");

        $this->rs->sql=$this->replace_params( $sql );

        $this->rs->table='`' . $this->getParam("table") . '`';
        $this->rs->keyfield=$this->getParam("keyfield");
        $this->rs->template_list=$this->getParam("template_list");
        $this->rs->template_export=$this->getParam("template_export");
        $this->rs->template_form=$this->getParam("template_form");
        $this->rs->template_detail=$this->getParam("template_detail");
        $this->rs->itemppage=$this->getParam("itemppage");
        $this->rs->nbruptfield=$this->getParam("nbruptfield");
        $this->rs->keyistext=$this->getParam("keyistext");
        $this->rs->navvar = $this->id.'_start';

        $field_list=explode("\r\n", $this->getParam("field_list"));

        foreach ($field_list as $f) {
            list($name,$editable,$type,$argument) = explode(":",$f);

            // types grs : text, upload_file, lookupsql
            // si type = text, argument = handler
            // si type = upload_file, argument = path d'upload
            // si type = lookupsql, argument = requte SQL de lookup

            $name=trim($name);
            $editable=trim($editable);
            $type=trim($type);
            $argument=trim($argument);

            if (!isset($editable)) {
                $editable=1;
            }

            if (!isset($type)) {
                $type="text";
            }

            if ($type == "wysiwyg") {
                $this -> wysiwygfield[]=$name;
                if (!isset($argument)) $argument="rs_field_text_handler";
                $this->rs->rs_addfield($name,($editable=='1'),$type,$argument);                
            } 
            else if (($type == 'text') || ($type == 'textarea')) {
                if (!isset($argument)) $argument="rs_field_text_handler";
                $this->rs->rs_addfield($name,($editable=='1'),$type,$argument);
            } 
            else if ($type == "bloc") {
                if (!isset($argument)) $argument="rs_field_text_handler";
                $this->rs->rs_addblocfield($name,($editable=='1'),$type,$argument);
            }            
            elseif ($type == "upload_file") {
                $lib=new rs_field($name,($editable=='1'),$type);
                $lib->upload_dest = trim($argument);
                $lib->as_bloc=true;
                $this->rs->rs_addfieldobj($lib);
            }
            elseif ($type == "lookupmods") {
                $lib=new rs_field($name,($editable=='1'),"text","rs_field_text_handler");
                $lib->lookupmods = $argument;
                $this->rs->rs_addfieldobj($lib);
            }
            elseif ($type == "lookupsql") {
                $match = eregi('(.*)GET\[(.*)\](.*)',$argument,$res);
                if ($match) {
                    $avant = $res[1];
                    $k = $res[2];
                    $apres = $res[3];
                    $argument = $avant.$_GET[$k].$apres;
                }
                $argument = $this->replace_params($argument);
                $lib=new rs_field($name,($editable=='1'));
                $lib->lookupsql = $argument;
                $this->rs->rs_addfieldobj($lib);
            }
            else{
                $this->rs->rs_addfield($name,($editable=='1'),$type,$argument);
            }
        }

        $this->rs->sql = $this->replace_params($this->rs->sql);

    }

    // Check if a string in the specified format
    function check_format ($txt, $format) {
        $l = strlen($format)-1;
        $optionnal = ($format[$l]=='?');
        if ($optionnal) $format = substr($format,0,$l); 

        if ($format == 'file') {
            if (trim($txt['name']) == '') return $optionnal;
            if ($txt['size'] == 0) return $optionnal;
            return true;
        }

        if (!array_key_exists($format, $this->format_regex)) {
            ErreurFatale ('Format incorrect : "<em>'.$format
                    .'</em>" dans le champ field_desc !');
        }

        $regex = '^'.$this->format_regex[$format].'$';

        if ($txt == '') return $optionnal;

        return ereg($regex, $txt);
    }

    // Parse template titles
    function parse_template_title() {
        $title = Array();
        $all = explode("\n", $this->getParam('template_title'));
        foreach ($all as $line) {
            $line = trim($line);
            if ($line == '') continue;

            if (eregi('^(list|form|detail)="(.*)"$', $line, $regs)) {
                $title[ $regs[1] ] = $regs[2];
            } else {
                Erreur('Ligne <em>'.htmlspecialchars($line).'</em> invalide dans template_title (module '.$this->id.').');
            }
        }
        return $title;
    }

    // Parse template options
    function parse_template_options() {
        $options = Array();
        $all = explode("\n", $this->getParam('template_options'));
        foreach ($all as $line) {
            $line = trim($line);
            if ($line == '') continue;

            if (eregi('^(opt_url)="(.*)"$', $line, $regs)) {
                $url = '&'.$regs[2];
                $id = 'opt_url_arg';
                $options['list'][ $id ] = $url;
                $options['form'][ $id ] = $url;
                $options['detail'][ $id ] = $url;
                $url = '?'.$regs[2];
                $id = 'opt_url';
                $options['list'][ $id ] = $url;
                $options['form'][ $id ] = $url;
                $options['detail'][ $id ] = $url;
            } else {
                Erreur('Ligne <em>'.htmlspecialchars($line).'</em> invalide dans template_options (module '.$this->id.').');
            }
        }
        return $options;    
    }

    // Parse field_desc argument
    // Return an array in this format :
    // $desc = Array(
    //   'link' => $keyi, --> Champ utilis pour le lien
    //   'label' => Array($key1 => $label1, $key2 => $label2, ...), --> Titre du champ
    //   'default' => Array($key1 => $defautl1, $key2 => $defautl2, ...), --> Valeur par dfaut
    //   'format' => Array($key1 => $format1, $key2 => $format2, ...)); --> Format du champ
    //   'hide' => Array($key1, $key2, ...), --> Champ cach
    //   'hide_in_list' => Array($key1, $key2, ...)); --> Ce qui est cach dans le template list
    //   'hide_in_form' => Array($key1, $key2, ...)); --> Ce qui est cach dans le template list
    function fields_description() {
        $desc = Array
            ('label' => Array(), 
             'default' => Array(),
             'format' => Array(),
             'hide' => Array(),
             'hide_in_list' => Array(),
             'hide_in_form' => Array(),
             'link' => false
            );
        $all = explode("\n", $this->getParam('field_desc'));

        foreach ($all as $line) {
            $line = trim($line);
            if ($line == '') continue;

            // label[f]="xxx"
            if (eregi('^label\[(.*)\]="(.*)"$', $line, $regs)) {
                $f = $regs[1];
                $desc['label'][ $regs[1] ] = $regs[2];

                // format[f]=xxx
            } else if (eregi('^format\[(.*)\]=(.*)$', $line, $regs)) {
                $f = $regs[1];	
                $desc['format'][ $regs[1] ] = $regs[2];

                // default[f]="xxx"
            } else if (eregi('^default\[(.*)\]="(.*)"$', $line, $regs)) {
                $f = $regs[1];
                $desc['default'][ $regs[1] ] = $regs[2];

                // hide[f]
            } else if (eregi('^hide\[(.*)\]$', $line, $regs)) {
                $f = $regs[1];
                $desc['hide'][] = $f;

            // hide_in_list[f]
            } else if (eregi('^hide_in_list\[(.*)\]$', $line, $regs)) {
                $f = $regs[1];
                $desc['hide_in_list'][] = $f;

            // hide_in_form[f]
            } else if (eregi('^hide_in_form\[(.*)\]$', $line, $regs)) {
                $f = $regs[1];
                $desc['hide_in_form'][] = $f;

                // link[f]
            } else if (eregi('^link\[(.*)\]$', $line, $regs)) {
                if ($desc['link'])
                    Erreur ('Champ <em>link</em> dj renseign dans '.
                            'field_desc (module '.$this->id.') !');
                $f = $regs[1];
                $desc['link'] = $f;

                // autre: erreur!
            } else {
                Erreur('Ligne <em>'.htmlspecialchars($line).'</em> invalide dans field_desc (module '.$this->id.').');
            }

            if (!array_key_exists($f, $this->rs->field_list)) {
                Erreur ('Le champ <em>'.$f.'</em> n\'existe pas (module '.$this->id.') !');
            }
        }
        /*
           if ($desc['link'] === false) 
           Erreur ('Le champ <em>link</em> n\'a pas t renseign dans field_desc (module '.$this->id.') !');
         */
        return $desc;
    }


    function initModule(){

        $table=$this->getParam('table');

        // If no sql param does exist, generate one
        if ( ( $this->getParam('sql')=='' ) && trim( $this->getParam('table') ) != '') {
            $table=$this->getParam('table');
            $admin=$this->getParam('admin');
            $rf=mysql_query("show Columns from $table");
            echo mysql_error();
            $champs="";
            $fieldlist="";
            while ($field=mysql_fetch_row($rf)) {
                $nom = $field[0];
                if ($champs != '') $champs .= ', ';
                $champs.= $nom;

                // key and state (for workflow) fields are not editable
                if ($nom == $this->getParam('keyfield')) {      
                    $fielddesc .= 'link['.$nom.']'."\n"; 
                    $editable = "0";
                } else if ($this->is_workflow
                        && ($nom == $this->getParam('champetat'))) {                 
                    $editable = "0";
                } else {
                    $editable = "1";
                }
                $fieldlist .= $nom.":".$editable.":text:rs_field_text_handler\r\n";
                $fielddesc .= 'label['.$nom.']="'.$nom.'"'."\n"; 
                if ($admin) $fielddesc .= 'format['.$nom.']=text?'."\n";
                $fielddesc .= "\n";
            }
            $sql="SELECT ".$champs." FROM ".$table;
            $this->setParam('sql',$sql);
            $this->setParam('field_list',trim($fieldlist));
            $this->setParam('field_desc',trim($fielddesc));
        }


        if ($table and $this->getParam('template_list')=='') {
            $this->init_rs();
            $this->rs->sql=$this->getParam("sql");
            require_once("modules/wm_rs/modelxtpl.php");
            require_once("modules/wm_rs/template_creator.php");
            $listtpl=TC_liste($this, $this->getParam("admin"));
            //print $listtpl;
            $this->setParam('template_list',$listtpl);
        }

        if ($table and $this->getParam('template_export')=='') {
            $this->init_rs();
            require_once("modules/wm_rs/modelxtpl.php");
            require_once("modules/wm_rs/template_creator.php");
            $this->rs->sql=$this->getParam("sql");
            $exporttpl=TC_export($this, $this->getParam("admin"));
            $this->setParam('template_export',$exporttpl);
        }        

        if ($table and $this->getParam('template_detail')=='') {
            $this->init_rs();
            require_once("modules/wm_rs/modelxtpl.php");
            require_once("modules/wm_rs/template_creator.php");
            $this->rs->sql=$this->getParam("sql");
            $listtpl=TC_detail($this, $this->getParam("admin"));
            //print $listtpl;
            $this->setParam('template_detail',$listtpl);
        }

        if ($table and $this->getParam('template_form')=='') {
            $this->init_rs();
            require_once("modules/wm_rs/modelxtpl.php");
            require_once("modules/wm_rs/template_creator.php");
            $this->rs->sql=$this->getParam("sql");
            $listtpl=TC_saisie($this, $this->getParam("admin"));
            //print $listtpl;
            $this->setParam('template_form',$listtpl);
        }

        $this->saveParamToDb();
        parent::initModule();
    }

    function check_all_fields() {
        $err_fields = Array();
        foreach ($this->rs->field_list as $field) {

            $key = $field -> name;

            if (array_key_exists($key, $this->field_desc['format'])) {
                if (array_key_exists($key, $this->field_desc['label']))
                    $label = $this->field_desc['label'][$key];
                else
                    $label = $key;
                $format = $this->field_desc['format'][$key];
            } else {
                $format = false;
            }

            if ($format != 'file') {
                $value = $_REQUEST[$key];
                $value = trim($value);
                $value = stripcslashes($value);
                $_REQUEST[$key] = $value;
            } else {
                $value = $_FILES[$key];
            }

            $this->request_val[$key] = $value;

            // Vilain hack  cause de liste de choix o $xtpl->VAR[$key]=libell,
            // et non la valeur
            $this->request_val['__'.$key.'__'] = $value;

            if (!$field -> editable) continue;

            if ($format) {
                if (!$this->check_format($value,$format)) $err_fields[] = $label;
            }
        }
        if (1<count($err_fields)) {
            $txt = '<em>'.join($err_fields, '</em>, <em>').'</em>';
            Erreur('Les champs '.$txt.' sont mal renseigns.');
            return false;
        }

        if (count($err_fields)==1) {
            Erreur('Le champ <em>'.$err_fields[0].'</em> est mal renseign.');
            return false;
        }
        return true;
    }

    /**
     * Short description.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function process(){
        global $modid,$page;
        global $_URLVARS;
        global $insertedID;

        $modid=$this->id;        
        $parr=explode(',',$this->getParam('persistVars'));

        $user_droit=$GLOBALS["droit_user"];
        if (eval("return ".$this->getParam('cond_expr').";")) {
            $user_droit=$this->getParam('cond_droit');
        }

        // Droit sur les actions d'un recordset
        if( $this->getParam("droitAjout") != '' && $user_droit >= $this->getParam("droitAjout") ){
            $insere_ajout = TRUE;
        }

        if( $this->getParam("droitModif") != '' && $user_droit >= $this->getParam("droitModif") ){
            $insere_modif = TRUE;
        }

        if( $this->getParam("droitSuppr") != '' && $user_droit >= $this->getParam("droitSuppr") ){
            $insere_suppr = TRUE;
        }        

        if( $this->getParam("droitExport") != '' && $user_droit >= $this->getParam("droitExport") ){
            $insere_export = TRUE;
        }                

        foreach ($parr as $pvar){
            $_URLVARS[]=$pvar;
        }

        $ajout =($_REQUEST[$modid.'_postnew'] && $insere_ajout);
        $modif = $_REQUEST[$modid.'_postmodify'];
        if ($ajout || $modif) {
            if (!$this->check_all_fields($ajout)) {
                if ($ajout)
                    $id = $_REQUEST[$modid.'_postnew'];
                else
                    $id = $_REQUEST[$modid.'_postmodify'];

                unset ($_REQUEST[$modid.'_postnew']);
                unset ($_REQUEST[$modid.'_postmodify']);
                if ($ajout)
                    $_REQUEST[$modid.'_new'] = $id;
                else
                    $_REQUEST[$modid.'_modify'] = $id;
                $ajout = $modif = false;
            }
        }

        $info = "Table: " . $this->rs->table . " Cl: ". $this->rs->keyfield . " ";

        if ($ajout){
            $insertedID = $this->rs->rs_post_new($this->getParam("evt_before_post"),$this->getParam("evt_after_post"));
            if (isset($_REQUEST["redirect"])) {
                $_REQUEST["redirect"] = $this->replace_params( $_REQUEST["redirect"] );
                Header("Location: ".$_REQUEST["redirect"]);
                die();
            }
        }

        elseif ($modif){
            $this->rs->rs_post_modify($_REQUEST[$modid.'_postmodify'], $this->getParam("evt_before_post"), $this->getParam("evt_after_post"));
            unset($_REQUEST[$modid.'_postmodify']);
        }

        elseif ($_REQUEST[$modid.'_delete'] && $insere_suppr){
            // Log dans db
            //$this->log( "delete", $info  . $GLOBALS[$modid.'_delete']);

            $this->rs->rs_delete($_REQUEST[$modid.'_delete'],$this->getParam("evt_before_delete"),$this->getParam("evt_after_delete"));
            //q_query("DELETE FROM fw_modules_params WHERE id_module = '".$_REQUEST[$modid.'_delete']."'");
        }

        elseif ($_GET[$modid.'_export'] && $insere_export){
            // Log dans db
            //$this->log( "export", $info  . $GLOBALS[$modid.'_export']);
            $this->rs->rs_export($this->getParam("mime_export"), $this->getParam("file_export"), $this->getParam("evt_on_row"), false);
        }

        // Calcul du nombre d'enregistrements du RECORDSET.
        $tmp_SQL = $this->replace_params($this->rs->sql);
        $var_name = $this->id."_nbRecord";
        $var_name2 = $this->id."_itemppage";
        $var_name3 = $this->id."_nbPage";
        $var_name4 = $this->id."_currentPage";
        global $$var_name, $$var_name2, $$var_name3, $$var_name4;
        if ($tmp_SQL) {
            $res = q_query($tmp_SQL);
        } else {
            $res=0;
        }
        if ($res && $this->getParam("itemppage") != 0){
            $$var_name = q_num_rows($res);
            $$var_name2 = $this->getParam("itemppage");
            $$var_name3 = round($$var_name / $$var_name2,0) + 1;
            $tmp = $this->id."_start";
            if (isset($_GET[$tmp])) $$var_name4 = ($_GET[$tmp] / $$var_name2) + 2;
            else $$var_name4 = 1;
        }
        $v=$this->id."_orderby";
        if ($_GET[$v]) {
            $$v=$_GET[$v];
            //print $_GET[$v];
            session_register($this->id."_orderby");
            $_SESSION[$v]=$_GET[$v];
        }
        $_URLVARS[]=$this->id."_start";
    } // end func


    /**
     * renvoie la sortie du module.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function out(){
        global $modid, $_OUT;
        $modid=$this->id;
        $insere_ajout  = FALSE;
        $insere_modif  = FALSE;
        $insere_suppr  = FALSE;
        $insere_export  = FALSE;
        $insere_detail = FALSE;

        //----- Feuille de style CSS ----------
        if ($this->getParam("css")) {
            $_OUT["head"].="<link rel=\"stylesheet\" media=\"screen\" href=\"".$this->getParam("css")."\">\n";
        }

        //----- Gestion des droits ----------
        $user_droit=$GLOBALS["droit_user"];
        if (eval("return ".$this->getParam('cond_expr').";")) {
            $user_droit=$this->getParam('cond_droit');
        }

        // Droit sur les actions d'un recordset
        if( $this->getParam("droitAjout") != '' 
                && $user_droit >= $this->getParam("droitAjout") ){
            $insere_ajout = TRUE;
        }

        if( $this->getParam("droitModif") != '' 
                && $user_droit >= $this->getParam("droitModif") ){
            $insere_modif = TRUE;
        }

        if( $this->getParam("droitSuppr") != '' 
                && $user_droit >= $this->getParam("droitSuppr") ){
            $insere_suppr = TRUE;
        }

        if( $this->getParam("droitDetail") != '' 
                && $user_droit >= $this->getParam("droitDetail") ){
            $insere_detail = TRUE;
        }

        if( $this->getParam("droitExport") != '' 
                && $user_droit >= $this->getParam("droitExport") ){
            $insere_export = TRUE;
        }                       

        //------ Que doit-on afficher ? --------------
        if ($_REQUEST[$modid.'_new'] && $insere_ajout) {

            $this->request_val = array_merge($this->field_desc['default'], $this->request_val);

            $_OUT[$this->zone] .= $this->rs->rs_new
                ($modid.'_postnew',false,true,$this->request_val);

            $this->use_wysiwyg=true;

        } elseif ($_REQUEST[$modid.'_modify'] && $insere_modif) {

            $_OUT[$this->zone] .= $this->rs->rs_modify
                ($_REQUEST[$modid.'_modify'],$modid.'_postmodify',false,true,$this->request_val);

            $this->use_wysiwyg=true;

        } elseif ($_REQUEST[$modid.'_detail'] && $insere_detail) {
            $sortie = $this->rs->rs_detail
                ($_REQUEST[$modid.'_detail'],false,true, $insere_modif, $insere_suppr);
            if( isset( $_REQUEST["pdf"] ) ){
                $this->template_detail = $this->template_detail_pdf;
                $this->generePDF( $sortie, $_REQUEST["pdf"] );
            }
            else{
                $_OUT[$this->zone] .= $sortie ;
            }
        } else {
            $this->rs->sql = trim($this->replace_params($this->rs->sql));

            if ($this->rs->sql) {
                $orderBy = $this->getParam("orderBy");
                if ($orderBy!= ''){
                    $oblist=explode('|',$this->replace_params($orderBy));
                    foreach ($oblist as $key => $value)
                        if( empty( $oblist[$key] ) ) unset( $oblist[$key] );
                    $orderBy = implode( ",", $oblist );
                    $this->rs->sql .= ' order by '.$orderBy;                    
                }

                if (isset($_REQUEST[$this->rs->navvar])) {
                    $GLOBALS[$this->rs->navvar."_sav"]=$_REQUEST[$this->rs->navvar];
                    session_register($this->rs->navvar."_sav");
                }

                if (isset($_REQUEST[$this->rs->navvar."_keep"])) {
                    //print "saved=".$_SESSION[$this->rs->navvar."_sav"];
                    $GLOBALS[$this->rs->navvar]=$_SESSION[$this->rs->navvar."_sav"];
                }

                if ( $this->getParam( 'cond_affichage' ) == '0'  
                        || eval( "return " . $this->getParam( 'cond_affichage' ) . ";" )){

                    $sortie = $this->rs->rs_list
                        (false, true, 
                         $this->getParam("parsenorow"), 
                         $insere_ajout, $insere_modif, $insere_suppr, $insere_detail, 
                         $insere_export,$this->getParam('evt_on_row'));

                    if( isset( $_REQUEST["pdf"] ) ){
                        $this->template_list = $this->template_list_pdf;
                        $this->generePDF( $sortie, $_REQUEST["pdf"] );
                    }
                    else{
                        $_OUT[$this->zone] .= $sortie ;
                    }                      
                }                    
            }
        }

        //---- Si on utilise HtmlArea, crit le code HTML ncessaire ----
        if ($this->use_wysiwyg) {
            $_OUT["head"].=
                '<link rel="stylesheet" href="./inc/htmlarea/styles_web.css">'."\n".
                '<link rel="stylesheet" href="./inc/htmlarea/style.css">'."\n".
                '<script type="text/javascript">'."\n".
                '  _editor_url = "./inc/htmlarea/";'."\n".
                '  _editor_lang = "fr";'."\n".
                '</script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/htmlarea.js"></script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/lang/fr.js"></script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/dialog.js"></script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/popupwin.js	"></script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/plugins/TableOperations/table-operations.js"></script>'."\n".
                '<script type="text/javascript" src="./inc/htmlarea/plugins/TableOperations/lang/fr.js"></script>';
        }

        if ($this->use_wysiwyg) {
            foreach( $this -> wysiwygfield as $f ) {
                $_OUT["bodyfoot"].=
                    '<script type="text/javascript">'."\n".
                    '  HTMLArea.replace ("wysiwyg_'.$f.'");'."\n".
                    '  function mySubmit() {'."\n".
                        '    document.'.$modid.'_formulaire.onsubmit();'."\n".
                            '    document.'.$modid.'_formulaire.submit();'."\n".
                            '};'."\n".
                    '</script>';
            }
        }
    }

    /**
     *
     * This is the short Description for the Function
     *
     * This is the long description for the Class
     *
     * @return	mixed	 Description
     * @access	public
     * @see		??
     */
    function generePDF( $html, $orientation ){
        define('FPDF_FONTPATH','font/');        
        if( $orientation != "landscape" && $orientation != "portrait" ) $orientation = "portrait";
        $pdf=new HTML2FPDF($orientation,"mm", "A4");
        $pdf->AddPage();
        $pdf->WriteHTML( $html );
        $pdf->Output("document.pdf", "I");
        die();        
    }
}
?>
