<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

// Gnrateur de template

// $Id: template_creator.php,v 1.1.1.1 2004/11/16 15:04:28 haypo Exp $

if ($debug) echo ("template_creator.php3 start<BR>\n");
//umask (022);

function TC_liste($module,$admin,$theme="default") {
    $rs=$module->rs;
    $desc=$module->field_desc;
    $table_key=$rs->keyfield;
    $template_liste=$rs->template_list;

    $tpl_path="";

    $modele="modules/wm_rs/themes/default/modele_liste.mod";

    $mod=new ModXTemplate($modele);
    if ($template_liste == '') $template_liste = 'template_liste dans DB';
    $mod->assign("co",'[');
    $mod->assign("cf",']');
    $mod->assign("template_name",$module->id);
    $mod->assign("keyfield",$rs->keyfield);
    $mod->assign("title",$module->template_title['list']);
    $mod->assign($module->template_options['list']);
    
    if ($admin) $mod->parse('main.entete_admin');

    while (list($key, $val) = each($rs->field_list)) {
	if (in_array($key, $desc['hide'])) continue;
	if (in_array($key, $desc['hide_in_list'])) continue;

	if (array_key_exists($key, $desc['label']))
	  $mod->assign("var_name",$desc['label'][$key]);
	else
	  $mod->assign("var_name",$key);
	$mod->parse("main.entete");

	$mod->assign("var_det",$key);
	if ($key == $desc['link'])
          $mod->parse("main.detail.keyfield");
	else
          $mod->parse("main.detail.classic");
        $mod->parse("main.detail");
    }
    if ($admin) {
	$mod->assign("keyfield",$rs->keyfield);
	$mod->parse("main.admin");
    }
    if ($rs->itemppage>0) 
      $mod->parse("main.nav");
    if ($admin)
      $mod->parse("main.ajout");
	
    $mod->parse("main");
    $str=$mod->text("main");
    return $str;
}

function TC_detail($module,$admin,$theme="default") {
    $rs=$module->rs;
    $desc=$module->field_desc;
    $table_key=$rs->keyfield;
    $template_detail=$rs->template_detail;

    $tpl_path="";

    $modele="modules/wm_rs/themes/default/modele_detail.mod";

    $mod=new ModXTemplate($modele);
    if ($template_detail == '') $template_detail = 'template_detail dans DB';
    $mod->assign("template_name",$module->id);
    $mod->assign("co",'[');
    $mod->assign("cf",']');
    $mod->assign("title",$module->template_title['detail']);
    $mod->assign($module->template_options['detail']);
				
    while (list($key, $val) = each($rs->field_list)) {
	if (in_array($key, $desc['hide'])) continue;

	if (array_key_exists($key, $desc['label']))
	  $mod->assign("var_name", $desc['label'][$key]);
	else
	  $mod->assign("var_name", $key);
	$mod->parse("main.entete");
	$mod->assign("var_det",$key);
	$mod->parse("main.detail");
    }
    if ($admin) {
	$mod->assign("keyfield",$rs->keyfield);
	$mod->parse("main.admin");
    }

    $mod->parse("main");
    $str=$mod->text("main");
    return $str;
}


function TC_saisie($module,$admin,$theme="default") {
    $rs=$module->rs;
    $desc=$module->field_desc;
    $template_form=$rs->template_form;
    $modele="modules/wm_rs/themes/default/modele_saisie.mod";
    $mod=new ModXTemplate($modele);
    if ($template_form == '') $template_form = 'template_form dans DB';
    $mod->assign("template_name",$module->id);
    $mod->assign("co",'[');
    $mod->assign("cf",']');
    $mod->assign("title",$module->template_title['form']);
    $mod->assign($module->template_options['form']);

    while (list($key, $val) = each($rs->field_list)) {
	if ($val->type=="hiddenvar") {
	    $mod->assign("hidden",$key);
	    $mod->assign("hidden_value",$val->handler);
	    $mod->parse("main.type_hidden");
	} else if ($val->editable) {
	    if (array_key_exists($key, $desc['label']))
	      $mod->assign("label", $desc['label'][$key]);
	    else
	      $mod->assign("label", $key);
	    $mod->assign("key", $key);
	    $mod->assign("val",$val);
	    if ($val->type=="text") {
		if ($val->lookupsql!="" || $val->lookupmods!="") 
		  $mod->parse("main.form_item.type_lookup");
		else 
		  $mod->parse("main.form_item.type_text");
	    }
	    if ($val->type=="upload_file") {
		$mod->parse("main.form_item.type_upload");
	    }
	    if ($val->type=="wysiwyg") {
		$mod->parse("main.form_item.type_wysiwyg");
	    }
            $mod->parse("main.form_item");	
	}
    }

    $mod->parse("main");
    $str=$mod->text("main");
    return $str;
}

function TC_export($module,$admin,$theme="default") {
    $rs=$module->rs;
    $desc=$module->field_desc;
    $table_key=$rs->keyfield;
    $template_export=$rs->template_export;

    $tpl_path="";

    $modele="modules/wm_rs/themes/default/modele_export.mod";

    $mod=new ModXTemplate($modele);
    if ($template_export == '') $template_export = 'template_liste dans DB';
    $mod->assign("co",'[');
    $mod->assign("cf",']');
    $mod->assign("template_name",$module->id);
				
    while (list($key, $val) = each($rs->field_list)) {
	$mod->assign("var_name",$key);
	$mod->parse("main.entete");
	$mod->assign("var_det",$key);
	$mod->parse("main.detail");
    }
    $mod->assign("keyfield",$rs->keyfield);
    $mod->parse("main.show_detail");
    if ($admin) {
	$mod->assign("keyfield",$rs->keyfield);
	$mod->parse("main.detail_admin");
    }
    if ($rs->itemppage>0) 
      $mod->parse("main.nav");
    if ($admin)
      $mod->parse("main.ajout");
	
    $mod->parse("main");
    $str=$mod->text("main");
    return $str;
}

?>
