<?php

/******************************************************************************
 *   Copyright (c) 2004 The 2le development team                              *
 ******************************************************************************
 *                                                                            *
 *  This file is part of CASTOR.                                              *
 *                                                                            *
 *  CASTOR is free software; you can redistribute it and/or modify            *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  CASTOR is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with CASTOR; if not, write to the Free Software                     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                            *
 *****************************************************************************/

include_once('modules/wm_rs.php');
/**
 * webmodule.
 *
 * module web, gestion des entres, sorties.
 * @author       
 * @version      1.0
 * @copyright    
 * @since        
 * @access       public
 */

class wm_rswf extends wm_rs {

    var $docstring = "Module recordset avec workflow";
    /**
     * Constructeur.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     **/

	function wm_rswf($id='wm_rs'){
		wm_rs::wm_rs($id,true);
        $this->is_workflow = true;

        // Paramtres du workflow
		$this->params["champetat"]="etat";
		$this->params["listeetat"]="SAISI:VALIDE";
		$this->params["transitions"]="VALIDER:Valider:SAISI:VALIDE:100:1000:mailadmin\nDEVALIDER:Dpublier:VALIDE:SAISI:100:1000";
		$this->params["templateActionList"]=
			'<a href="{PHP.page}.html?'.
			'{PHP.modid}_action={codeAction}&'.
			'{PHP.modid}_keyvalue={'.$this->params['keyfield'].'}">'.
			'{libAction}</a>&nbsp;';

        // Commentaires sur les paramtres
        $this->paramsComment['listeetat'] = '<p>Liste des tats spars par des ":".</p>';
        $this->paramsComment['transitions'] = 
          '<p>Transition d\'un tat  un autre, c\'est en fait une suite d\'actions autorises. Syntaxe :<br />'.
          'CODE_ACTION:Intitul:ANCIEN_ETAT:NOUVEL_ETAT:droits min:droits max[:handler]</p>'.
          '<p>handler est une fonction optionnelle, appele lorque l\'action est appele. Prototype de la fonction :</p>'.
          '<pre>fonction($code_action, $ancien_etat, $nouvel_etat, $libelle_action);</pre>';
		
		$this->paramsType["transitions"]="textarea";
		$this->paramsType["templateActionList"]="textarea";

		$this->paramsLevel["champetat"]=6;
		$this->paramsLevel["listeetat"]=6;
		$this->paramsLevel["transitions"]=6;
		$this->paramsLevel["templateActionList"]=6;
		$this->levellib[]="Workflow";

		webmodule::webmodule($id);
		$this->rs->caller=$this;
		$this->params["evt_on_row"]='on_row';

	}
	
    /**
     * Short description.
     *
     * Detail description
     * @param     
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function process(){
		wm_rs::process();
		$modid=$this->id; 
		$actions=explode("\r\n", $this->getParam("transitions"));
		$user_droit=$GLOBALS["droit_user"];

        foreach ($actions as $f) {
            list($codeaction,$libaction,$sourcestate,$deststate,$minRight,$maxRight,$callback) = explode(":",$f);
			if ( ($_REQUEST[$modid.'_action']==$codeaction) and $user_droit<=$maxRight and $user_droit>=$minRight) {
                // Met  jour la base MySQL
				$sql='update '.$this->getParam("table").
					' set '.$this->getParam("champetat")."='".$deststate.
					"' where " .$this->getParam("keyfield")."=".$_REQUEST[$modid.'_keyvalue'];
				q_query( $sql);

                // Dclanche un vnement si ncessaire
                $callback = trim($callback);
                if ($callback!='') $callback($codeaction, $_REQUEST[$modid.'_keyvalue'], $sourcestate, $deststate,$libaction);
			}
		}
    } // end func

	function on_row($row)
	{	
		global $page,$_SESSION;
		$etat=$row[$this->getParam("champetat")];
		$actions=explode("\r\n", $this->getParam("transitions"));
		$user_droit=$GLOBALS["droit_user"];
		$tpl=$this->getParam("templateActionList");
		$tpl=$this->replace_params($tpl);
		$al="";
		$keyfield = $this->getParam("keyfield"); 
		$keyval = $row[$keyfield];
        foreach ($actions as $f) {
            list($codeaction,$libaction,$sourcestate,$deststate,$minRight,$maxRight,$callback) = explode(":",$f);
			if ($sourcestate==$etat and $user_droit<=$maxRight and $user_droit>=$minRight) {
				$act=str_replace(
							array('{codeAction}','{libAction}','{PHP.page}','{PHP.modid}', '{'.$keyfield.'}'),
							
							 array($codeaction,$libaction,$page,$this->id,$keyval),
							 $tpl);

			    $al.=$act;
			}
		}

		$row["wf_actionlist"]=$al;
	} // end func


}

?>
