<?php

    /*********************************************************************************
     *   Copyright (c) 2004 The 2le development team                                 *
     *********************************************************************************/
     
    /*********************************************************************************
     *                                                                               *
     *   This file is part of CASTOR.                                                *
     *                                                                               *
     *   CASTOR is free software; you can redistribute it and/or modify              *
     *   it under the terms of the GNU General Public License as published by        *
     *   the Free Software Foundation; either version 2 of the License, or           *
     *   (at your option) any later version.                                         *
     *                                                                               *
     *   CASTOR is distributed in the hope that it will be useful,                   *
     *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
     *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
     *   GNU General Public License for more details.                                *
     *                                                                               *
     *   You should have received a copy of the GNU General Public License           *
     *   along with CASTOR; if not, write to the Free Software                       *
     *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
     *                                                                               *
     *********************************************************************************/

/**
 * webmodule.
 *
 * module web, recherche.
 * @author       
 * @version      1.0
 * @copyright    
 * @since        
 * @access       public
 */


class wm_search extends webmodule {
    var $docstring = 'Module de recherche, gnre une requete sql dans la variable SESSION[$modid."_search_sql"]<BR>Types disponibles: fulltext,starttext,textnotempty,text,int,boolean<br>Le troisime paramtre de la liste de champs est le poids pour la pertinence';

	function wm_search($id='wm_search'){
		$this->params=array(
			"sql" => "",
			"champ_modalite" => "noModalite",
			"calcul_pertinence" => "0",
			"keyword_pertinence" => "pertinence",
			"template_form" => "",
			"field_list" =>""
		);
		$this->paramsType=array(
			"sql" => "textarea",
			"field_list" => "textarea",
			"template_form" => "templates"
		);

        parent::webmodule($id);
    }


	function process(){
		global $modid,$page,$_URLVARS;
		$id=$this->id;
		$field_list=explode("\r\n", $this->getParam("field_list"));
		$sql=$this->replace_params( $this->getParam("sql") );
		$clauseWhere = "";
		$_URLVARS[]=$id.'_postrech';
		if ($_REQUEST[$id.'_postrech']){
			foreach ($field_list as $f) {
				list($name,$type,$poids,$parametre) = explode(":",$f);
                $_URLVARS[]=$name;
				$value=$_REQUEST[$name];
				//print_r($_REQUEST);
				if ($type=='fulltext') {
					if ($value) {
						$clauseWhere .= " AND ".$name." like '%".$value."%'";
					}
				} else 
				if ($type=='starttext') {
					if ($value) {
						$clauseWhere .= " AND ".$name." like '".$value."%'";
					}
				} else
				if ($type=='textnotempty') {
					if ($value) {
						$clauseWhere .= " AND ".$value." != ''";
					}
				} else
				if ( ($type=='text') or ($type=='lookuptext') ){
					if ($value) {
						$clauseWhere .= " AND ".$name." = '".$value."'";
					}
				} else 
				if ( ($type=='int') or ($type=='lookup') ) {
					if ($value) {
						$clauseWhere .= " AND ".$name." = ".$value;
					}
				} else 
				if ($type=='boolean') {
					if ($value) {
					    $clauseWhere .= " AND ".$name." = 1";
					}
				} else 
				if ($type=='boolean_whereclause') {
					if ($value) {
					    $clauseWhere .= " ".$parametre;
					}
				} else 
				if ($type=='qualif') {
					$modlist=array();
					foreach ($_REQUEST as $var=>$val) {
						$regs=array();
						if (ereg("qualif_([0-9]*)",$var,$regs)) {
						   $modlist[]=$regs[1];
						}
					}
					if (count($modlist)) {
					    $clauseWhere .= " AND ".$this->getParam("champ_modalite")." in (".join(',',$modlist).")";
					}
				}
			}
			$tmpSQL = eregi_replace("where +1","WHERE 1".$clauseWhere,$sql);
			if (count($modlist) && $this->getParam("calcul_pertinence")) {
                  $tmpSQL = eregi_replace("having +1","HAVING SUM(1)=MAX(".count($modlist).")",$tmpSQL);
            }
			//print $tmpSQL;
			if (q_num_rows(q_query($tmpSQL))>0 || !$this->getParam("calcul_pertinence")) {
			    // Un (ou des) rsultats match tous les critres (toutes qualifs comprises), on ajoute donc la pertinence maxi, soit 100%,  notre requte
			    $_SESSION[$id."_search_sql"] = eregi_replace("^(.*)from(.*)$","\\1, '100' AS ".$this->getParam("keyword_pertinence")." FROM \\2",$sql);
			    $_SESSION[$id."_search_sql"] = eregi_replace("where +1","WHERE 1".$clauseWhere,$_SESSION[$id."_search_sql"]);
			}
			else {
			    // On recre la requte avec des OR  la place des AND et on calcul la pertinence de chaque ligne de rsultat.
                $_SESSION[$id."_search_sql"] = $sql;
                $pertinenceCalculee = "0";
                $clauseWhere = "";
                $nbCriteres = 0;
                $poidsModalite = 0;
      			foreach ($field_list as $f) {
      				list($name,$type,$poids,$parametre) = explode(":",$f);
      				$_URLVARS[]=$name;
      				$value=$_REQUEST[$name];
      				if ($type=='fulltext') {
      					if ($value) {
      						$clauseWhere .= " OR ".$name." like '%".$value."%'";
      						$pertinenceCalculee .= "+IF(".$name." like '%".$value."%'".",".$poids.",0)";
      						$nbCriteres += $poids;
      					}
      				} else
      				if ($type=='starttext') {
      					if ($value) {
      						$clauseWhere .= " OR ".$name." like '".$value."%'";
      						$pertinenceCalculee .= "+IF(".$name." like '".$value."%'".",".$poids.",0)";
      						$nbCriteres += $poids;
      					}
      				} else
      				if ($type=='textnotempty') {
      					if ($value) {
      						$clauseWhere .= " OR ".$value." != ''";
      						$pertinenceCalculee .= "+IF(".$value." != ''".",".$poids.",0)";
      						$nbCriteres += $poids;
      					}
      				} else
      				if ($type=='text') {
      					if ($value) {
      						$clauseWhere .= " OR ".$name." = '".$value."'";
      						$pertinenceCalculee .= "+IF(".$name." = '".$value."'".",".$poids.",0)";
      						$nbCriteres += $poids;
      					}
      				} else
      				if ($type=='int') {
      					if ($value) {
      						$clauseWhere .= " OR ".$name." = ".$value;
      						$pertinenceCalculee .= "+IF(".$name." = ".$value.",".$poids.",0)";
      						$nbCriteres += $poids;
      					}
      				} else
      				if ($type=='boolean') {
      					if ($value) {
      					    $clauseWhere .= " OR ".$name." = 1";
      					    $pertinenceCalculee .= "+IF(".$name." = 1".",".$poids.",0)";
      					    $nbCriteres += $poids;
      					}
      				} else
      				if ($type=='qualif') {
      					$modlist=array();
      					foreach ($_REQUEST as $var=>$val) {
      						$regs=array();
      						if (ereg("qualif_([0-9]*)",$var,$regs)) {
      						   $modlist[]=$regs[1];
      						}
      					}
      					if (count($modlist)) {
      					    $clauseWhere .= " OR ".$this->getParam("champ_modalite")." IN (".join(',',$modlist).")";
      					    $nbCriteres += $poids * count($modlist);
      					    $poidsModalite = $poids;
      					}
      				}
      			}
      			if (count($modlist)<1) {
                  $modlist[]=-1;
                }
                $_SESSION[$id."_search_sql"] = eregi_replace("^(.*)from(.*)$","\\1, ROUND((MAX((".$pertinenceCalculee.")*100)+SUM(IF(".$this->getParam("champ_modalite")." IN (".join(',',$modlist)."),".$poidsModalite."*100,0)))/MAX(".$nbCriteres.")) AS ".$this->getParam("keyword_pertinence")." FROM \\2",$sql);
       			$_SESSION[$id."_search_sql"] = eregi_replace("where +1", "WHERE 0 ".$clauseWhere, $_SESSION[$id."_search_sql"]);
			}
            // Log dans db
            $this->log("recherche", $_SESSION[$id."_search_sql"]);
            
		} elseif (!isset($_REQUEST["sql_SESSION"])) {
		    $_SESSION[$id."_search_sql"] ='';
		}
	    //print $_SESSION[$id."_search_sql"];
	} // end func    

	/**
	 * renvoie la sortie du module.
	 *
	 * Detail description
	 * @param     
	 * @since     1.0
	 * @access    private
	 * @return    void
	 * @throws    
	 */
	function out(){
		global $modid, $_OUT;
		$modid=$this->id;
		$xtpl=new XTemplate($this->getParam('template_form'),'main',0);

		$field_list=explode("\r\n", $this->getParam("field_list"));
		foreach ($field_list as $f) {
			list($name,$type,$poids,$parametre) = explode(":",$f);

			if (($type=='lookup') or ($type=='lookuptext')) {
				$optionList=optionList($parametre);
				$xtpl->assign($name.'_option',$optionList);
			}
		}


		$xtpl->parse("main");
		$_OUT[$this->zone] .= $xtpl->text("main");
	}
}
	
?>
