# phpMyAdmin MySQL-Dump
# version 2.4.0-rc2
# http://www.phpmyadmin.net/ (download page)
#
# Serveur: localhost
# Gnr le : Jeudi 25 Novembre 2004  15:04
# Version du serveur: 3.23.49
# Version de PHP: 4.1.2
# Base de donnes: `castor_test`
# --------------------------------------------------------

#
# Structure de la table `cms_article`
#

DROP TABLE IF EXISTS cms_article;
CREATE TABLE cms_article (
  no int(11) NOT NULL auto_increment,
  title varchar(255) NOT NULL default 'titre',
  subtitle varchar(255) default NULL,
  text text,
  UNIQUE KEY no (no),
  FULLTEXT KEY text (text)
) TYPE=MyISAM;

#
# Contenu de la table `cms_article`
#

# --------------------------------------------------------

#
# Structure de la table `cms_document`
#

DROP TABLE IF EXISTS cms_document;
CREATE TABLE cms_document (
  no int(10) unsigned NOT NULL auto_increment,
  document_type int(10) unsigned NOT NULL default '0',
  author int(10) unsigned NOT NULL default '0',
  title tinytext,
  creation_date timestamp(14) NOT NULL,
  lang tinytext,
  section tinytext NOT NULL,
  url tinytext NOT NULL,
  min_rights smallint(6) NOT NULL default '0',
  max_rights smallint(6) NOT NULL default '1000',
  PRIMARY KEY  (no),
  KEY Document_FKIndex1 (author),
  KEY Document_FKIndex2 (document_type)
) TYPE=MyISAM;

#
# Contenu de la table `cms_document`
#

# --------------------------------------------------------

#
# Structure de la table `cms_document_type`
#

DROP TABLE IF EXISTS cms_document_type;
CREATE TABLE cms_document_type (
  no int(10) unsigned NOT NULL auto_increment,
  sql_table tinytext NOT NULL,
  title tinytext NOT NULL,
  php_module tinytext NOT NULL,
  image tinytext NOT NULL,
  directory tinytext,
  event_insert tinytext,
  event_update tinytext NOT NULL,
  event_remove tinytext NOT NULL,
  PRIMARY KEY  (no)
) TYPE=MyISAM;

#
# Contenu de la table `cms_document_type`
#

INSERT INTO cms_document_type VALUES (1, 'cms_texte', 'Texte brut', 'cms_text', 'images/mime/text.png', '', '', '', '');
INSERT INTO cms_document_type VALUES (2, 'cms_image', 'Images', 'cms_image', 'images/mime/image.png', './cms_data/image', 'cms_evt_insert_image', 'cms_evt_update_image', 'cms_evt_remove_image');
INSERT INTO cms_document_type VALUES (3, 'cms_file', 'Fichier', 'cms_file', 'images/mime/file.png', './cms_data/file', 'cms_evt_insert_file', 'cms_evt_update_file', 'cms_evt_remove_file');
INSERT INTO cms_document_type VALUES (5, 'cms_article', 'Article', 'cms_article', 'images/cms/article.png', '', '', '', '');
# --------------------------------------------------------

#
# Structure de la table `cms_file`
#

DROP TABLE IF EXISTS cms_file;
CREATE TABLE cms_file (
  no int(11) NOT NULL auto_increment,
  mime tinytext NOT NULL,
  type tinytext NOT NULL,
  title tinytext NOT NULL,
  text text NOT NULL,
  size int(11) NOT NULL default '0',
  filename tinytext NOT NULL,
  realname tinytext NOT NULL,
  UNIQUE KEY no (no)
) TYPE=MyISAM;

#
# Contenu de la table `cms_file`
#

# --------------------------------------------------------

#
# Structure de la table `cms_image`
#

DROP TABLE IF EXISTS cms_image;
CREATE TABLE cms_image (
  no int(11) NOT NULL auto_increment,
  text tinytext NOT NULL,
  width int(11) NOT NULL default '0',
  height int(11) NOT NULL default '0',
  image tinytext NOT NULL,
  thumbnail tinytext NOT NULL,
  mime tinytext NOT NULL,
  UNIQUE KEY no (no)
) TYPE=MyISAM;

#
# Contenu de la table `cms_image`
#

# --------------------------------------------------------

#
# Structure de la table `cms_publication`
#

DROP TABLE IF EXISTS cms_publication;
CREATE TABLE cms_publication (
  no int(11) NOT NULL auto_increment,
  section tinytext NOT NULL,
  document_no int(11) NOT NULL default '0',
  version_no int(11) NOT NULL default '0',
  date timestamp(14) NOT NULL,
  UNIQUE KEY no (no)
) TYPE=MyISAM;

#
# Contenu de la table `cms_publication`
#

# --------------------------------------------------------

#
# Structure de la table `cms_role`
#

DROP TABLE IF EXISTS cms_role;
CREATE TABLE cms_role (
  no int(11) NOT NULL auto_increment,
  gid int(11) NOT NULL default '0',
  role varchar(40) NOT NULL default '',
  section varchar(40) NOT NULL default '',
  UNIQUE KEY no (no)
) TYPE=MyISAM;

#
# Contenu de la table `cms_role`
#

INSERT INTO cms_role VALUES (1, 1, 'write', '*');
INSERT INTO cms_role VALUES (2, 1, 'publish', '*');
INSERT INTO cms_role VALUES (3, 4, 'write', '*');
INSERT INTO cms_role VALUES (4, 5, 'write', '*');
INSERT INTO cms_role VALUES (5, 5, 'publish', '*');
# --------------------------------------------------------

#
# Structure de la table `cms_role_type`
#

DROP TABLE IF EXISTS cms_role_type;
CREATE TABLE cms_role_type (
  role varchar(40) NOT NULL default '',
  title varchar(100) NOT NULL default ''
) TYPE=MyISAM;

#
# Contenu de la table `cms_role_type`
#

INSERT INTO cms_role_type VALUES ('write', 'Rdacteur');
INSERT INTO cms_role_type VALUES ('publish', 'Publicateur');
# --------------------------------------------------------

#
# Structure de la table `cms_text`
#

DROP TABLE IF EXISTS cms_text;
CREATE TABLE cms_text (
  no int(11) NOT NULL auto_increment,
  text text NOT NULL,
  UNIQUE KEY no (no),
  FULLTEXT KEY text (text)
) TYPE=MyISAM;

#
# Contenu de la table `cms_text`
#

# --------------------------------------------------------

#
# Structure de la table `cms_version`
#

DROP TABLE IF EXISTS cms_version;
CREATE TABLE cms_version (
  no int(10) unsigned NOT NULL auto_increment,
  document int(10) unsigned NOT NULL default '0',
  version int(10) unsigned default NULL,
  date timestamp(14) NOT NULL,
  full_text text,
  data int(11) NOT NULL default '0',
  PRIMARY KEY  (no),
  KEY Texte_FKIndex1 (document),
  FULLTEXT KEY texte (full_text)
) TYPE=MyISAM;

#
# Contenu de la table `cms_version`
#

# --------------------------------------------------------

#
# Structure de la table `fw_menu`
#

DROP TABLE IF EXISTS fw_menu;
CREATE TABLE fw_menu (
  nomPage varchar(50) NOT NULL default '',
  libelle varchar(100) NOT NULL default '',
  url varchar(200) NOT NULL default '',
  droitMini int(11) NOT NULL default '0',
  droitMaxi int(11) NOT NULL default '1000',
  tri int(11) NOT NULL default '0',
  langue char(1) default NULL,
  nomPagePere varchar(50) default NULL,
  PRIMARY KEY  (nomPage)
) TYPE=MyISAM;

#
# Contenu de la table `fw_menu`
#

INSERT INTO fw_menu VALUES ('index', 'Accueil', '', 0, 1000, 1, 'F', NULL);
INSERT INTO fw_menu VALUES ('admin', 'Admin', '', 100, 1000, 100, 'F', '');
INSERT INTO fw_menu VALUES ('gest_mod', 'Modules', '', 1000, 1000, 1, 'F', 'admin');
INSERT INTO fw_menu VALUES ('gest_menus', 'Plan du site', '', 100, 1000, 3, 'F', 'contenu');
INSERT INTO fw_menu VALUES ('gest_staticpage', 'Pages statiques', '', 100, 1000, 2, 'F', 'contenu');
INSERT INTO fw_menu VALUES ('compte', 'Comptes', '', 100, 1000, 8, 'F', 'admin');
INSERT INTO fw_menu VALUES ('mediadb', 'MediaDB', '', 100, 1000, 60, 'F', 'contenu');
INSERT INTO fw_menu VALUES ('groupe', 'Groupes', '', 100, 1000, 0, 'F', 'admin');
INSERT INTO fw_menu VALUES ('maj_template', 'Mj. template', '', 1000, 1000, 0, 'F', 'admin');
INSERT INTO fw_menu VALUES ('generateur', 'Gnrateur', '', 1000, 1000, 0, 'F', 'admin');
INSERT INTO fw_menu VALUES ('contenu', 'Contenu', '', 100, 1000, 50, 'F', '');
INSERT INTO fw_menu VALUES ('cms_manager', 'CMS manager', 'cms/manager.html', 100, 1000, 10, 'F', 'contenu');
INSERT INTO fw_menu VALUES ('cms_search', 'Recherche', '', 0, 1000, 30, 'F', '');
INSERT INTO fw_menu VALUES ('cms_role', 'Rles CMS', '', 100, 1000, 50, 'F', 'contenu');
# --------------------------------------------------------

#
# Structure de la table `fw_modules`
#

DROP TABLE IF EXISTS fw_modules;
CREATE TABLE fw_modules (
  id varchar(40) NOT NULL default '',
  libelle varchar(200) default NULL,
  classe varchar(30) NOT NULL default '',
  id_page varchar(200) NOT NULL default '',
  tri int(11) NOT NULL default '0',
  droitMini int(11) NOT NULL default '0',
  droitMaxi int(11) NOT NULL default '999',
  zone varchar(200) NOT NULL default 'content',
  langue char(1) default NULL,
  showModule tinyint(4) NOT NULL default '1',
  package varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Contenu de la table `fw_modules`
#

INSERT INTO fw_modules VALUES ('modules_params', 'Gestion des paramtres des modules', 'wm_modconfig', 'modules_params', 50, 1000, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('header', 'Tte de page', 'wm_file', '%', 1, 0, 1000, 'header', 'F', 1, 'Affichage de contenu');
INSERT INTO fw_modules VALUES ('bottom', 'Pied de page', 'wm_file', '%', 100, 0, 1000, 'footer', 'F', 1, 'Affichage de contenu');
INSERT INTO fw_modules VALUES ('DEV_gestMod', 'Gestion des modules', 'wm_rs', 'gest_mod', 50, 1000, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('DEV_menu', 'Editer un item du menu', 'wm_rs', 'gest_menus', 49, 100, 1000, 'content', 'F', 1, 'Editeur de contenu');
INSERT INTO fw_modules VALUES ('submenu', 'Sous-menu de l\'application', 'wm_menu', '%', 60, 0, 1000, 'submenu', 'F', 1, 'Affichage de contenu');
INSERT INTO fw_modules VALUES ('GEST_staticpage', 'Editeur de page statique', 'wm_rs', 'gest_staticpage', 50, 100, 1000, 'content', 'F', 1, 'Editeur de contenu');
INSERT INTO fw_modules VALUES ('menu', 'Menu de l\'application', 'wm_menu', '%', 50, 0, 1000, 'menu', 'F', 1, 'Affichage de contenu');
INSERT INTO fw_modules VALUES ('staticpage', 'Affichage des pages statiques', 'wm_static', '%', 50, 0, 1000, 'content', 'F', 1, 'Affichage de contenu');
INSERT INTO fw_modules VALUES ('login', 'Boite de Login', 'wm_login', '%', 0, 0, 1000, 'login', 'F', 1, 'Authentification');
INSERT INTO fw_modules VALUES ('mod_save', 'Module de sauvegarde de modules', 'wm_modSave', 'gest_mod', 55, 1000, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('compte', 'gestion compte', 'wm_rs', 'compte', 50, 100, 1000, 'content', 'F', 1, 'Authentification');
INSERT INTO fw_modules VALUES ('editeur_menu', 'Editeur de menu', 'wm_tree', 'gest_menus', 51, 100, 1000, 'content', 'F', 1, 'Editeur de contenu');
INSERT INTO fw_modules VALUES ('groupe', 'Gestion des groupes', 'wm_rs', 'groupe', 50, 1000, 1000, 'content', 'F', 1, 'Authentification');
INSERT INTO fw_modules VALUES ('generateur', 'Gnrateur de module', 'wm_generateur', 'generateur', 50, 1000, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('maj_template', 'Mise  jour des templates d\'un module', 'wm_maj_template', 'maj_template', 50, 1000, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('error_document', 'error_document', 'wm_error_document', '%', 0, 0, 1000, 'content', 'F', 0, '_kernel');
INSERT INTO fw_modules VALUES ('cms_manager', 'cms manager', 'wm_cms_manager', 'cms_manager', 50, 100, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
INSERT INTO fw_modules VALUES ('cms_search', 'Recherche CMS', 'wm_cms_search', 'cms_search', 50, 0, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
INSERT INTO fw_modules VALUES ('cms_display', 'cms_display', 'wm_cms_display', '%', 50, 0, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
INSERT INTO fw_modules VALUES ('cms_display_obj', 'cms_display_obj', 'wm_cms_display_obj', 'cms_display_obj', 50, 0, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
INSERT INTO fw_modules VALUES ('cms_role', 'cms_role', 'wm_rs', 'cms_role', 50, 100, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
INSERT INTO fw_modules VALUES ('mediadb', 'MediaDB', 'wm_mediadb', 'mediadb,gest_staticpage', 30, 100, 1000, 'content', 'F', 1, 'Gestionnaire de contenu');
# --------------------------------------------------------

#
# Structure de la table `fw_modules_params`
#

DROP TABLE IF EXISTS fw_modules_params;
CREATE TABLE fw_modules_params (
  id varchar(50) NOT NULL default '',
  id_module varchar(50) NOT NULL default '',
  text text NOT NULL,
  ts timestamp(14) NOT NULL
) TYPE=MyISAM;

#
# Contenu de la table `fw_modules_params`
#

INSERT INTO fw_modules_params VALUES ('keyischar', 'modules_params', '1', 20041006182843);
INSERT INTO fw_modules_params VALUES ('sql', 'modules_params', 'select id, id_module,val,text from fw_modules_params where id_module=\'[[idmodule]]\'', 20041006182901);
INSERT INTO fw_modules_params VALUES ('Redirect', 'modules_params', 'gest_mod.html', 20041015110558);
INSERT INTO fw_modules_params VALUES ('template_list', 'DEV_menu', '--', 20041014130847);
INSERT INTO fw_modules_params VALUES ('template_detail', 'DEV_menu', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Dtail d\'un item du menu</h1>\n\n<!-- BEGIN: table -->\n<table class="datatable">\n<tbody class="datatable">\n<!-- BEGIN: row -->\n<tr>\n  <td class="tableheader">Nom de la page</td>\n  <td>{nomPage}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Titre de la page</td>\n  <td>{libelle}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">URL</td>\n  <td>{url}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Droits minimum</td>\n  <td>{droitMini}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Droits maximum</td>\n  <td>{droitMaxi}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Tri</td>\n  <td>{tri}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Langue</td>\n  <td>{langue}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Nom de la page pre</td>\n  <td>{nomPagePere}</td>\n</tr>\n<!-- END: row -->\n</tbody>\n</table>\n<!-- END: table -->\n\n<p class="centre">\n<a href="{PHP.page}.html?{PHP.modid}_modify={nomPage}">Modifier</a>\n- <a href="{PHP.page}.html?{PHP.modid}_delete={nomPage}" onClick="return confirm(\'Supprimer ?\');">Supprimer</a>\n- \n<a href="{PHP.page}.html">Retour</a></p>\n\n<!-- Fin Template :  -->\n<!-- END: main -->', 20041015102229);
INSERT INTO fw_modules_params VALUES ('template_form', 'DEV_menu', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Edition d\'un item du menu</h1>\n\n<form action="?{PHP.URL}" name="{PHP.modid}_formulaire" method="post" \n  enctype="multipart/form-data">\n{Type_form}\n\n\n<table class="datatable">\n<tbody class="datatable">\n\n<tr>\n\n  <td class="tableheader">Nom de la page : </td>\n  <td><input type="text" name="nomPage" value="{nomPage}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Titre de la page : </td>\n  <td><input type="text" name="libelle" value="{libelle}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">URL : </td>\n  <td><input type="text" name="url" value="{url}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Droits minimum : </td>\n  <td><input type="text" name="droitMini" value="{droitMini}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Droits maximum : </td>\n  <td><input type="text" name="droitMaxi" value="{droitMaxi}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Tri : </td>\n  <td><input type="text" name="tri" value="{tri}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Langue : </td>\n  <td><input type="text" name="langue" value="{langue}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Nom de la page pre : </td>\n  <td><select name="nomPagePere">\n    <option value="">--- aucun ---</option>\n<!-- BEGIN: nomPagePereoptions -->\n    <option value="{key}">{val}</option>\n<!-- END: nomPagePereoptions -->\n  </select>\n<script type="text/javascript">\nvar option_nomPagePere = document.forms["{PHP.modid}_formulaire"].nomPagePere.options;\nfor (i = 0; i < option_nomPagePere.length; i++)\n  if (option_nomPagePere[i].value==\'{nomPagePere_id}\') option_nomPagePere[i].selected=true;\n</script>\n  </td>\n\n</tr>\n\n\n</tbody>\n</table>\n<p class="centre">\n  <input type=submit value="Valider" name="{PHP.modid}_envoyer" />\n  - <a href="{PHP.page}.html">Annuler</a>\n</p>\n\n</form>\n<!-- END: main -->', 20041014131018);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'DEV_gestMod', '1', 20040318112123);
INSERT INTO fw_modules_params VALUES ('itemppage', 'DEV_menu', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'DEV_menu', '1', 20031010181745);
INSERT INTO fw_modules_params VALUES ('keyistext', 'DEV_menu', '1', 20040317170119);
INSERT INTO fw_modules_params VALUES ('field_list', 'DEV_menu', 'nomPage:1:text:rs_field_text_handler\r\nlibelle:1:text:rs_field_text_handler\r\nurl:1:text:rs_field_text_handler\r\ndroitMini:1:text:rs_field_text_handler\r\ndroitMaxi:1:text:rs_field_text_handler\r\ntri:1:text:rs_field_text_handler\r\nlangue:1:text:rs_field_text_handler\r\nnomPagePere:1:lookupsql:select nomPage, nomPage from fw_menu', 20040618143249);
INSERT INTO fw_modules_params VALUES ('css', 'DEV_gestMod', 'inc/modules.css', 20040617150531);
INSERT INTO fw_modules_params VALUES ('sql', 'DEV_menu', 'SELECT  nomPage, libelle, url, droitMini, droitMaxi, tri, langue, nomPagePere FROM fw_menu', 20040322142454);
INSERT INTO fw_modules_params VALUES ('table', 'DEV_menu', 'fw_menu', 20031010181745);
INSERT INTO fw_modules_params VALUES ('libelle', 'DEV_menu', 'libelle', 20031010181745);
INSERT INTO fw_modules_params VALUES ('keyfield', 'DEV_menu', 'nomPage', 20040318100447);
INSERT INTO fw_modules_params VALUES ('admin', 'DEV_menu', '1', 20031010181745);
INSERT INTO fw_modules_params VALUES ('file', 'bottom', './themes/GLOBALS[theme_css]/inc/bottom.inc', 20040922145757);
INSERT INTO fw_modules_params VALUES ('persistVars', 'DEV_menu', '', 20031010181745);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'DEV_menu', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'DEV_menu', '0', 20040318093445);
INSERT INTO fw_modules_params VALUES ('orderBy', 'DEV_menu', 'nomPagePere', 20040322142529);
INSERT INTO fw_modules_params VALUES ('template_export', 'DEV_menu', '--', 20041014130847);
INSERT INTO fw_modules_params VALUES ('paramsSQL', 'mod_save', 'SELECT id, text FROM fw_modules_params WHERE id_module = \'REQUEST[mod_save_save]\'', 20040324173135);
INSERT INTO fw_modules_params VALUES ('template_load', 'mod_save', '<!-- BEGIN: main -->\r\n<div class="contenu">\r\n<FORM name="mod_save_formulaire" method="post" action="./?page={PHP.page}" enctype="multipart/form-data">\r\n<p>Charger\r\n<input type="file" name="mod_save_load">\r\n  Id : \r\n  <input type="text" name="mod_id">\r\n  (si vide utilise celui du fichier)\r\n  <input type="hidden" name="MAX_FILE_SIZE" value="1000000"><input type="submit" name="Submit" value="GO">\r\n</p>\r\n</FORM>\r\n</div>\r\n<!-- END: main -->', 20040924163736);
INSERT INTO fw_modules_params VALUES ('log_description', 'mod_save', '', 20040324173135);
INSERT INTO fw_modules_params VALUES ('modSQL', 'mod_save', 'SELECT * FROM fw_modules WHERE id = \'REQUEST[mod_save_save]\'', 20040324173135);
INSERT INTO fw_modules_params VALUES ('file', 'header', './themes/GLOBALS[theme_css]/inc/header.inc', 20040922144957);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'DEV_menu', '100', 20040322085416);
INSERT INTO fw_modules_params VALUES ('droitModif', 'DEV_menu', '100', 20040322085431);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'DEV_menu', '100', 20040322085437);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'DEV_menu', '100', 20040322085444);
INSERT INTO fw_modules_params VALUES ('log_description', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitExport', 'DEV_menu', '100', 20040322085450);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('sql', 'compte', 'SELECT  noUtilisateur, login, pass, user_right, utilisateur.noGroupe, societe, nom, prenom, email FROM utilisateur LEFT  JOIN groupe USING ( noGroupe )  WHERE group_right <= SESSION[auth_right]', 20041014130639);
INSERT INTO fw_modules_params VALUES ('orderBy', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('table', 'compte', 'utilisateur', 20040324155817);
INSERT INTO fw_modules_params VALUES ('keyfield', 'compte', 'noUtilisateur', 20040324160131);
INSERT INTO fw_modules_params VALUES ('template_list', 'compte', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Gestion des comptes</h1>\n\n<!-- BEGIN: table -->\n<table class="datatable">\n<tbody class="datatable">\n<tr class="tableheader">\n  <th>Identifiant</th>\n  <th>Groupe</th>\n  <th>Nom</th>\n  <th>Prnom</th>\n  <th>Socit</th>\n  <th>Actions</th>\n</tr>\n<!-- BEGIN: row --><tr>\n  <td>\n    <a href="{PHP.page}.html?{PHP.modid}_detail={noUtilisateur}">\n    <img src="images/mini_add.gif" alt="(+)" /> {login}</a>\n  </td>  <td>\n    {noGroupe}\n  </td>\n  <td>\n    {nom}\n  </td>\n  <td>\n    {prenom}\n  </td>\n  <td>\n    {societe}\n  </td>\n  <td class="centre">\n    <!-- BEGIN: lien_modif --><a href="{PHP.page}.html?{PHP.modid}_modify={noUtilisateur}">\n    <img src="images/mini_edit.png" alt="Modifier" /></a><!-- END: lien_modif -->\n    <!-- BEGIN: lien_suppr --><a href="{PHP.page}.html?{PHP.modid}_delete={noUtilisateur}"\n    onclick="return confirm(\'Supprimer ?\');"><img src="images/mini_remove.gif" alt="Supprimer" /></a><!-- END: lien_suppr -->\n  </td>\n</tr>\n<!-- END: row -->\n</tbody>\n</table>\n<!-- END: table --><!-- BEGIN: norow -->\n<p class="centre">Aucun enregistrement</p>\n<!-- END: norow -->\n<!-- BEGIN: lien_ajout -->\n<p class="centre">\n  <a href="{PHP.page}.html?{PHP.modid}_new=y"><img src="images/mini_add.gif" alt="(+)" /> Ajouter</a>\n</p><!-- END: lien_ajout -->\n\n<!-- END: main -->', 20041015090744);
INSERT INTO fw_modules_params VALUES ('field_desc', 'compte', 'label[noUtilisateur]="Numro"\r\nhide[noUtilisateur]\r\n\r\nlabel[login]="Identifiant"\r\nformat[login]=text\r\nlink[login]\r\n\r\nlabel[pass]="Mot de passe"\r\nformat[pass]=text\r\nhide_in_list[pass]\r\n\r\nlabel[noGroupe]="Groupe"\r\nformat[noGroupe]=unsigned_integer\r\n\r\nlabel[societe]="Socit"\r\nformat[societe]=text?\r\n\r\nlabel[nom]="Nom"\r\nformat[nom]=text\r\n\r\nlabel[prenom]="Prnom"\r\nformat[prenom]=text\r\n\r\nlabel[email]="Courriel"\r\nformat[email]=email\r\nhide_in_list[email]', 20041011165124);
INSERT INTO fw_modules_params VALUES ('template_export', 'compte', '--', 20041012101415);
INSERT INTO fw_modules_params VALUES ('template_detail', 'compte', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Dtails d\'un compte</h1>\n\n<!-- BEGIN: table -->\n<table class="datatable">\n<tbody class="datatable">\n<!-- BEGIN: row -->\n<tr>\n  <td class="tableheader">Identifiant</td>\n  <td>{login}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Mot de passe</td>\n  <td>{pass}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Groupe</td>\n  <td>{noGroupe}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Nom</td>\n  <td>{nom}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Prnom</td>\n  <td>{prenom}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Socit</td>\n  <td>{societe}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Courriel</td>\n  <td>{email}</td>\n</tr>\n<!-- END: row -->\n</tbody>\n</table>\n<!-- END: table -->\n\n<p class="centre">\n<a href="{PHP.page}.html?{PHP.modid}_modify={noUtilisateur}">Modifier</a>\n- <a href="{PHP.page}.html?{PHP.modid}_delete={noUtilisateur}" onClick="return confirm(\'Supprimer ?\');">Supprimer</a>\n- \n<a href="{PHP.page}.html">Retour</a></p>\n\n<!-- Fin Template :  -->\n<!-- END: main -->', 20041015102152);
INSERT INTO fw_modules_params VALUES ('template_form', 'compte', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Edition d\'un compte</h1>\n\n<form action="?{PHP.URL}" name="{PHP.modid}_formulaire" method="post" \n  enctype="multipart/form-data">\n{Type_form}\n\n\n<table class="datatable">\n<tbody class="datatable">\n\n<tr>\n\n  <td class="tableheader">Identifiant : </td>\n  <td><input type="text" name="login" value="{login}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Mot de passe : </td>\n  <td><input type="text" name="pass" value="{pass}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Groupe : </td>\n  <td><select name="noGroupe">\n    <option value="">--- aucun ---</option>\n<!-- BEGIN: noGroupeoptions -->\n    <option value="{key}">{val}</option>\n<!-- END: noGroupeoptions -->\n  </select>\n<script type="text/javascript">\nvar option_noGroupe = document.forms["{PHP.modid}_formulaire"].noGroupe.options;\nfor (i = 0; i < option_noGroupe.length; i++)\n  if (option_noGroupe[i].value==\'{noGroupe_id}\') option_noGroupe[i].selected=true;\n</script>\n  </td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Nom : </td>\n  <td><input type="text" name="nom" value="{nom}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Prnom : </td>\n  <td><input type="text" name="prenom" value="{prenom}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Socit : </td>\n  <td><input type="text" name="societe" value="{societe}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Courriel : </td>\n  <td><input type="text" name="email" value="{email}" /></td>\n\n</tr>\n\n\n</tbody>\n</table>\n<p class="centre">\n  <input type=submit value="Valider" name="{PHP.modid}_envoyer" />\n  - <a href="{PHP.page}.html">Annuler</a>\n</p>\n\n</form>\n<!-- END: main -->', 20041015085601);
INSERT INTO fw_modules_params VALUES ('itemppage', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'compte', '1', 20040324155734);
INSERT INTO fw_modules_params VALUES ('field_list', 'compte', 'login:1:text:rs_field_text_handler\r\npass:1:text:rs_field_text_handler\r\nnoGroupe:1:lookupsql:SELECT noGroupe,libelle FROM groupe WHERE group_right<=SESSION[auth_right]\r\nnom:1:text:rs_field_text_handler\r\nprenom:1:text:rs_field_text_handler\r\nsociete:1:text:rs_field_text_handler\r\nnoUtilisateur:0:text:rs_field_text_handler\r\nemail:1:text:rs_field_text_handler', 20041014112106);
INSERT INTO fw_modules_params VALUES ('admin', 'compte', '1', 20040324155817);
INSERT INTO fw_modules_params VALUES ('persistVars', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitModif', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('droitExport', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('log_description', 'menu', '', 20040323090939);
INSERT INTO fw_modules_params VALUES ('sql_hierarchie', 'editeur_menu', 'select nomPage ,libelle,nomPagePere,droitMini, droitMaxi, tri, langue  from fw_menu where 1', 20040921164804);
INSERT INTO fw_modules_params VALUES ('log_description', 'login', '', 20040323085618);
INSERT INTO fw_modules_params VALUES ('log_description', 'DEV_menu', '', 20040323090154);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'DEV_gestMod', 'removeModParams', 20040324165548);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'compte', '0', 20040324155734);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'compte', '', 20041011100926);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'compte', '', 20040324155734);
INSERT INTO fw_modules_params VALUES ('flags', 'submenu', '0', 20040921101309);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'DEV_menu', '', 20040322141349);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('log_description', 'GEST_staticpage', '', 20040322161821);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('log_description', 'DEV_gestMod', '', 20040324164644);
INSERT INTO fw_modules_params VALUES ('email_field', 'login', 'email', 20040318113841);
INSERT INTO fw_modules_params VALUES ('login_field', 'login', 'login', 20040318113841);
INSERT INTO fw_modules_params VALUES ('password_field', 'login', 'pass', 20040318115550);
INSERT INTO fw_modules_params VALUES ('template_login', 'login', '<!-- BEGIN: main -->\r\n\r\n<FORM method="post" action="./{PHP.page}.html">\r\n<table><tr><td>\r\n  Identifiant :\r\n</td><td>\r\n  <input name="login_login" size="10" type="text" class="textfield" />\r\n</td></tr><tr><td>\r\n  Mot de passe :\r\n</td><td>\r\n  <input name="login_passwd" size="10" type="password" class="textfield" />\r\n</td></tr></table>\r\n  <p class="centre"><input type="submit" value="S\'identifier" /></p>\r\n</FORM>\r\n\r\n<p class="centre"><a href="identification.html?identification_passLose=yes">\r\nMot de passe oubli ?</a></p>\r\n<!-- END: main -->', 20041007161531);
INSERT INTO fw_modules_params VALUES ('template_title', 'DEV_gestMod', 'list="Ajout/Modification d\'un enregistrement"\r\nform="Edition d\'un enregistrement"\r\ndetail="Dtails d\'un enregistrement"\r\n', 20041015110539);
INSERT INTO fw_modules_params VALUES ('template_logged', 'login', '<!-- BEGIN: main -->\r\n\r\n<p class="logged">Bienvenue<br />\r\n<em>{PHP.auth_first_name} {PHP.auth_last_name}</em></p>\r\n\r\n<p><a href="./index.html?logout=yes">Fermer ma session</a></p>\r\n\r\n<!-- END: main -->', 20041007161531);
INSERT INTO fw_modules_params VALUES ('template_passLose', 'login', '<!-- BEGIN: main -->T\'as perdu ton mot de passe ????<!-- END: main -->', 20040322092731);
INSERT INTO fw_modules_params VALUES ('template_passLose_OK', 'login', 'Votre mot de passe vient de vous tre envoy  l\'adresse mail que vous nous avez communique.', 20040318113841);
INSERT INTO fw_modules_params VALUES ('template_passLose_failed', 'login', 'L\'envoi de votre mot de passe a chou.', 20040318113841);
INSERT INTO fw_modules_params VALUES ('template_mail', 'login', '<!-- BEGIN: main -->Votre accs : {login} / {pass}<!-- END: main -->', 20040318113841);
INSERT INTO fw_modules_params VALUES ('sujet_mail', 'login', 'Accs Site Kiwi Backup', 20040318115725);
INSERT INTO fw_modules_params VALUES ('zone_passLose', 'login', 'content', 20040318113841);
INSERT INTO fw_modules_params VALUES ('sqlGetPass', 'login', 'SELECT pass FROM table WHERE clause', 20040318113841);
INSERT INTO fw_modules_params VALUES ('first_name_field', 'login', 'prenom', 20040318115550);
INSERT INTO fw_modules_params VALUES ('last_name_field', 'login', 'nom', 20040318115550);
INSERT INTO fw_modules_params VALUES ('group_right_field', 'login', 'group_right', 20040318120034);
INSERT INTO fw_modules_params VALUES ('user_right_field', 'login', 'user_right', 20040318113841);
INSERT INTO fw_modules_params VALUES ('gid_field', 'login', 'noGroupe', 20040318115550);
INSERT INTO fw_modules_params VALUES ('uid_field', 'login', 'noUtilisateur', 20040318115550);
INSERT INTO fw_modules_params VALUES ('table_auth_group', 'login', 'groupe', 20040318115550);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'DEV_gestMod', '1000', 20040322085508);
INSERT INTO fw_modules_params VALUES ('flags', 'menu', '0', 20040921110424);
INSERT INTO fw_modules_params VALUES ('css', 'GEST_staticpage', '', 20040617153358);
INSERT INTO fw_modules_params VALUES ('css', 'compte', '', 20040617171452);
INSERT INTO fw_modules_params VALUES ('tablehierarchie', 'editeur_menu', 'fw_menu', 20040921164804);
INSERT INTO fw_modules_params VALUES ('log_description', 'editeur_menu', '', 20040921164804);
INSERT INTO fw_modules_params VALUES ('keyfield', 'editeur_menu', 'nomPage', 20040921164804);
INSERT INTO fw_modules_params VALUES ('libfield', 'editeur_menu', 'nomPage', 20040921164804);
INSERT INTO fw_modules_params VALUES ('parentkeyfield', 'editeur_menu', 'nomPagePere', 20040921164804);
INSERT INTO fw_modules_params VALUES ('template', 'submenu', '<!-- BEGIN: main -->\r\n<div  class="submenu" id="{module_id}_cat">\r\n<ul>\r\n<!-- BEGIN: row -->\r\n<li><a class="submenu{style_actif}" href="{url}" title="{libelle}">{libelle}</a></li>\r\n<!-- END: row -->\r\n</ul>\r\n</div>\r\n<!-- END: main -->', 20040923094240);
INSERT INTO fw_modules_params VALUES ('sql', 'submenu', 'select nomPage,libelle,url from fw_menu where droitMini <= GLOBALS[droit_user] AND droitMaxi >= GLOBALS[droit_user] \r\nand (langue=\'GLOBALS[lg]\' or langue is null or langue=\'\') AND ( (\'GLOBALS[pagePere]\'<>\'\' AND nomPagePere=\'GLOBALS[pagePere]\') or (nomPagePere = \'GLOBALS[page]\') ) order by tri\r\n', 20040322142747);
INSERT INTO fw_modules_params VALUES ('template', 'menu', '<!-- BEGIN: main -->\r\n<div class="{style}" id="{module_id}_cat" >\r\n<!-- BEGIN: row -->\r\n<a class="{style}{style_actif}" href="{url}" title="{libelle}">{libelle}</a>\r\n<!-- END: row -->        \r\n<!-- BEGIN: flags -->\r\n<a href="./?newlg=F"><img src="images/F.gif" alt="Version francaise" title="Version francaise" border="0" width="24" height="17" align="top" /></a> \r\n<a href="./?newlg=E"><img src="images/E.gif" alt="English version" title="English version" border="0" width="24" height="17" align="top" /></a>\r\n<!-- END: flags -->\r\n</div>\r\n<!-- END: main -->', 20040921134355);
INSERT INTO fw_modules_params VALUES ('zone', 'menu', 'header', 20040317172414);
INSERT INTO fw_modules_params VALUES ('css', 'DEV_menu', '', 20040618142727);
INSERT INTO fw_modules_params VALUES ('css', 'editeur_menu', 'inc/tree.css', 20040921164804);
INSERT INTO fw_modules_params VALUES ('imagepath', 'editeur_menu', 'images/treemenu2', 20040921164804);
INSERT INTO fw_modules_params VALUES ('sql', 'menu', 'select nomPage,libelle,url from fw_menu where droitMini <= GLOBALS[droit_user] AND droitMaxi >= GLOBALS[droit_user] \r\nand (langue=\'GLOBALS[lg]\' OR langue is null OR langue=\'\') AND (nomPagePere is null OR nomPagePere=\'\') order by tri\r\n', 20040322144006);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'GEST_staticpage', '1', 20040317170119);
INSERT INTO fw_modules_params VALUES ('droitExport', 'GEST_staticpage', '100', 20040322085559);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'GEST_staticpage', '0', 20040317170119);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'GEST_staticpage', '0', 20040317170119);
INSERT INTO fw_modules_params VALUES ('keyistext', 'GEST_staticpage', '1', 20040317170119);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'GEST_staticpage', '0', 20040317170119);
INSERT INTO fw_modules_params VALUES ('log_description', 'header', '', 20040419103454);
INSERT INTO fw_modules_params VALUES ('log_description', 'submenu', '', 20040420085646);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'GEST_staticpage', '100', 20040322085548);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'GEST_staticpage', '100', 20040322085528);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'GEST_staticpage', '100', 20040322085535);
INSERT INTO fw_modules_params VALUES ('droitModif', 'GEST_staticpage', '100', 20040322085541);
INSERT INTO fw_modules_params VALUES ('itemppage', 'GEST_staticpage', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'GEST_staticpage', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('field_list', 'GEST_staticpage', 'nomPage:1:text:rs_field_text_handler\r\ntitre:1:text:rs_field_text_handler\r\npagehtml:1:wysiwyg:rs_field_text_handler\r\nlangue:1:text:rs_field_text_handler\r\nmetaDesc:1:text:rs_field_text_handler\r\nmetaKeyword:1:text:rs_field_text_handler', 20041006154908);
INSERT INTO fw_modules_params VALUES ('admin', 'GEST_staticpage', '1', 20031010181745);
INSERT INTO fw_modules_params VALUES ('persistVars', 'GEST_staticpage', '', 20031010181745);
INSERT INTO fw_modules_params VALUES ('template_form', 'GEST_staticpage', '<!-- BEGIN: main -->\r\n<H1>Edition d\'une page statique</h1>\r\n\r\n<FORM NAME="{PHP.modid}_formulaire" METHOD="POST" \r\n  action="{PHP.page}.html">\r\n        {Type_form}\r\n        <table class="datatable">\r\n        <tbody class="datatable">\r\n            <tr>\r\n            	<td class="tableheader">Nom :</td>\r\n            	<td><INPUT TYPE="text" NAME="nomPage" VALUE="{nomPage}"></td>\r\n            </tr>\r\n            <tr>\r\n            	<td class="tableheader">Titre :</td>\r\n            	<td><INPUT TYPE="text" NAME="titre" VALUE="{titre}"></td>\r\n            </tr>\r\n            <tr>\r\n            	<td class="tableheader">Langue :</td>\r\n            	<td><INPUT TYPE="text" NAME="langue" VALUE="{langue}"></td>\r\n            </tr>\r\n            <tr>\r\n            	<td colspan="2">\r\n               	<TEXTAREA id="wysiwyg_pagehtml" class="wysiwyg" rows="20" cols="80" name="pagehtml">{pagehtml}</TEXTAREA>\r\n            	</td>\r\n            </tr>\r\n{PHP.imagedb_out}\r\n            <tr>\r\n            	<td class="tableheader">Description :</td>\r\n            	<td><TEXTAREA NAME="metaDesc" rows="1" cols="80">{metaDesc}</TEXTAREA></td>\r\n            </tr>\r\n            <tr>\r\n            	<td class="tableheader">Mots cls :</td>\r\n            	<td><TEXTAREA NAME="metaKeyword" rows="1" cols="80">{metaKeyword}</TEXTAREA></td>\r\n            </tr>\r\n\r\n        </tbody>\r\n        </table>\r\n\r\n        <p class="centre">\r\n        <INPUT type="submit" value="Valider" name="{PHP.modid}_envoyer" onClick="mySubmit()" />\r\n        - <a href="./?page={PHP.page}">Annuler</a>        \r\n        </p>\r\n</FORM>\r\n\r\n<!-- END: main -->', 20041006172109);
INSERT INTO fw_modules_params VALUES ('template_export', 'GEST_staticpage', '--', 20031010181745);
INSERT INTO fw_modules_params VALUES ('template_detail', 'GEST_staticpage', '<!-- BEGIN: main -->\r\n<TABLE class="datatable">\r\n<!-- BEGIN: row -->\r\n<TR>\r\n<TD class="tableheader">nomPage</td>\r\n<TD>{nomPage}</td>\r\n</tr>\r\n\r\n<TR>\r\n<TD class="tableheader">titre</td>\r\n<TD>{titre}</td>\r\n</tr>\r\n\r\n<TR>\r\n<TD class="tableheader">page</td>\r\n<TD>{pagehtml}</td>\r\n</tr>\r\n\r\n<TR>\r\n<TD class="tableheader">langue</td>\r\n<TD>{langue}</td>\r\n</tr>\r\n<!-- END: row -->\r\n</table>\r\n\r\n<p class="centre">\r\n<a href="{PHP.page}.html?{PHP.modid}_delete={nomPage}" onClick="return confirm(\'Supprimer ?\');">supprimer</a>\r\n- <a href="{PHP.page}.html?{PHP.modid}_modify={nomPage}">modifier</a>\r\n</p>\r\n\r\n<p class="centre"><a href="./{PHP.page}.html">retour</a></p>\r\n<!-- END: main -->\r\n', 20041012083359);
INSERT INTO fw_modules_params VALUES ('template_title', 'GEST_staticpage', 'list="Ajout/Modification d\'un enregistrement"\r\nform="Edition d\'un enregistrement"\r\ndetail="Dtails d\'un enregistrement"\r\n', 20041012083423);
INSERT INTO fw_modules_params VALUES ('linetemplate', 'editeur_menu', '<span class="libtree" style="display:inline">\r\n<TABLE class="tree">\r\n<TR class="tree">\r\n	<TD  class="treewhite" width=30px><img src="images/{langue}.gif"></td>\r\n	<TD  class="tree" width=300px>{libelle} ({lib})</td>\r\n	<TD class="treewhite"><img src="images/icones_modules/droit{droitMini}.png"><img src="images/icones_modules/droit{droitMaxi}.png">\r\n</td>\r\n	<TD class="tree"><a href="./?page=gest_menus&DEV_menu_new=y&nomPagePere={key}&idconference={PHP.idconference}" title="Add" alt="Add"><img src="images/mini_add.gif"/></a>\r\n    <a href="./?page=gest_menus&DEV_menu_modify={key}&nomPagePere={parentkey}" title="Modify" alt="Modify"><img src="images/mini_edit.gif"/></a>\r\n    <a href="./?page=gest_menus&DEV_menu_delete={key}" title="Delete" alt="Delete"><img src="images/mini_remove.gif"/></a>\r\n</td>\r\n</tr>\r\n</table>\r\n</span>', 20040921164804);
INSERT INTO fw_modules_params VALUES ('leaftemplate', 'editeur_menu', '', 20040921164804);
INSERT INTO fw_modules_params VALUES ('template', 'editeur_menu', '<H1>Plan du site</h1>\r\n<div>[tree]</div>', 20040921164804);
INSERT INTO fw_modules_params VALUES ('keyistext', 'editeur_menu', '1', 20040921164804);
INSERT INTO fw_modules_params VALUES ('orderBy', 'GEST_staticpage', '', 20031010181745);
INSERT INTO fw_modules_params VALUES ('table', 'GEST_staticpage', 'page', 20031010181745);
INSERT INTO fw_modules_params VALUES ('keyfield', 'GEST_staticpage', 'nomPage', 20031010181745);
INSERT INTO fw_modules_params VALUES ('template_list', 'GEST_staticpage', '<!-- BEGIN: main -->\r\n<h1>Edition de page statique</h1>\r\n\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<tr>\r\n  <th>Liste des pages</th>\r\n  <th>Supprimer</th>\r\n</tr>\r\n\r\n<!-- BEGIN: row -->\r\n<tr>\r\n  <td>\r\n    <img src="images/{langue}.gif" alt="{langue}" />\r\n<a href="./{PHP.page}.html?{PHP.modid}_modify={nomPage}&imagedb=choix">{titre}</a>\r\n    ({nomPage})\r\n  </td>\r\n  <TD class="centre">\r\n    <a href="./{PHP.page}.html?{PHP.modid}_delete={nomPage}" \r\n       onClick="return confirm(\'Etes-vous certain(e) de vouloir supprimer cette page ?\');">\r\n      <img src="images/mini_remove.gif" alt="Supprimer" />\r\n    </a>\r\n  </td>\r\n</tr>\r\n<!-- END: row -->\r\n\r\n<!-- BEGIN: norow -->\r\n<TR>\r\n  <TD>Aucune page</td>\r\n</tr>\r\n<!-- END: norow -->\r\n\r\n</tbody>\r\n</table>\r\n\r\n<!-- BEGIN: lien_ajout -->\r\n<p class="centre"><a href="./{PHP.page}.html?{PHP.modid}_new=y">(+) Ajouter</a></p>\r\n<!-- END: lien_ajout -->\r\n<!-- END: main -->\r\n', 20041012083358);
INSERT INTO fw_modules_params VALUES ('sql', 'GEST_staticpage', 'SELECT  nomPage, titre, pagehtml, langue, metaKeyword, metaDesc FROM page', 20040329151417);
INSERT INTO fw_modules_params VALUES ('admin', 'DEV_gestMod', '1', 20031010181745);
INSERT INTO fw_modules_params VALUES ('keyistext', 'DEV_gestMod', '1', 20031010181745);
INSERT INTO fw_modules_params VALUES ('sql', 'DEV_gestMod', 'SELECT  package,id, libelle, classe, id_page, tri, droitMini, droitMaxi, zone, langue\r\n\r\nFROM fw_modules\r\n\r\nWHERE showModule=1\r\n\r\nORDER BY package ASC, libelle ASC', 20041007165548);
INSERT INTO fw_modules_params VALUES ('table', 'DEV_gestMod', 'fw_modules', 20031010181745);
INSERT INTO fw_modules_params VALUES ('keyfield', 'DEV_gestMod', 'id', 20031010181745);
INSERT INTO fw_modules_params VALUES ('template_list', 'DEV_gestMod', '<!-- BEGIN: main -->\r\n<!-- BEGIN: table -->\r\n<div>\r\n<!-- BEGIN: row -->\r\n\r\n<!-- BEGIN: entete -->\r\n</div>\r\n<h2>\r\n  <A HREF="#" onclick="return switchDiv(\'pkg_{package}\');">\r\n    <IMG SRC="images/icones_modules/charger_modules.png" alt="{package}">\r\n    {package}\r\n  </A>\r\n</h2>\r\n<div id=\'pkg_{package}\' style="display:none;">\r\n<!-- END: entete -->\r\n\r\n<table class="moduletable">\r\n<tbody class="moduletable">\r\n    <tr>\r\n      <th colspan="2" >\r\n        <a href="./modules_params.html?idmodule={id}">{libelle}</a>\r\n      </td>\r\n    </tr>\r\n    <tr>\r\n      <td>\r\n<img alt="Droits minimum = {droitMini}" src="images/icones_modules/droit{droitMini}.png" />\r\n<img alt="Droits maximum = {droitMaxi}" src="images/icones_modules/droit{droitMaxi}.png" />\r\n<img src="images/{langue}.gif">        \r\n      </td>\r\n      <td class="moduletable_droite">\r\n        <img alt="{classe}" src="modules/{classe}/icon.png"><br />\r\n        {classe}<br />\r\n        {id}\r\n      </td>\r\n    </tr>\r\n    <tr>\r\n      <td>Pages :</td>\r\n      <td>{id_page}</td>\r\n    <tr>\r\n      <td class="tablemodule_bottom" colspan="2">\r\n	  <a onclick="return confirm(\'Etes-vous certain de vouloir supprimer le module {libelle} ?\');" href="{PHP.page}.html?DEV_gestMod_delete={id}">suppr</a> \r\n        - <a href="{PHP.page}.html?mod_save_save={id}">export</a>\r\n        </td>\r\n    </tr>\r\n</tbody>\r\n</table>\r\n<!-- END: row -->\r\n</div>\r\n<!-- END: table -->\r\n\r\n<!-- BEGIN: norow -->\r\n<p class="centre">Aucun module pour l\'instant</p>\r\n<!-- END: norow -->\r\n\r\n<p><A href="./?page=gest_mod&DEV_gestMod_new=y">(+) AJOUTER</a></p>\r\n<!-- END: main -->', 20041015143557);
INSERT INTO fw_modules_params VALUES ('droitModif', 'DEV_gestMod', '1000', 20040322085609);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'DEV_gestMod', '1000', 20040322085614);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'DEV_gestMod', '1000', 20040322085621);
INSERT INTO fw_modules_params VALUES ('persistVars', 'DEV_gestMod', '', 20031010181745);
INSERT INTO fw_modules_params VALUES ('droitExport', 'DEV_gestMod', '1000', 20040322085629);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'DEV_gestMod', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'DEV_gestMod', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'DEV_gestMod', '1000', 20040322085638);
INSERT INTO fw_modules_params VALUES ('table_auth', 'login', 'utilisateur', 20040318115550);
INSERT INTO fw_modules_params VALUES ('itemppage', 'DEV_gestMod', '0', 20031010181745);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'DEV_gestMod', '1', 20040617141359);
INSERT INTO fw_modules_params VALUES ('field_list', 'DEV_gestMod', 'id:1:text:rs_field_text_handler\r\nlibelle:1:text:rs_field_text_handler\r\nclasse:1:lookupmods:./modules/\r\nid_page:1:text:rs_field_text_handler\r\ntri:1:text:rs_field_text_handler\r\ndroitMini:1:text:rs_field_text_handler\r\ndroitMaxi:1:text:rs_field_text_handler\r\nzone:1:text:rs_field_text_handler\r\nlangue:1:text:rs_field_text_handler\r\npackage:1:text:rs_field_text_handler', 20041015110539);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'DEV_menu', '1', 20040204203841);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'DEV_menu', '0', 20040318093445);
INSERT INTO fw_modules_params VALUES ('template_form', 'DEV_gestMod', '<!-- BEGIN: main -->\r\n<h1>Ajout / Modification d\'un module</h1>\r\n\r\n<FORM \r\n  action="?{PHP.URL}" name="{PHP.modid}_formulaire" method="post" \r\n  enctype="multipart/form-data">\r\n\r\n{Type_form}\r\n\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<tr>\r\n	<td class="tableheader">Classe : </td>\r\n	<td><SELECT NAME="classe">\r\n<!-- BEGIN: classeoptions -->\r\n		<OPTION value="{key}">{val}</option>\r\n<!-- END: classeoptions -->\r\n		</select>\r\n	</td>\r\n</tr>\r\n<SCRIPT>\r\nfor (i = 0; i < document.forms["{PHP.modid}_formulaire"].classe.options.length; i++) {\r\n	 if (document.forms["{PHP.modid}_formulaire"].classe.options[i].value==\'{classe}\')\r\n		 document.forms["{PHP.modid}_formulaire"].classe.options[i].selected=true;\r\n}\r\n</script>\r\n<tr>\r\n	<td class="tableheader">Identifiant : </td>\r\n	<td><INPUT TYPE="text" NAME="id" VALUE="{id}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Libell : </td>\r\n	<td><INPUT TYPE="text" NAME="libelle" VALUE="{libelle}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Page(s) : </td>\r\n	<td><INPUT TYPE="text" NAME="id_page" VALUE="{id_page}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Tri : </td>\r\n	<td><INPUT TYPE="text" NAME="tri" VALUE="{tri}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Droits mini : </td>\r\n	<td><INPUT TYPE="text" NAME="droitMini" VALUE="{droitMini}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Droits maxi : </td>\r\n	<td><INPUT TYPE="text" NAME="droitMaxi" VALUE="{droitMaxi}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Zone : </td>\r\n	<td><INPUT TYPE="text" NAME="zone" VALUE="{zone}"></td>\r\n</tr><tr>\r\n	<td class="tableheader">Langue : </td>\r\n	<td><select name="langue">\r\n<option value="F" selected="selected">F</option>\r\n<option value="D">D</option>\r\n</select>\r\n<SCRIPT>\r\nfor (i = 0; i < document.forms["{PHP.modid}_formulaire"].langue.options.length; i++) {\r\n	 if (document.forms["{PHP.modid}_formulaire"].langue.options[i].value==\'{langue}\')\r\n		 document.forms["{PHP.modid}_formulaire"].langue.options[i].selected=true;\r\n}\r\n</script>\r\n</td>\r\n</tr>\r\n\r\n</tbody>\r\n</table>\r\n\r\n<p class="centre"><input type=submit value="Valider" name="{PHP.modid}_envoyer" /></p>\r\n</FORM>\r\n<!-- END: main -->', 20041015140148);
INSERT INTO fw_modules_params VALUES ('template_detail', 'DEV_gestMod', '--', 20031010181745);
INSERT INTO fw_modules_params VALUES ('template_export', 'DEV_gestMod', '--', 20031010181745);
INSERT INTO fw_modules_params VALUES ('orderBy', 'DEV_gestMod', '', 20040617141424);
INSERT INTO fw_modules_params VALUES ('pagetable', 'staticpage', 'page', 20040921171659);
INSERT INTO fw_modules_params VALUES ('namefield', 'staticpage', 'nomPage', 20040921171659);
INSERT INTO fw_modules_params VALUES ('pagefield', 'staticpage', 'pagehtml', 20040921171659);
INSERT INTO fw_modules_params VALUES ('titlefield', 'staticpage', 'titre', 20040921171659);
INSERT INTO fw_modules_params VALUES ('field_desc', 'DEV_menu', 'label[nomPage]="Nom de la page"\r\nformat[nomPage]=text\r\nlink[nomPage]\r\n\r\nlabel[libelle]="Titre de la page"\r\nformat[libelle]=text\r\n\r\nlabel[url]="URL"\r\nformat[url]=text?\r\n\r\nlabel[droitMini]="Droits minimum"\r\ndefault[droitMini]="0"\r\nformat[droitMini]=unsigned_integer\r\n\r\nlabel[droitMaxi]="Droits maximum"\r\ndefault[droitMaxi]="1000"\r\nformat[droitMaxi]=unsigned_integer\r\n\r\nlabel[tri]="Tri"\r\nformat[tri]=unsigned_integer\r\ndefault[tri]="0"\r\n\r\nlabel[langue]="Langue"\r\ndefault[langue]="F"\r\nformat[langue]=text\r\n\r\nlabel[nomPagePere]="Nom de la page pre"\r\nformat[nomPagePere]=text?', 20041011163255);
INSERT INTO fw_modules_params VALUES ('metaDescfield', 'staticpage', 'metaDesc', 20040921171659);
INSERT INTO fw_modules_params VALUES ('metaKeywordfield', 'staticpage', 'metaKeyword', 20040921171659);
INSERT INTO fw_modules_params VALUES ('afterCheckCallBack', 'login', 'clientAuthentification', 20040329180921);
INSERT INTO fw_modules_params VALUES ('log_description', 'bottom', '', 20040419103515);
INSERT INTO fw_modules_params VALUES ('template_options', 'compte', '', 20041015102153);
INSERT INTO fw_modules_params VALUES ('template_options', 'groupe', '', 20041015102157);
INSERT INTO fw_modules_params VALUES ('template_options', 'DEV_gestMod', '', 20041015110319);
INSERT INTO fw_modules_params VALUES ('template_options', 'DEV_menu', '', 20041015102229);
INSERT INTO fw_modules_params VALUES ('orderby', 'editeur_menu', 'tri', 20040921164804);
INSERT INTO fw_modules_params VALUES ('field_desc', 'DEV_gestMod', 'label[id]="Identifiant"\r\nformat[id]=text\r\n\r\nlabel[libelle]="Libell"\r\nformat[libelle]=text\r\nlink[libelle]\r\n\r\nlabel[classe]="Classe"\r\nformat[classe]=text\r\n\r\nlabel[id_page]="Pages"\r\nformat[id_page]=text\r\n\r\nlabel[tri]="Tri"\r\nformat[tri]=unsigned_integer\r\ndefault[tri]="50"\r\n\r\nlabel[droitMini]="Droits mini"\r\nformat[droitMini]=unsigned_integer\r\ndefault[droitMini]="0"\r\n\r\nlabel[droitMaxi]="Droits maxi"\r\nformat[droitMaxi]=unsigned_integer\r\ndefault[droitMaxi]="1000"\r\n\r\nlabel[zone]="Zone"\r\nformat[zone]=text\r\ndefault[zone]="content"\r\n\r\nlabel[langue]="Langue"\r\ndefault[langue]="F"\r\nformat[langue]=text\r\n\r\n\r\nlabel[package]="Package"', 20041015110539);
INSERT INTO fw_modules_params VALUES ('template_title', 'compte', 'list="Gestion des comptes"\r\nform="Edition d\'un compte"\r\ndetail="Dtails d\'un compte"\r\n', 20041011161222);
INSERT INTO fw_modules_params VALUES ('template_title', 'groupe', 'list="Gestion des groupes d\'utilisateur"\r\nform="Edition d\'un groupe"\r\ndetail="Dtails d\'un groupe"\r\n', 20041011161934);
INSERT INTO fw_modules_params VALUES ('field_desc', 'groupe', 'label[noGroupe]="Numro de groupe"\r\nformat[noGroupe]=unsigned_integer\r\nhide[noGroupe]\r\n\r\nlabel[group_right]="Droits"\r\nformat[group_right]=unsigned_integer\r\n\r\nlabel[libelle]="Nom"\r\nformat[libelle]=text\r\nlink[libelle]\r\n\r\nlabel[descriptif]="Descriptif"\r\nformat[descriptif]=text?', 20041011165426);
INSERT INTO fw_modules_params VALUES ('template_title', 'DEV_menu', 'list="Ajout/Modification d\'un enregistrement"\r\ndetail="Dtail d\'un item du menu"\r\nform="Edition d\'un item du menu"\r\n', 20041011164533);
INSERT INTO fw_modules_params VALUES ('sql_listing', 'maj_template', 'SELECT id,libelle,package FROM fw_modules WHERE classe=\'wm_rs\' AND showModule=\'1\' ORDER BY package ASC, libelle ASC', 20041012164600);
INSERT INTO fw_modules_params VALUES ('keyistext', 'compte', '', 20040921165453);
INSERT INTO fw_modules_params VALUES ('field_desc', 'GEST_staticpage', 'label[nomPage]="Nom de la page"\r\nformat[nomPage]=text\r\n\r\nlabel[titre]="Titre de la page"\r\nformat[titre]=text\r\nlink[titre]\r\n\r\nlabel[langue]="Langue"\r\ndefault[langue]="F"', 20041012083423);
INSERT INTO fw_modules_params VALUES ('template_detail', 'groupe', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Dtails d\'un groupe</h1>\n\n<!-- BEGIN: table -->\n<table class="datatable">\n<tbody class="datatable">\n<!-- BEGIN: row -->\n<tr>\n  <td class="tableheader">Nom</td>\n  <td>{libelle}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Droits</td>\n  <td>{group_right}</td>\n</tr>\n\n<tr>\n  <td class="tableheader">Descriptif</td>\n  <td>{descriptif}</td>\n</tr>\n<!-- END: row -->\n</tbody>\n</table>\n<!-- END: table -->\n\n<p class="centre">\n<a href="{PHP.page}.html?{PHP.modid}_modify={noGroupe}">Modifier</a>\n- <a href="{PHP.page}.html?{PHP.modid}_delete={noGroupe}" onClick="return confirm(\'Supprimer ?\');">Supprimer</a>\n- \n<a href="{PHP.page}.html">Retour</a></p>\n\n<!-- Fin Template :  -->\n<!-- END: main -->', 20041015102157);
INSERT INTO fw_modules_params VALUES ('template_form', 'groupe', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Edition d\'un groupe</h1>\n\n<form action="?{PHP.URL}" name="{PHP.modid}_formulaire" method="post" \n  enctype="multipart/form-data">\n{Type_form}\n\n\n<table class="datatable">\n<tbody class="datatable">\n\n<tr>\n\n  <td class="tableheader">Nom : </td>\n  <td><input type="text" name="libelle" value="{libelle}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Droits : </td>\n  <td><input type="text" name="group_right" value="{group_right}" /></td>\n\n</tr>\n<tr>\n\n  <td class="tableheader">Descriptif : </td>\n  <td><input type="text" name="descriptif" value="{descriptif}" /></td>\n\n</tr>\n\n\n</tbody>\n</table>\n<p class="centre">\n  <input type=submit value="Valider" name="{PHP.modid}_envoyer" />\n  - <a href="{PHP.page}.html">Annuler</a>\n</p>\n\n</form>\n<!-- END: main -->', 20041015091013);
INSERT INTO fw_modules_params VALUES ('itemppage', 'groupe', '0', 20040921172510);
INSERT INTO fw_modules_params VALUES ('template_list', 'groupe', '<!-- BEGIN: main -->\n<!-- Template :  -->\n\n<h1>Gestion des groupes d\'utilisateur</h1>\n\n<!-- BEGIN: table -->\n<table class="datatable">\n<tbody class="datatable">\n<tr class="tableheader">\n  <th>Nom</th>\n  <th>Droits</th>\n  <th>Descriptif</th>\n  <th>Actions</th>\n</tr>\n<!-- BEGIN: row --><tr>\n  <td>\n    <a href="{PHP.page}.html?{PHP.modid}_detail={noGroupe}">\n    <img src="images/mini_add.gif" alt="(+)" /> {libelle}</a>\n  </td>  <td>\n    {group_right}\n  </td>\n  <td>\n    {descriptif}\n  </td>\n  <td class="centre">\n    <!-- BEGIN: lien_modif --><a href="{PHP.page}.html?{PHP.modid}_modify={noGroupe}">\n    <img src="images/mini_edit.png" alt="Modifier" /></a><!-- END: lien_modif -->\n    <!-- BEGIN: lien_suppr --><a href="{PHP.page}.html?{PHP.modid}_delete={noGroupe}"\n    onclick="return confirm(\'Supprimer ?\');"><img src="images/mini_remove.gif" alt="Supprimer" /></a><!-- END: lien_suppr -->\n  </td>\n</tr>\n<!-- END: row -->\n</tbody>\n</table>\n<!-- END: table --><!-- BEGIN: norow -->\n<p class="centre">Aucun enregistrement</p>\n<!-- END: norow -->\n<!-- BEGIN: lien_ajout -->\n<p class="centre">\n  <a href="{PHP.page}.html?{PHP.modid}_new=y"><img src="images/mini_add.gif" alt="(+)" /> Ajouter</a>\n</p><!-- END: lien_ajout -->\n\n<!-- END: main -->', 20041015091013);
INSERT INTO fw_modules_params VALUES ('orderBy', 'groupe', 'group_right', 20041011103829);
INSERT INTO fw_modules_params VALUES ('table', 'groupe', 'groupe', 20040921172510);
INSERT INTO fw_modules_params VALUES ('keyfield', 'groupe', 'noGroupe', 20040921172510);
INSERT INTO fw_modules_params VALUES ('admin', 'groupe', '1', 20040921172510);
INSERT INTO fw_modules_params VALUES ('sql', 'groupe', 'SELECT noGroupe, group_right, libelle, descriptif \r\nFROM groupe\r\nWHERE group_right<=SESSION[auth_right]', 20041014132842);
INSERT INTO fw_modules_params VALUES ('template_export', 'groupe', '--', 20041014132711);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'groupe', '0', 20040921172510);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'groupe', '1', 20040921172510);
INSERT INTO fw_modules_params VALUES ('field_list', 'groupe', 'noGroupe:0:text:rs_field_text_handler\r\nlibelle:1:text:rs_field_text_handler\r\ngroup_right:1:text:rs_field_text_handler\r\ndescriptif:1:text:rs_field_text_handler', 20041011084638);
INSERT INTO fw_modules_params VALUES ('persistVars', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('droitModif', 'groupe', '1000', 20041014133200);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'groupe', '1000', 20040921172510);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'groupe', '100', 20041014133053);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'groupe', '100', 20041014133053);
INSERT INTO fw_modules_params VALUES ('droitExport', 'groupe', '1000', 20040921172510);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'groupe', '0', 20040921172510);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'groupe', '0', 20040921172510);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'groupe', '0', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('css', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('log_description', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('keyistext', 'groupe', '', 20040921172510);
INSERT INTO fw_modules_params VALUES ('timeout', 'error_document', '30', 20041115175129);
INSERT INTO fw_modules_params VALUES ('template_401', 'error_document', './templates/F/error_document/401.xtpl', 20041115175129);
INSERT INTO fw_modules_params VALUES ('template_404', 'error_document', './templates/F/error_document/404.xtpl', 20041115175129);
INSERT INTO fw_modules_params VALUES ('table', 'cms_role', 'cms_role', 20041125140358);
INSERT INTO fw_modules_params VALUES ('keyfield', 'cms_role', 'no', 20041125140358);
INSERT INTO fw_modules_params VALUES ('admin', 'cms_role', '1', 20041125140358);
INSERT INTO fw_modules_params VALUES ('sql', 'cms_role', 'SELECT no, gid, role, section FROM cms_role', 20041125140359);
INSERT INTO fw_modules_params VALUES ('orderBy', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('keyistext', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('template_list', 'cms_role', '<!-- BEGIN: main -->\r\n<!-- Template liste : cms_role -->\r\n\r\n<h1>Gestion des rles</h1>\r\n\r\n<!-- BEGIN: table -->\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<tr class="tableheader">\r\n  <th>Groupe</th>\r\n  <th>Rle</th>\r\n  <th>Rubrique</th>\r\n  <th>Actions</th>\r\n</tr>\r\n<!-- BEGIN: row --><tr>\r\n  <td>\r\n    <a href="{PHP.page}.html?{PHP.modid}_detail={no}">\r\n    <img src="images/mini_add.gif" alt="(+)" /> {gid}</a>\r\n  </td>  <td>\r\n    {role}\r\n  </td>\r\n  <td>\r\n    {section}\r\n  </td>\r\n  <td class="centre">\r\n    <!-- BEGIN: lien_modif --><a href="{PHP.page}.html?{PHP.modid}_modify={no}">\r\n    <img src="images/mini_edit.png" alt="Modifier" /></a><!-- END: lien_modif -->\r\n    <!-- BEGIN: lien_suppr --><a href="{PHP.page}.html?{PHP.modid}_delete={no}"\r\n    onclick="return confirm(\'Supprimer ?\');"><img src="images/mini_remove.gif" alt="Supprimer" /></a><!-- END: lien_suppr -->\r\n  </td>\r\n</tr>\r\n<!-- END: row -->\r\n</tbody>\r\n</table>\r\n<!-- END: table --><!-- BEGIN: norow -->\r\n<p class="centre">Aucun enregistrement</p>\r\n<!-- END: norow -->\r\n<!-- BEGIN: lien_ajout -->\r\n<p class="centre">\r\n  <a href="{PHP.page}.html?{PHP.modid}_new=y"><img src="images/mini_add.gif" alt="(+)" /> Ajouter</a>\r\n</p><!-- END: lien_ajout -->\r\n\r\n<!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('template_export', 'cms_role', '<!-- BEGIN: main -->no;gid;role;section;\r\n<!-- BEGIN: table --><!-- BEGIN: row -->{no};{gid};{role};{section};\r\n<!-- END: row --><!-- END: table --><!-- BEGIN: norow -->Pas d\'enregistrement<!-- END: norow --><!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('template_detail', 'cms_role', '<!-- BEGIN: main -->\r\n<!-- Template detail : cms_role -->\r\n\r\n<h1>Dtails d\'un rle</h1>\r\n\r\n<!-- BEGIN: table -->\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<!-- BEGIN: row -->\r\n<tr>\r\n  <td class="tableheader">Groupe</td>\r\n  <td>{gid}</td>\r\n</tr>\r\n\r\n<tr>\r\n  <td class="tableheader">Rle</td>\r\n  <td>{role}</td>\r\n</tr>\r\n\r\n<tr>\r\n  <td class="tableheader">Rubrique</td>\r\n  <td>{section}</td>\r\n</tr>\r\n<!-- END: row -->\r\n</tbody>\r\n</table>\r\n<!-- END: table -->\r\n\r\n<p class="centre">\r\n<a href="{PHP.page}.html?{PHP.modid}_modify={no}">Modifier</a>\r\n- <a href="{PHP.page}.html?{PHP.modid}_delete={no}" onClick="return confirm(\'Supprimer ?\');">Supprimer</a>\r\n- \r\n<a href="{PHP.page}.html">Retour</a></p>\r\n\r\n<!-- Fin Template : cms_role -->\r\n<!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('template_form', 'cms_role', '<!-- BEGIN: main -->\r\n<!-- Template form : cms_role -->\r\n\r\n<h1>Ajout/Edition d\'un rle</h1>\r\n\r\n<FORM action="?{PHP.URL}" name="{PHP.modid}_formulaire" method="post" \r\n  enctype="multipart/form-data">\r\n{Type_form}\r\n\r\n\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n\r\n<tr>\r\n\r\n  <td class="tableheader">Groupe : </td>\r\n  <td><select name="gid">\r\n    <option value="">--- aucun ---</option>\r\n<!-- BEGIN: gidoptions -->\r\n    <option value="{key}">{val}</option>\r\n<!-- END: gidoptions -->\r\n  </select>\r\n<script type="text/javascript">\r\nvar option_gid = document.forms["{PHP.modid}_formulaire"].gid.options;\r\nfor (i = 0; i < option_gid.length; i++)\r\n  if (option_gid[i].value==\'{gid_id}\') option_gid[i].selected=true;\r\n</script>\r\n  </td>\r\n\r\n</tr>\r\n<tr>\r\n\r\n  <td class="tableheader">Rle : </td>\r\n  <td><select name="role">\r\n    <option value="">--- aucun ---</option>\r\n<!-- BEGIN: roleoptions -->\r\n    <option value="{key}">{val}</option>\r\n<!-- END: roleoptions -->\r\n  </select>\r\n<script type="text/javascript">\r\nvar option_role = document.forms["{PHP.modid}_formulaire"].role.options;\r\nfor (i = 0; i < option_role.length; i++)\r\n  if (option_role[i].value==\'{role_id}\') option_role[i].selected=true;\r\n</script>\r\n  </td>\r\n\r\n</tr>\r\n<tr>\r\n\r\n  <td class="tableheader">Rubrique : </td>\r\n  <td><input type="text" name="section" value="{section}" /></td>\r\n\r\n</tr>\r\n\r\n\r\n</tbody>\r\n</table>\r\n<p class="centre">\r\n  <input type=submit value="Valider" name="{PHP.modid}_envoyer" />\r\n  - <a href="{PHP.page}.html">Annuler</a>\r\n</p>\r\n\r\n</FORM>\r\n<!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('template_list_pdf', 'cms_role', '<!-- BEGIN: main -->\r\n<!-- Template liste : cms_role -->\r\n\r\n<h1>Gestion des rles</h1>\r\n\r\n<!-- BEGIN: table -->\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<tr class="tableheader">\r\n  <th>Groupe</th>\r\n  <th>Rle</th>\r\n  <th>Rubrique</th>\r\n  <th>Actions</th>\r\n</tr>\r\n<!-- BEGIN: row --><tr>\r\n  <td>\r\n    <a href="{PHP.page}.html?{PHP.modid}_detail={no}">\r\n    <img src="images/mini_add.gif" alt="(+)" /> {gid}</a>\r\n  </td>  <td>\r\n    {role}\r\n  </td>\r\n  <td>\r\n    {section}\r\n  </td>\r\n  <td class="centre">\r\n    <!-- BEGIN: lien_modif --><a href="{PHP.page}.html?{PHP.modid}_modify={no}">\r\n    <img src="images/mini_edit.png" alt="Modifier" /></a><!-- END: lien_modif -->\r\n    <!-- BEGIN: lien_suppr --><a href="{PHP.page}.html?{PHP.modid}_delete={no}"\r\n    onclick="return confirm(\'Supprimer ?\');"><img src="images/mini_remove.gif" alt="Supprimer" /></a><!-- END: lien_suppr -->\r\n  </td>\r\n</tr>\r\n<!-- END: row -->\r\n</tbody>\r\n</table>\r\n<!-- END: table --><!-- BEGIN: norow -->\r\n<p class="centre">Aucun enregistrement</p>\r\n<!-- END: norow -->\r\n<!-- BEGIN: lien_ajout -->\r\n<p class="centre">\r\n  <a href="{PHP.page}.html?{PHP.modid}_new=y"><img src="images/mini_add.gif" alt="(+)" /> Ajouter</a>\r\n</p><!-- END: lien_ajout -->\r\n\r\n<!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('template_detail_pdf', 'cms_role', '<!-- BEGIN: main -->\r\n<!-- Template detail : cms_role -->\r\n\r\n<h1>Dtails d\'un rle</h1>\r\n\r\n<!-- BEGIN: table -->\r\n<table class="datatable">\r\n<tbody class="datatable">\r\n<!-- BEGIN: row -->\r\n<tr>\r\n  <td class="tableheader">Groupe</td>\r\n  <td>{gid}</td>\r\n</tr>\r\n\r\n<tr>\r\n  <td class="tableheader">Rle</td>\r\n  <td>{role}</td>\r\n</tr>\r\n\r\n<tr>\r\n  <td class="tableheader">Rubrique</td>\r\n  <td>{section}</td>\r\n</tr>\r\n<!-- END: row -->\r\n</tbody>\r\n</table>\r\n<!-- END: table -->\r\n\r\n<p class="centre">\r\n<a href="{PHP.page}.html?{PHP.modid}_modify={no}">Modifier</a>\r\n- <a href="{PHP.page}.html?{PHP.modid}_delete={no}" onClick="return confirm(\'Supprimer ?\');">Supprimer</a>\r\n- \r\n<a href="{PHP.page}.html">Retour</a></p>\r\n\r\n<!-- Fin Template : cms_role -->\r\n<!-- END: main -->', 20041125142604);
INSERT INTO fw_modules_params VALUES ('itemppage', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('nbruptfield', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('parsenorow', 'cms_role', '1', 20041125140359);
INSERT INTO fw_modules_params VALUES ('field_list', 'cms_role', 'no:0:text:rs_field_text_handler\r\ngid:1:lookupsql:SELECT noGroupe,libelle FROM groupe\r\nrole:1:lookupsql:SELECT role,title FROM cms_role_type\r\nsection:1:text:rs_field_text_handler', 20041125140608);
INSERT INTO fw_modules_params VALUES ('field_desc', 'cms_role', 'hide[no]\r\n\r\nlink[gid]\r\nlabel[gid]="Groupe"\r\nformat[gid]=text\r\n\r\nlabel[role]="Rle"\r\nformat[role]=text?\r\n\r\nlabel[section]="Rubrique"\r\nformat[section]=text', 20041125140802);
INSERT INTO fw_modules_params VALUES ('template_title', 'cms_role', 'list="Gestion des rles"\r\nform="Ajout/Edition d\'un rle"\r\ndetail="Dtails d\'un rle"\r\n', 20041125140608);
INSERT INTO fw_modules_params VALUES ('template_options', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('mime_export', 'cms_role', 'text/csv', 20041125140359);
INSERT INTO fw_modules_params VALUES ('file_export', 'cms_role', 'document.csv', 20041125140359);
INSERT INTO fw_modules_params VALUES ('persistVars', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('droitModif', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('droitAjout', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('droitSuppr', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('droitDetail', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('droitExport', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('cond_expr', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('cond_droit', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('cond_affichage', 'cms_role', '0', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_on_new', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_after_delete', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_before_delete', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_before_post', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_after_post', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_on_row', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('evt_on_edit', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('css', 'cms_role', '', 20041125140359);
INSERT INTO fw_modules_params VALUES ('event_remove_doc', 'cms_manager', '', 20041125142542);
INSERT INTO fw_modules_params VALUES ('event_new_doc', 'cms_manager', '', 20041125142542);
# --------------------------------------------------------

#
# Structure de la table `groupe`
#

DROP TABLE IF EXISTS groupe;
CREATE TABLE groupe (
  noGroupe tinyint(3) unsigned NOT NULL auto_increment,
  group_right smallint(5) NOT NULL default '0',
  libelle varchar(20) NOT NULL default '',
  descriptif varchar(100) default NULL,
  PRIMARY KEY  (noGroupe)
) TYPE=MyISAM;

#
# Contenu de la table `groupe`
#

INSERT INTO groupe VALUES (1, 1000, 'Dveloppeurs', 'Dveloppeurs de l\'application');
INSERT INTO groupe VALUES (2, 100, 'Administrateurs', 'Administrateurs de l\'application');
INSERT INTO groupe VALUES (4, 100, 'Rdacteurs Castor', 'A le droit de crer et modifier des documents dans le CMS');
INSERT INTO groupe VALUES (5, 100, 'Publicateurs', 'A le droit de publier des documents dans le CMS (et des les diteurs)');
# --------------------------------------------------------

#
# Structure de la table `mediadb`
#

DROP TABLE IF EXISTS mediadb;
CREATE TABLE mediadb (
  no int(11) NOT NULL auto_increment,
  type tinytext NOT NULL,
  filename tinytext NOT NULL,
  KEY no (no)
) TYPE=MyISAM;

#
# Contenu de la table `mediadb`
#

# --------------------------------------------------------

#
# Structure de la table `page`
#

DROP TABLE IF EXISTS page;
CREATE TABLE page (
  nomPage varchar(20) NOT NULL default '',
  titre varchar(200) NOT NULL default '',
  metaDesc text NOT NULL,
  metaKeyword text NOT NULL,
  pagehtml text NOT NULL,
  langue varchar(5) default 'F',
  PRIMARY KEY  (nomPage)
) TYPE=MyISAM;

#
# Contenu de la table `page`
#

INSERT INTO page VALUES ('index', 'FrameWork par 2le', 'Voil une belle description', 'et, hop, les, mots, clefs', '\r\n<div class="contenu"><h1>2le libre son framework de dveloppement PHP</h1><p><b>Castor</b>, le framework de dveloppement web de la socit 2le, est maintenant disponible sous licence GPL. <b>2le</b> (acronyme signifiant Logiciels Libres pour l\'Entreprise) est une SSLL Mulhousienne spcialiste du PHP et des dveloppements web depuis maintenant 3 ans.</p><p><b>Castor</b> n\'est pas un gestionnaire de contenu (Content Management System en anglais), mais peut se rlver idal pour par exemple dvelopper son propre CMS. Cet environnement de dveloppement web s\'adresse surtout  un public de dveloppeurs, ou de personnes pour qui les langages du web (XHTML, CSS, PHP, Javascript, etc...) n\'ont aucun secret.<br /></p><p><span style="text-decoration: underline;"></span>A la base, Castor sait :</p><ul><li>crer, diter (en WYSIWYG) et afficher des pages statiques </li><li>manipuler et formater des informations issues d\'une base de donnes </li><li>administrer ses utilisateurs et visiteurs ainsi que les fonctions qu\'il leur est possible d\'utiliser </li><li>grer des hirarchies sous forme d\'arbres </li></ul><p>Ayez l\'ide... Castor la concrtise pour vous !</p></div>', 'F');
# --------------------------------------------------------

#
# Structure de la table `utilisateur`
#

DROP TABLE IF EXISTS utilisateur;
CREATE TABLE utilisateur (
  noUtilisateur smallint(5) unsigned NOT NULL auto_increment,
  login varchar(20) NOT NULL default '',
  pass varchar(20) NOT NULL default '',
  user_right int(11) NOT NULL default '0',
  noGroupe tinyint(3) unsigned default NULL,
  societe varchar(100) NOT NULL default '',
  nom varchar(20) NOT NULL default '',
  prenom varchar(20) default NULL,
  email varchar(50) default NULL,
  PRIMARY KEY  (noUtilisateur),
  UNIQUE KEY login (login)
) TYPE=MyISAM;

#
# Contenu de la table `utilisateur`
#

INSERT INTO utilisateur VALUES (1, 'admin', 'admin', 1000, 1, '2LE', 'Castor', 'Administrateur de', '2le@2le.net');

